if ( !window.console ) window.console = {};
if ( !window.console.log ) window.console.log = function(){};

window.CONFIG = {
    device: 'desktop'
};

new QWebChannel(qt.webChannelTransport,
    function(channel){
        window.plugin = channel.objects.plugin;
    }
);

var leftFrame;
var rightFrame;
var pageWidth,pageHeight;
var pageMode;
var loaded = 0;
var hiddenNum = 0;
var hiddens = {}

function setDocumentSize(w,h)
{
    pageWidth = w;
    pageHeight = h;
    console.log("pageSize",pageWidth,pageHeight);
}

function fitSingleToWidth() {
    var viewportWidth = window.innerWidth;
    var viewportHeight = window.innerHeight;

    rightFrame.width(viewportWidth);
    rightFrame.height(viewportHeight);
}

function fitSingleToHeight() {

}

function fitSingleToView() {
    var viewportWidth = window.innerWidth;
    var viewportHeight = window.innerHeight;

    rightFrame.width(viewportWidth);
    rightFrame.height(viewportHeight);
    console.log("fitSingleToView",viewportWidth,viewportHeight,pageMode);
}

function fitSingleToViewOnTop()
{
    var viewportWidth = window.innerWidth;
    var viewportHeight = window.innerHeight;

    rightFrame.width(viewportWidth);
    rightFrame.height(pageHeight * viewportWidth / pageWidth);
    rightFrame.css({top: 0, left: 0});
    $('body').css({display: 'block'});
}

function createHidden(hiddenUrl)
{
    var viewportHeight = window.innerHeight;
	var viewportWidth = window.innerWidth;
	
	var hiddenWidth = window.innerWidth;;
	var hiddenHeight = pageHeight * viewportWidth / pageWidth;
	var htmlCode = '<object type="application/x-shockwave-flash" wmode="transparent" id="Main" name="Main" align="middle" width="'+hiddenWidth+'px" height="'+hiddenHeight+'px">';
	htmlCode+='<param name="quality" value="high">'
	htmlCode+='<param name="movie" value="'+hiddenUrl+'" />';
    htmlCode+='<param name="wmode" value="transparent">'
	htmlCode+='<embed play="false" swliveconnect="true" id="Main" name="Main" src="'+hiddenUrl+'" allowNetworking="all" quality="high" width="'+hiddenWidth+'px" wmode="transparent" height="'+hiddenHeight+'px" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash"/>'
    htmlCode+='</object>';
	var hiddenId = document.createAttribute("id");
 	var hidden = document.createElement("div");

	hiddenId.value = "hidden_"+hiddenNum;
	hidden.style.width = "100%";
	hidden.style.height = "100%",
	hidden.style.position = "absolute";
	hidden.style.left = '0px';
	hidden.style.top = '0px';
	hidden.style.background = "transparent";
 	hidden.setAttributeNode(hiddenId);
	hidden.innerHTML = htmlCode;
 	document.body.appendChild(hidden);
	hiddens[hiddenNum] = hidden;
	hideOverlay(hiddenNum);
	hiddenNum++;
	fitSingleToViewOnTop();
	return hiddenUrl;
}

function showOverlay(overlayId)
{
	if(hiddens[overlayId]){
		var hidden = hiddens[overlayId];
		hidden.style.opacity = '1';
	}
	
}

function hideOverlay(overlayId)
{
	if(hiddens[overlayId]){
		var hidden = hiddens[overlayId];
		hidden.style.opacity = '0';
	}
	
}

function fitDoubleToWidth() {

}

function fitDoubleToHeight() {

}

function fitDoubleToView() {
    var scale;
    var viewportWidth = window.innerWidth;
    var viewportHeight = window.innerHeight;

    var widthRatio = (viewportWidth/2)/pageWidth;
    var heightRatio = viewportHeight/pageHeight;

    scale = Math.min(widthRatio, heightRatio);

    leftFrame.width(pageWidth*scale);
    leftFrame.height(pageHeight*scale);
    
    rightFrame.width(pageWidth*scale);
    rightFrame.height(pageHeight*scale);

    rightFrame.attr('scrolling', 'no');
    leftFrame.attr('scrolling', 'no');
    console.log("fitDoubleToView",pageWidth,pageHeight, scale);
}

function gotoPages(lPage,rPage)
{
    var fleft = document.getElementById('left').contentWindow.document;
    var fright = document.getElementById('right').contentWindow.document;
    document.getElementById('left').style.display = "block";
    setDoublePageMode();

    if(lPage!="-1"){
        fleft.embeds["plugin"].GotoFrame(lPage);
         document.getElementById('left').style.opacity= 1;
    }else{
        document.getElementById('left').style.opacity= 0;
    }
    
    if(rPage!="-1"){
        fright.embeds["plugin"].GotoFrame(rPage);
        document.getElementById('right').style.opacity= 1;
    }else{
        document.getElementById('right').style.opacity= 0;
    }
    
    console.log(lPage,rPage);
}

function gotoPage(page)
{
    var frame = document.getElementById('right').contentWindow.document;
    document.getElementById('left').style.display = "none";
    setSinglePageMode();

    if(page!="-1"){
        frame.embeds["plugin"].GotoFrame(page);
        document.getElementById('right').style.opacity= 1;
       
    }
}

function removeHiddens()
{
	for(var i in hiddens){
		var element = hiddens[i];
		element.remove();
	}
	hiddens = {};
}

function loadWebPage(page, mode)
{
    pageMode = mode;
    leftFrame = $("#left");
    rightFrame = $("#right");

    rightFrame.attr('src', page);
    console.log("Page",page,mode);
    setSinglePageMode();
}

function loadWebPages(pageLeft, pageRight, mode)
{
    pageMode = mode;
    leftFrame = $("#left");
    rightFrame = $("#right");

    leftFrame.attr('src', pageLeft);
    rightFrame.attr('src', pageRight);
    setDoublePageMode();
}

function setSinglePageMode(){
    var recalcFrameSize = function() {
        console.log('SinglePageMode frames size recalculation')
        $("#left").hide();
        if (pageMode === 'fit_width') {
            fitSingleToWidth();
        }
        else if (pageMode === 'fit_height') {
            fitSingleToHeight();
        }
        else if (pageMode === 'fit_page') {
            fitSingleToView();
        }else if(pageMode === 'fit_width_top'){
            fitSingleToViewOnTop();
        }else {
            console.log('Unrecognised single page view mode.',pageMode);
        }
    }

    $("#right").off("load");
    $(window).off("resize");
    
    $("#right").load(function(){
        recalcFrameSize();
        plugin.contentLoaded();
    });
    $(window).resize(recalcFrameSize);
}

function setDoublePageMode()
{
    var recalcFramesSize = function () {
        console.log('DoublePageMode frames size recalculation')
        $("#left").show();
        $("#right").show();
        if (pageMode === 'fit_width') {
            fitDoubleToWidth();
        }
        else if (pageMode === 'fit_height') {
            fitDoubleToHeight();
        }
        else if (pageMode === 'fit_page') {
            fitDoubleToView();
        }
        else {
            console.log('Unrecognised double page view mode.');
        }
    }

    $("#left").off("load");
    $("#right").off("load");
    $(window).off("resize");

    recalcFramesSize();
    console.log("setToDoublePage",pageMode);
    $('#left, #right').load(function(){
        if(++loaded ===2){
            recalcFramesSize();
        plugin.contentLoaded();
        }
    });
    $(window).resize(recalcFramesSize);
}
