/**
 * Navbar controller. Only for debug use.
 */

// @ifndef NATIVE

define(['jquery','jquery-ui'],function($) {

	var NavbarController = function(app) {

		var me = this;

		this.savedMap = {};

        $('#navbar').show();

		$('#navitem_interactionMode').buttonset();

		$("#navitem_slider").slider({
			range: "max",
			min: 1,
			max: 500,
			value: 1,
			slide: function( event, ui ) {
				document.app.setZoom(ui.value);
			},
			stop:function(){

				document.app.onNodeStateChange();
			}
		});



		$('#navitem_loadImportedMap').button().click(function() {
			document.app.loadImportedMap("importedmap");
		});

		$('#navitem_generateNode').button().click(function() {
			var nodeId = document.app.insertNode();
			//document.app.insertEdge('n01', nodeId);
		});

        $('#navitem_generateWithImage').button().click(function() {
            var nodeId = document.app.insertNode(null, null, null, 'resources/test02.jpg' );
            //document.app.insertEdge('n01', nodeId);
        });

		$('#navitem_getJson').button().click(function() {
			me.savedMap = document.app.toJson();
			alert('Map saved!');
		});

		$('#navitem_clearMap').button().click(function() {
			document.app.closeMap();
		});

		$('#navitem_reloadModel').button().click(function() {
			document.app.closeMap();
			document.app.loadJson(me.savedMap);
			document.app.getMapController().redraw();
		});

		$('#navitem_print_map').button().click(function(){
			document.app.printMap();
		})
        $('#navitem_addImg').button().click(function() {
            var nodeId = document.app.getNodeFromPoint('', 800,100);
            if (nodeId==""){
                var nodeId = document.app.insertNode(null, null, null, 'resources/test02.jpg' );
            }else{
                document.app.updateExistingNode(null, nodeId,'resources/test02.jpg' );
            }
        });


		$("#navitem_interactionMode input").change(function() {
			switch ($(this).val()) {
				case 'direct':
					document.app.modeDirect();
					break;
				case 'hand':
					document.app.modeHand();
					break;
			}
		});

	};

	return NavbarController;

});

// @endif
