requirejs.config(
    {
        paths:
	    {
		    'jquery':               '../../bower_components/jquery/dist/jquery',
		    'jquery-ui':            '../../bower_components/jquery-ui/jquery-ui',
        'jqueryui-touch-punch': '../../bower_components/jqueryui-touch-punch/jquery.ui.touch-punch.min',
		    'underscore':           '../../bower_components/underscore/underscore',
		    'easeljs':              '../../bower_components/EaselJS/lib/easeljs-0.8.1.min',
        //
        'nativeService':     'services/nativeService',
        'nativeApp':         'native/nativeApp',
        'nativeModel':       'native/nativeModel',
        'navbarController':  'controllers/navbarController',
		    'mapUtils':          'services/mapUtils',
		    'eventsService':     'services/eventsService',
		    'geometryService':   'services/geometryService',
		    'textService':       'services/textService',
        //
		    'map':               'models/map',
		    'node':              'models/node',
		    'edge':              'models/edge',
		    //
		    'mapController':     'controllers/mapController',
		    //
		    'mapView':           'views/mapView',
		    'nodeView':          'views/nodeView',
		    'edgeView':          'views/edgeView',

		    //
		    'app':               'app'
        },
        shim:
	    {
            'underscore':
		    {
                exports: '_'
            },
            'jqueryui-touch-punch':
            {
                deps: ['jquery']
            }
        }
    });

var COLORS =
	{
    	YELLOW : '#FFFF00' ,
    	GRAY: '#808080'
	};

define(['app', 'nativeService', 'jquery', 'nativeApp', 'nativeModel', 'navbarController', 'jquery-ui', 'jqueryui-touch-punch'], function (App, NativeService, $, NativeApp, NativeModel, NavbarController)
       {
           $('body').on('contextmenu', function(evt) { return false; });

            var onAppLoaded = function() {
                 document.app = new App($('#mapCanvas'));
                 document.nativeService.notifyAppLoaded();
            }

            document.nativeService = new NativeService();

            if (typeof(QWebChannel) === 'undefined') {
                if(window.nativeApp == undefined)
                {
                    window.nativeApp = new NativeApp();
                    window.nativeModel = new NativeModel();
                    navbarController = new NavbarController();
                }
                onAppLoaded();
            }
            else {
                if (window.nativeApp == undefined) {
                    new QWebChannel(qt.webChannelTransport,
                                    function(channel){
                                        // set up connections
                                        window.nativeApp = channel.objects.nativeApp;
                                        window.nativeModel = channel.objects.nativeModel;
                                        //navbarController =new NavbarController();
                                        onAppLoaded();
                                    }
                                );
                }
            }
       });
