/**
 * Created by fabrizio on 14/04/14.
 */

define ([], function() {

	// Custom events service

	var EventsService = function()
	{
	}

	EventsService.prototype.createGenericEvent = function(evtType,id,bubbles,cancelable)
	{
		var evt = new CustomEvent(
			evtType, {
				detail: {id: id},
				bubbles: bubbles,
				cancelable: cancelable
			});
		return evt;
	}

	EventsService.prototype.createGenericMouseEvent = function(evtType,id,x,y,bubbles,cancelable)
	{

		var evt = new CustomEvent(
			evtType, {
				detail: {id: id, x: x, y: y},
				bubbles: bubbles,
				cancelable: cancelable
			});

       //console.log("EventService",evt)
		return evt;
	}


    EventsService.prototype.createNodeRollOverEvent = function(nodeId,x,y,bubbles,cancelable)
    {
        return this.createGenericMouseEvent(this.EVENTTYPE.NODE_ROLL_OVER,nodeId,x,y,bubbles,cancelable);
    }

    EventsService.prototype.createDBLClickEvent =  function(nodeId,x,y,bubbles,cancelable)
    {
        return this.createGenericMouseEvent(this.EVENTTYPE.NODE_DBL_CLICK,nodeId,x,y,bubbles,cancelable);
    }


	EventsService.prototype.createNodeDragEvent = function(nodeId,x,y,bubbles,cancelable)
	{
		return this.createGenericMouseEvent(this.EVENTTYPE.NODE_DRAG,nodeId,x,y,bubbles,cancelable);
	}

	EventsService.prototype.createNodeEndDragEvent = function(nodeId,x,y,bubbles,cancelable)
	{
		return this.createGenericMouseEvent(this.EVENTTYPE.NODE_END_DRAG,nodeId,x,y,bubbles,cancelable);
	}


	EventsService.prototype.createEdgeMidPointDragEvent = function(edgeId,x,y,bubbles,cancelable)
	{
		return this.createGenericMouseEvent(this.EVENTTYPE.EDGE_MIDPOINT_DRAG,edgeId,x,y,bubbles,cancelable);
	}

	EventsService.prototype.createEdgeMidPointEndDragEvent = function(edgeId,x,y,bubbles,cancelable)
	{
		return this.createGenericMouseEvent(this.EVENTTYPE.EDGE_MIDPOINT_END_DRAG,edgeId,x,y,bubbles,cancelable);
	}

	EventsService.prototype.createEdgeModifiedEvent = function(edgeId,bubbles,cancelable)
	{
		return this.createGenericEvent(this.EVENTTYPE.EDGE_UPDATED,edgeId,bubbles,cancelable);
	}

	// Static Enums --------------------------------------------------------------------------------
	EventsService.prototype.EVENTTYPE =
	{
		NODE_DRAG: "nodeDrag",
		NODE_END_DRAG: 'nodeEndDrag',
		EDGE_MIDPOINT_DRAG: 'edgeMidPointDrag',
		EDGE_MIDPOINT_END_DRAG: 'edgeMidPointEndDrag',
		EDGE_UPDATED: 'edgeUpdated',
        NODE_DBL_CLICK:"dblclick",
        NODE_ROLL_OVER:"noderollover"
	}
	// ---------------------------------------------------------------------------------------------

	return EventsService;

})