define ([], function() {

    /**
     * Creates a service to interacte with native objects.
     *
     * @constructor
     */
	var NativeService = function() {
	}


    /**
     * Load map Json
     * @param {string} mapId
     * @returns {string} Map Json as string
     */
    NativeService.prototype.findMapJson = function(mapId)
    {
        if (nativeModel.findMap)
        {
            if (document.app.isDesktopDevice())
            {
                nativeModel.findMap(mapId, function(mapJSON){
                    var json = $.parseJSON(mapJSON);
                    document.app.mapController.processMapJson(json);
                });
            }
            else
            {
                var json = nativeModel.findMap(mapId);
                if (json == undefined) return;
                return $.parseJSON(json);
            }
        }
        else
        {
            console.warn("[NativeService] nativeModel.findMap not found");
        }
    }

    /**
     * @param {string} mapId
     * @returns {string} asset base dir path
     */
    NativeService.prototype.findAssetBaseUrl = function(mapId, next)
    {
        if (nativeModel.findAssetBaseUrl)
        {
            if (document.app.isDesktopDevice())
            {
                nativeModel.findAssetBaseUrl(mapId, function(path) {
                    if(next)
                    {
                        next(path);
                    }
                });
            }
            else
            {
                return nativeModel.findAssetBaseUrl(mapId);
            }
        } else
        {
            console.warn("[NativeService] nativeModel.findAssetBaseUrl not found");
        }
    }

    /**
     * Notificates to native app that webapp is loaded
     */
	NativeService.prototype.notifyAppLoaded = function () {
		if (nativeApp.onjs_appLoaded)
		{
			nativeApp.onjs_appLoaded();
		}
	}

    /**
     * Notificates to native app that a map is loaded
     */
	NativeService.prototype.notifyMapLoaded = function () {
		if (nativeApp.onjs_mapLoaded)
		{
			nativeApp.onjs_mapLoaded();
		}
	}
	
	NativeService.prototype.saveMapSession = function()
    {
        if(nativeApp.on_jsSave)
        {
            nativeApp.on_jsSave();
        }
    }


	return NativeService;
})
