/**
 * Created by fabrizio on 02/04/14.
 */

define(['map','nodeView','edgeView','easeljs'], function (Map,NodeView,EdgeView) {

    /**
     *
     * @param stage EaselJs container
     * @param map Map model
     * @constructor
     */
	var MapView = function (stage, map)
	{
		if (!stage) throw "MapView: Stage is null!";
		this.stage = stage;
		//
		this.nodeViews = {}; // Map id -> view
		this.edgeViews = {}; // Map id -> view
		//
		if (map)
		{
            this.createViews(map);
		}
	}

	MapView.prototype.createViews = function(map)
	{
        // caricamento di tutte le immagini?
        for (var edgeId in map.edges)
        {
            this.addEdgeView(map.edges[edgeId],map,this.stage);
        }
		// Create views from given model
		for (var nodeId in map.nodes)
		{
            document.app.nodesCount++;
			this.addNodeView(map.nodes[nodeId],this.stage);
		}


	}

	MapView.prototype.addNodeView = function(node, stage)
	{
		var nodeView = new NodeView(node, stage);
		this.nodeViews[node.id] = nodeView;
		this.stage.addChild(nodeView.widget);
        nodeView.updateWidget();
        nodeView.updateWidget();
		return nodeView;

	}


	MapView.prototype.addEdgeView = function(edge,map,stage)
	{
		var edgeView = new EdgeView(edge,map,stage);
		this.edgeViews[edge.id] = edgeView;
		this.stage.addChild(edgeView.widget);
		var source = this.nodeViews[edge.source];
		var target = this.nodeViews[edge.target];
		edgeView.updateWidget(source,target);
		return edgeView;
	}



	// TODO: selection (?), Helper buttons (?)...

	return MapView;

})
