/**
 * Created by mtassetti on 03/06/14.
 */
define(['jquery','edge'], function ($,Edge) {

    describe('constructor', function() {
        it('default constructor and defaultValues (no Json)', function() {
            var edge = new Edge();

            expect(edge).not.toBeUndefined()
            expect(edge.id).toEqual("");
            expect(edge.directed).toEqual(false);
            expect(edge.source).toEqual("");
            expect(edge.target).toEqual("");
            expect(edge.titleText).toEqual("");

            expect(edge.edgeData.type).toEqual(Edge.EDGETYPE.FORWARD);
            expect(edge.edgeData.penColor).toEqual("#C0C0C0");
            expect(edge.edgeData.penWidth).toEqual(Edge.PENWIDTH.WIDTH2);
            expect(edge.edgeData.drawOver).toEqual(false);
            expect(edge.edgeData.curve).toEqual(false);
            expect(edge.edgeData.ctrlPx).toEqual(0);
            expect(edge.edgeData.ctrlPy).toEqual(0);
            expect(edge.edgeData.language).toEqual("");

        });

        it('default constructor and defaultValues (no Json)', function() {
            var baseJson=
            {
                id:'n1'
            }

            var edge = new Edge(baseJson);
            expect(edge).not.toBeUndefined()
            expect(edge.id).toEqual(baseJson.id);
        });


    });

    describe('serialization', function() {
        beforeEach(function() {
            this.expectedJson={ id : '', directed : false, source : '', target : '', edgeData : { type : 'forward', penColor : '#C0C0C0', penWidth : '2', drawOver : false, curve : false, ctrlPx : 0, ctrlPy : 0, language : '' }, titleText : '' };
        });

        it('custom id and default values', function () {
            var baseJson=
            {
                id:'e1',
                source:'n1',
                target:'n2'
            }
            this.expectedJson.id='e1';
            this.expectedJson.source='n1';
            this.expectedJson.target='n2';

            var edge = new Edge(baseJson);
            var returnJson=edge.toJson();
            expect(this.expectedJson).toEqual(returnJson);
        });

    });
});