/**
 * Created by mtassetti on 03/06/14.
 */
define(['jquery','map'], function ($,Map) {
    beforeEach(function() {
        this.simpleMapJson={
            mapProps:{
                mapName:'testMap'
            },
            nodes:[
                {
                    id:'n1',
                    geometry:{x: 50,y: 50,width: 100,height: 100}
                },
                {
                    id:'n2',
                    geometry:{x: 250,y: 250,width: 100,height: 100}
                }
            ],
            edges:[
                {
                    id:'e1',
                    source:'n1',
                    target:'n2'
                }
            ]
        }
    })

    describe('constructor', function() {
        it('default constructor and defaultValues (no Json)', function() {
            var map = new Map();

            expect(map.map.mapProps.mapName).toEqual("");
            expect(map.map.mapProps.className).toEqual("");
            expect(map.map.mapProps.date).toEqual("");
            expect(map.map.mapProps.comments).toEqual("");
            expect(Object.keys(map.nodes).length).toEqual(0);
            expect(Object.keys(map.edges).length).toEqual(0);


        });

        it('default constructor and defaultValues with simple json', function() {
            var map = new Map(this.simpleMapJson);
            expect(map).not.toBeUndefined();
            expect(map.map.mapProps.mapName).toEqual(this.simpleMapJson.mapProps.mapName);
            console.log(map.nodes)
            expect(Object.keys(map.nodes).length).toEqual(2);
            expect(Object.keys(map.edges).length).toEqual(1);
        });


    });

    describe('serialization', function() {

        it('simple map', function () {
            var expectedJson={ mapProps : { mapName : 'testMap' }, nodes : [ { id : 'n1', nodeData : { nodeType : 'rectangle', frame : false, textLayout : 'inside', brushColor : '#FFFFFF', penColor : '#0000FF', penWidth : '2', children : 0, language : '', deepFillColor : '#FFFFFF' }, nodeTable : { tableID : '', tableRow : -1, tableCol : -1 }, geometry : { x : 50, y : 50, width : 100, height : 100, x1 : 0, y1 : 0, x2 : 0, y2 : 0, imgW : 0, imgH : 0, txtW : 0, txtH : 0 }, image : { name : '', transparent : false, custom : false }, titleText : '', deepText : '', links : [  ] }, { id : 'n2', nodeData : { nodeType : 'rectangle', frame : false, textLayout : 'inside', brushColor : '#FFFFFF', penColor : '#0000FF', penWidth : '2', children : 0, language : '', deepFillColor : '#FFFFFF' }, nodeTable : { tableID : '', tableRow : -1, tableCol : -1 }, geometry : { x : 250, y : 250, width : 100, height : 100, x1 : 0, y1 : 0, x2 : 0, y2 : 0, imgW : 0, imgH : 0, txtW : 0, txtH : 0 }, image : { name : '', transparent : false, custom : false }, titleText : '', deepText : '', links : [  ] } ], edges : [ { id : 'e1', directed : false, source : 'n1', target : 'n2', edgeData : { type : 'forward', penColor : '#C0C0C0', penWidth : '2', drawOver : false, curve : false, ctrlPx : 0, ctrlPy : 0, language : '' }, titleText : '' } ] }
            var map = new Map(this.simpleMapJson);
            var returnJson=map.toJson();
            expect(expectedJson).toEqual(returnJson);
        });

    });
});