/**
 * Created by mtassetti on 03/06/14.
 */
define(['jquery','node'], function ($,Node) {

    describe('constructor', function() {
        it('default constructor and defaultValues (no Json)', function() {
            var node = new Node();
            expect(node).not.toBeUndefined()
            expect(node.id).toEqual("");
            expect(node.nodeData.nodeType).toEqual(Node.NODETYPE.RECTANGLE);
            expect(node.nodeData.frame).toEqual(false);
            expect(node.nodeData.textLayout).toEqual(Node.TEXTLAYOUT.INSIDE);
            expect(node.nodeData.brushColor).toEqual("#FFFFFF");
            expect(node.nodeData.penColor).toEqual("#0000FF");
            expect(node.nodeData.penWidth).toEqual(Node.PENWIDTH.WIDTH2);
            expect(node.nodeData.children).toEqual(0);
            expect(node.nodeData.language).toEqual("");
            expect(node.nodeData.deepFillColor).toEqual("#FFFFFF");

            expect(node.geometry.x).toEqual(0);
            expect(node.geometry.y).toEqual(0);
            expect(node.geometry.width).toEqual(0);
            expect(node.geometry.height).toEqual(0);
            expect(node.geometry.x1).toEqual(0);
            expect(node.geometry.y1).toEqual(0);
            expect(node.geometry.x2).toEqual(0);
            expect(node.geometry.y2).toEqual(0);
            expect(node.geometry.imgW).toEqual(0);
            expect(node.geometry.imgH).toEqual(0);
            expect(node.geometry.txtW).toEqual(0);
            expect(node.geometry.txtH).toEqual(0);

            expect(node.image.name).toEqual("");
            expect(node.image.transparent).toEqual(false);
            expect(node.image.custom).toEqual(false);

            expect(node.titleText).toEqual("");
            expect(node.deepText).toEqual("")
            expect(node.links.length).toEqual(0);

        });

        it('default constructor and defaultValues (no Json)', function() {
            var baseJson=
            {
                id:'n1'
            }

            var node = new Node(baseJson);
            expect(node).not.toBeUndefined()
            expect(node.id).toEqual(baseJson.id);
        });


    });

    describe('serialization', function() {
        beforeEach(function() {
            this.expectedJson={id: '', nodeData: {nodeType: 'rectangle', frame: false, textLayout: 'inside', brushColor: '#FFFFFF', penColor: '#0000FF', penWidth: '2', children: 0, language: '', deepFillColor: '#FFFFFF'}, nodeTable: {tableID: '', tableRow: -1, tableCol: -1}, geometry: {x: 0, y: 0, width: 0, height: 0, x1: 0, y1: 0, x2: 0, y2: 0, imgW: 0, imgH: 0, txtW: 0, txtH: 0}, image: {name: '', transparent: false, custom: false}, titleText: '', deepText: '', links: []}
        });

        it('custom id and default values', function () {
            var baseJson=
            {
                id:'n1'
            }
            this.expectedJson.id='n1';
            var node = new Node(baseJson);
            var returnJson=node.toJson();
            expect(this.expectedJson).toEqual(returnJson);
        });

        it('custom position and default values', function () {
            var baseJson=
            {
                geometry:{x:100,y:200}
            }
            this.expectedJson.geometry.x=100;
            this.expectedJson.geometry.y=200;
            var node = new Node(baseJson);
            var returnJson=node.toJson();
            expect(this.expectedJson).toEqual(returnJson);
        });
    });
});