var tests = [];
for (var file in window.__karma__.files) {
    if (/Spec\.js$/.test(file)) {
        tests.push(file);
    }
}

requirejs.config({
    // Karma serves files from '/base'
    baseUrl: '/base/src',

    paths: {
        'jquery': '../lib/jquery',
        'underscore': '../lib/underscore',
        "text" : "../lib/text",
        'easeljs': '../lib/easeljs',
		'app': 'app',
		'mapController': 'controllers/mapController',
		'eventsService': 'services/eventsService',
        'geometryService': 'services/geometryService',
        'textService': 'services/textService',
		'mapUtils': 'services/mapUtils',
		'nativeInterface': 'services/nativeInterface',
        'map': 'models/map',
		'node': 'models/node',
		'edge': 'models/edge',
		'mapView': 'views/mapView',
		'nodeView': 'views/nodeView',
		'edgeView': 'views/edgeView'
    },

    shim: {
        'underscore': {
            exports: '_'
        }
    },

    // ask Require.js to loadJson these files (all our tests)
    deps: tests,

    // start test run, once Require.js is done
    callback: window.__karma__.start
});

