// @ifndef NATIVE
define([''],function() {
    /**
     * Creates an 'interface' to notificate something to native app.
     * The real one is injected by QT.
     *
     */
    var NativeApp = function () {

    };

    /**
     * Notificates to native app that app is loaded
     */
    NativeApp.prototype.onjs_appLoaded = function()
    {
        console.log("[NativeApp] onjs_appLoaded");
    };


    NativeApp.prototype.onjs_close = function()
    {
        console.log("[NativeApp] onjs_close");
    };


    NativeApp.prototype.onjs_keywordSearched = function(keywords)
    {
        console.log('[NativeApp] retrieving data from native app on keywords: ', keywords );

      /* hence there is a simplification, data are coming from nativeApp not from native Model

         */

        var mediaObject = {};
        var mediaObjectShuffled = {};

        for (var i = 1; i <= 5; i++)
        {

            var media = {
                type: 'img',
                title: 'Titolo del media ' + i,
                score: 100 - 1,
                tags: 'tag1 tag2 tag3',
                filePath: 'assets/images/media/media-' + i + '.jpg',
                fileExists: Math.random() < 0.5 ? true : false,
                id: i.toString()
            };
            mediaObject[i] = media;
        }

        for (var i = 6; i <= 11; i++)
        {

            var media = {
                type: 'video',
                title: 'Titolo del video ' + i,
                score: 100 - i,
                tags: 'tag1 tag2 tag3',
                filePath: 'assets/images/media/media-' + i + '.jpg',
                fileExists: true,
                id: i.toString()
            };

            mediaObject[i] = media;
        }

        var keys = Object.keys(mediaObject);
        keys.sort(function() {return 0.5 - Math.random()});

        for (var i=0; i<keys.length; i++) { // now lets iterate in sort order
            var key = keys[i];
            var value = mediaObject[key];
            mediaObjectShuffled[key] = value;
        }

        var output;
        Math.random() < 0.5 ? output = mediaObjectShuffled : output = [];
        return output;
        /*return mediaObjectShuffled;*/
    };

    NativeApp.prototype.onjs_mediaSelected = function(id)
    {
        console.log('[NativeApp] selecting resource with id ', id);
    };

    return NativeApp;
});

// @endif
