define ([], function() {

    /**
     * Creates a service to interacte with native objects.
     *
     * @constructor
     */
    var NativeService = function()
    {
    };

    /**
     * Notificates to native app that webapp is loaded
     */
    NativeService.prototype.notifyAppLoaded = function ()
    {
        if (nativeApp.onjs_appLoaded)
        {
            nativeApp.onjs_appLoaded();
        }
    };

    NativeService.prototype.onjs_close = function()
    {
        if (nativeApp.onjs_close)
        {
            nativeApp.onjs_close();
        }
    };

    NativeService.prototype.onjs_keywordSearched = function(keywords, refresh)
    {
        console.log('searching keywords ' + keywords);
        if (nativeApp.onjs_keywordSearched)
        {
            nativeApp.onjs_keywordSearched(keywords, refresh);
        }
    };

    NativeService.prototype.onjs_mediaSelected = function(id)
    {
        console.log('selecting media ' + id);
        if (nativeApp.onjs_mediaSelected)
        {
            return nativeApp.onjs_mediaSelected(id);
        }
    };


    return NativeService;
});
