var zoom=1;
var load = true;

String.prototype.decodeHTML = function() {
    var map = {"gt":">" /* , … */};
    return this.replace(/&(#(?:x[0-9a-f]+|\d+)|[a-z]+);?/gi, function($0, $1) {
        if ($1[0] === "#") {
            return String.fromCharCode($1[1].toLowerCase() === "x" ? parseInt($1.substr(2), 16)  : parseInt($1.substr(1), 10));
        } else {
            return map.hasOwnProperty($1) ? map[$1] : $0;
        }
    });
};

var checkIfAppIsInstalled = function() {
	var hash = window.location.hash;
	var forceload = hash.indexOf('forceload')!=-1;
	if (!TPCONF.package && !forceload && BrowserInfo.isiOS) {
		var save = window.location.href;
		load = false;
		var href = TPCONF.protocol+'://';
		setTimeout(function() {
			var nhref = window.location.href;
			if (nhref!=href) {
				var url = $('.iosstore').closest('A').attr('href');
			    window.location = url;
			}
		}, 50)
		window.location = href;
	}
}

var init = function() {
	window.location.hash = window.location.hash.replace('forceload', '').replace('#', '');
	if (load) {
		$('.js-year').text(new Date().getFullYear());
		FastClick.attach(document.body)
		if (Modernizr.touch) {
			$('html, body').addClass('touch');
			// fix shadow ios7
			if (navigator.userAgent.match(/(iPad|iPhone);.*CPU.*OS 7_\d/i)) $('#wrap').css('backface-visibility', 'hidden');
		}

		if (BrowserInfo.isChrome && navigator && navigator.registerProtocolHandler) {
			try {
				var protocol = TPCONF['protocol'] || 'zptable';
				var name = TPCONF['appname'] || 'Tavola Periodica';
				navigator.registerProtocolHandler('web+'+TPCONF['protocol'], 'http://www.tavolaperiodica.lcl/%s', name);
			} catch( e ) {}
		}

		/*if (BrowserInfo.isChrome && TPCONF.package && !BrowserInfo.isAndroid && chrome.app.window) {
			chrome.app.window.current().maximize();
		}*/

		periodicTableView = new periodicTable();
		periodicTableView.historyView = new PeriodicTable.HistoryView();
		periodicTableView.load().done(function() {
			var preloadingFonts = document.body.querySelector('.preloadFonts');
			if (preloadingFonts) {
				preloadingFonts.style['display'] = 'none';
			}
			var fetching = document.getElementById('fetching');
			if (fetching) {
				fetching.style['display'] = 'none';
			}
			if (periodicTableView.historyView.model.get('mode')==null) $('[rel="simple"]').trigger('click');
			if (navigator.splashscreen) {
				setTimeout(function() {
					navigator.splashscreen.hide();
				}, 100)
			}

			if (BrowserInfo.isChrome && TPCONF.package && !BrowserInfo.isAndroid) {
				$('.splashscreen').fadeOut(500, function() {
					$('.splashscreen').remove();
				});

				/*$(document).bind('keydown', function(ev) {
					if (ev.keyCode==27) {
						chrome.app.window.current().close();
					}
				})*/
			}

			if (!TPCONF.package && !BrowserInfo.isAndroid && !BrowserInfo.isiOS) {
				$('.switchToApp, .switchToApp LI').show();
				setTimeout(function() {
					$('.switchToApp').addClass('visible');
				},10);
				$('.switchToApp .nostore').click(function() {
					$('.switchToApp').removeClass('visible');
					setTimeout(function() {
						$('.switchToApp').fadeOut(500, function() {
							$('.switchToApp').remove();
						});
					}, 500);
				})
			}

			if (BrowserInfo.isAndroid && !TPCONF.package) {
				$('.switchToApp, .switchToApp LI.androidstore').show();
				$('.switchToApp LI.nostore').hide();
				setTimeout(function() {
					$('.switchToApp').addClass('visible');
				},10);
			}

			Backbone.trigger('periodictable:shown');
		});
	}
}

$(window).load(function(){
	checkIfAppIsInstalled();
	init();
});
