(function() {
	'use strict';

	PeriodicTable.SimpleView = Backbone.View.extend({
		/*** attributes ***/
		isActive: false,

		/***  elemets ***/
		panel: null,

		initialize: function() {
			Backbone.on('focus:close', this.deSelect, this);
			this.panel = document.getElementById('approfondimento');
		},

		setActive: function(bool) {
			if (bool!=this.isActive) {
				this.isActive = bool;
				if (bool) this.active();
				else this.deactive();
				return this;
			}
		},

		active: function() {
			this.panel.classList.remove('app_ce');
			this.listenTo(periodicTableView.zElements,'change:active',this.onElementTap);
			periodicTableView.modalToShow('tabella_ing');
			var activeEl = periodicTableView.getActiveElement();
			if (activeEl) this.onElementTap(activeEl);
		},

		reset: function() {
			periodicTableView.focusView.close();
			periodicTableView.zElements.each(function(model) {
				model.set('active', false)
			});
		},

		deactive: function() {
			periodicTableView.focusView.closePlus();
			this.stopListening();
		},

		onElementTap: function(model) {
			if (this.isActive && model.get('active')) {
				document.body.classList.remove('showCredits');
				periodicTableView.focusView.open('simple',model);
				periodicTableView.audio.play("elemento");
			}
		},

		deSelect: function(model) {
			if (this.isActive && model) {
				model.set('active',false);
			}
		},
	});

}());