(function() {
	'use strict';

	PeriodicTable.TrainingView = Backbone.View.extend({
		/*** attributes ***/
		isActive: false,
		submenus: null,
		isTesting: false,
		activeElements: [],
		elementsIterator: 0,
		currentTest: null,
		currentDifficoult: null,
		hasSkipped: false,
		selectedClass: null,
		selectedState: null,

		events: {
			"click .plink:not(.palestraattiva)": "onTitleTap",
			//"click .plink.palestraattiva li": "switchTraining",
			"click .lista_istruzioni .submenu li": "switchTraining",
			"click #menupunteggio #azzera": 'resetQuiz',
			"click #menupunteggio #esci": 'reset',
			"click #passa_label": 'skip',
			"click #labelclassi .labelclasse:not(.inactive)": 'selectClass',
			"click #labelstati .labelclasse:not(.inactive)": 'selectStatus'
		},

		setActive: function(bool) {
			if (bool!=this.isActive) {
				this.isActive = bool;
				if (bool) this.active();
				else this.deactive();
				return this;
			}
		},

		active: function() {
			this.listenTo(periodicTableView.zElements,'change:active',this.onElementTap);
			this.submenus = this.$('#seleziona_gioco .submenu');
			var activeElement = periodicTableView.getActiveElement();
			if (activeElement) activeElement.set('active', false);
			periodicTableView.focusView.close();
			periodicTableView.zElements.each(function(model) {
				model.set('clickable', false);
			})
		},

		reset: function() {
			this.endQuiz();
			this.active();
			$('.lista_istruzioni').hide();
			$('.palestraattiva').removeClass('palestraattiva').find('.submenu').stop().animate({ height : 0 },500);
		},

		deactive: function() {
			periodicTableView.switchColours('default');
			this.endQuiz();
		},

		onElementTap: function(model) {
			if (this.isActive && model.get('active')) {
				periodicTableView.audio.play("elemento");
				return false;
			}
		},

		onTitleTap: function(ev) {
			periodicTableView.audio.play("scheda");
			var t = ev.currentTarget;
			var $t = $(t);
			var submenu = $t.find('.submenu');
			var others = this.submenus.not(submenu);
			var ns = submenu.find('li');
			$('.plink').removeClass('palestraattiva');
			/*if (submenu.css('height')=='0px'){
				others.animate({ height : 0 },500);
				submenu.stop().animate({ height : 21*ns.length },500);
			} */
			$('.lista_istruzioni').hide();
			var id = $t.attr('rel');
			this.currentExercise = id;
			$('.lista_istruzioni[rel="'+id+'"]').show();
			$t.addClass('palestraattiva');
			$('#titolotest').text($t.contents()[0].textContent);
			return false;
		},

		switchTraining: function(ev) {
			periodicTableView.audio.play("scheda");
			$('body').addClass('modeQuiz');
			$('.lista_istruzioni').hide();
			var $t = $(ev.currentTarget);
			$('.elemento').removeClass('nonconsiderare');
			this.$('.plink').removeClass('palestraattiva');
			this.submenus.find('li').removeClass('palestraattiva');
			this.submenus.css({ height : 0 });
			var rel = $t.closest('.plink').attr('rel');
			var difficoult = $t.data('difficoult');
			this.isTesting = true;
			this.currentTest = rel;
			this.currentDifficoult = difficoult;
			this.resetQuiz();
			return false;
		},

		endQuiz: function() {
			$('#punteggio').hide();
			$('#passa-al-successivo').hide();
			if (this.isTesting) $('body').removeClass('modeQuiz difficoult0 difficoult1 '+(TPEXERCISES[this.currentExercise].css_class||''));
			this.stopListening();
			this.isTesting = false;
			this.selectedState = null;
			this.selectedClass = null;
			periodicTableView.zElements.each(function(model) {
				var view = model.get('elementView');
				view.setClass('', 'toguess fondoscuro alreadyActive nonconsiderare schiarita solido gassoso liquido '+model.get('group')+'g');
				model.set('clickable', true);
			});
		},

		resetQuiz: function() {
			this.resetPoints();
			$('.labelclasse','#labelclassi').removeClass('schiarita');
			$('.labelclasse','#labelstati').removeClass('schiarita');
			this.selectedClass = null;
			this.selectedState = null;
			periodicTableView.zElements.each(function(model) {
				model.set('clickable', true);
			});
			this.test(this.currentDifficoult);
			periodicTableView.audio.play("scheda");
		},

		resetPoints: function() {
			$('#tentativi').html('0');	
			$('#corretti').html('0');
			$('#errori').html('0');
			$('#lineapunti').html(null);
			$('#palestra_ing').show();
			this.elementsIterator = 0;
			this.selectedClass = null;
			this.selectedState = null;
			$('#punt_r').css({
				left: 290
			});
		},

		setPoint: function(correct) {
			var num;
			if (correct){
				num = parseInt($('#corretti').html())+1;
				$('#corretti').html(num);
				$('#lineapunti').prepend('<td class="puntog"></td>');
				periodicTableView.audio.play("corretto");
			} else {
				num = parseInt($('#errori').html())+1;
				$('#errori').html(num);
				$('#lineapunti').append('<td class="puntos"></td>');
				periodicTableView.audio.play("errore");
			}
			var giusti = parseInt($('#corretti').html());
			var sbagliati = parseInt($('#errori').html());
			var tentativi = (giusti+sbagliati);
			$('#tentativi').html(tentativi);
			
			var larg = (($('#tabellone').width())/(tentativi))|3;
			
			$('td','#lineapunti').css({
				width : larg
			});
			
			var perc=$('#tabellone').width();
			try {
				var ar=$('.puntos').get();
				var fe=ar[0];
				perc = ($(fe).offset().left-$('#tabellone').offset().left)/zoom+1;
			} catch(e) {};
			
			$('#punt_r').css({
				left: perc
			});
		},

		skip: function() {
			var view = this;
			for(var i=0; i<3; i++) view.setPoint(false);
			var model = view.activeElements[view.elementsIterator];
			this.hasSkipped = true;
			model.set('active', true);
			return false;
		},

		test: function(v) {
			var view = this;
			periodicTableView.switchColours('default');
			var ex = TPEXERCISES[this.currentExercise];
			
			if (ex.show_score) {
				$('#punteggio').show();
			} else {
				$('#punteggio').hide();
			}

			if (ex.can_go_to_next) {
				$('#passa-al-successivo').show();
			} else {
				$('#passa-al-successivo').hide();
			}

			$('body').addClass(ex.css_class).addClass('difficoult'+v);;
			var filter = ex.degree_filter[v];

			var filterType = '';
			var filterProp = [];
			for (var prop in filter) {
			    filterType = prop;
			    filterProp = filter[prop];
			    break;
			}
			periodicTableView.zElements.each(function(model) {
				var prop = model.get(filterType);
				var elView = model.get('elementView');
				if (filterProp.indexOf(prop)==-1){
					elView.setClass('schiarita nonconsiderare',' ');
					model.set('clickable', false);
				} else {
					elView.setClass('toguess');
				}
			});
			
			this.activeElements = periodicTableView.zElements.where({ clickable: true });
			this.activeElements = this.activeElements.sort(function() { return (Math.round(Math.random())-0.5)});
			this.elementsIterator = 0;
			for (var k in ex.request_data) {
				var str = ex.request_data[k];
				if (str.indexOf('text:')==-1) {
					str = this.activeElements[this.elementsIterator].get(ex.request_data[k]);
				} else {
					str = str.replace('text:', '');
				}
				$('.'+k, '#daindovinare').html(str);
			}

			var m = this.activeElements[this.elementsIterator].get('levels_matrix');
			periodicTableView.configurationView.completeSpinGraph(m, $('#spin'));

			this.listenTo(periodicTableView.zElements,'change:active', function(model) {
				if (model.get('active')==true) {
					var id = model.get('number');
					var group = model.get('group').toLowerCase();
					var state = model.get('standard_physical_state').toLowerCase();
					var rid = view.activeElements[view.elementsIterator].get('number');
					if (id == rid || group == this.selectedClass || state == this.selectedState) {
						var elView = model.get('elementView');
						model.set('clickable', false);
						elView.setClass('', 'toguess');
						view.elementsIterator++;
						if (view.elementsIterator<view.activeElements.length) {
							for (var k in ex.request_data) {
								$('.'+k, '#daindovinare').html(this.activeElements[this.elementsIterator].get(ex.request_data[k]));
							}
							var m = this.activeElements[this.elementsIterator].get('levels_matrix');
							periodicTableView.configurationView.completeSpinGraph(m, $('#spin'));
						} else {
							view.$('#palestra_ing').hide();
						}
						if (!view.hasSkipped) view.setPoint(true);
						else view.hasSkipped = false;
					} else {
						if (!(view.currentTest=='compose_classes' && view.selectedClass==null) 
							&& !(view.currentTest=='standard_state' && view.selectedState==null))
							view.setPoint(false);
					}
					model.set('active', false);
				}
				return false;
			});
		},

		selectClass: function(ev) {
			var $t = $(ev.currentTarget);
			$('.labelclasse','#labelclassi').addClass('schiarita');
			$t.removeClass('schiarita');
			periodicTableView.audio.play("scheda");
			this.selectedClass = $t.attr('rel').toLowerCase();
			return false;
		},

		selectStatus: function(ev) {
			var $t = $(ev.currentTarget);
			$('.labelclasse','#labelstati').addClass('schiarita');
			$t.removeClass('schiarita');
			periodicTableView.audio.play("scheda");
			this.selectedState = $t.attr('rel').toLowerCase();
			return false;
		},
	});

}());