var saved_json = JSON.parse('[{"name":"Idrogeno","number":1,"color":"0xadb293","group":"nonmetal","symbol":"H","image_url":"idrogeno.jpg","image_description":"Grazie alla sua leggerezza, in passato l’idrogeno era il gas utilizzato per gonfiare i dirigibili.","more_text":"<h1>Biologia</h1>L’idrogeno elementare è un gas assai raro in natura: è presente nei gas naturali e vulcanici, ma solo in piccole quantità.<br />Eppure l’idrogeno è molto abbondante negli esseri viventi: infatti quasi tutti i composti organici, fondamentali per la vita, contengono idrogeno. Inoltre uno dei composti più abbondanti sulla Terra è l’acqua, che come sappiamo contiene due atomi di idrogeno e un atomo di ossigeno.<br /><br /><h1>Scienze della Terra</h1>L’idrogeno è l’elemento più abbondante nella Via Lattea, ma rappresenta solo il 14% in peso della crosta terrestre. È presente però in quasi tutti i composti organici, e soprattutto nell’acqua. La reazione di formazione dell’acqua è<br />2H<sub>2</sub> + O<sub>2</sub> → 2H<sub>2</sub>O<br />in cui l’idrogeno gassoso «brucia» se innescato con una scintilla. Se fatta avvenire in ambienti chiusi, questa reazione può diventare esplosiva.<br />Questa è la maniera in cui l’acqua si è formata milioni di anni fa sul nostro pianeta, in un’atmosfera ricca di idrogeno e di ossigeno.<br /><br /><h1>Astronomia</h1>L’idrogeno è di gran lunga l’elemento più abbondante nell’Universo. Il Sole, così come le altre stelle, è costituito da una percentuale molto bassa (0,1-3%) di metalli (soprattutto ferro e nichel), mentre sono molto abbondanti l’idrogeno (70-75%) e l’elio (24-27%).<br />La reazione che «genera» la luce e il calore del Sole è<br />4<sup>1</sup>H → <sup>4</sup>He + 2e<sup>+</sup> + 2γ + 2ν<br />cioè si fondono quattro atomi di idrogeno per generare un atomo di elio e una serie di particelle e di onde altamente energetiche.<br /><br /><h1>Storia</h1>L’idrogeno è stato identificato e isolato per la prima volta nel 1766 da Cavendish; precedentemente veniva confuso con altri gas. Cavendish mescolò un acido forte (l’acido cloridrico, HCl) con lo zinco metallico (Zn), producendo cloruro di zinco (ZnCl<sub>2</sub>) e idrogeno allo stato gassoso (H<sub>2</sub>). La presenza dell’idrogeno si osserva mediante la formazione di un’effervescenza nella soluzione, a causa dell’allontanamento dell’idrogeno gassoso. Cavendish dimostrò anche che l’idrogeno, reagendo con l’ossigeno, genera l’acqua.<br /><br /><h1>Utilizzo</h1>Attraverso il processo Haber-Bosch si fa reagire l’idrogeno con l’azoto per ottenere l’ammoniaca.<br />L’idrogeno e l’ossigeno, entrambi allo stato liquido, sono usati come combustibile per i razzi.<br />Circa un secolo fa l’idrogeno veniva usato per gonfiare i palloni, ma essendo infiammabile causava gravi e terribili incidenti quando il gas nella bombola veniva a contatto con fiamme libere o scintille.<br />I principali composti dell’idrogeno sono gli idruri e gli idracidi. Gli idruri sono composti binari con un metallo del I, II o III gruppo, hanno carattere basico e contengono lo ione H<sup>-</sup>. Gli idracidi sono composti binari con un non metallo del VI o VII gruppo, hanno carattere acido e contengono lo ione H<sup>+</sup>.<br />","atomic_mass":1,"oxidation_numbers":"±1","melting_temperature":14,"boiling_temperature":20,"electronic_configuration":"1s<sup>1</sup>","standard_physical_state":"Gas","atomic_radius":37,"first_ionisation_energy":1312,"electronegativity":2,"electronic_affinity":0,"density":"0,0899 g/L","discovery_year":1776},{"name":"Elio","number":2,"color":"0xadccdc","group":"gas","symbol":"He","image_url":"elio.jpg","image_description":"L’elio è  un gas leggero, utilizzato per gonfiare i palloncini.","more_text":"<h1>Biologia</h1>Gli scienziati stanno esplorando nuovi metodi per scrutare all’interno del corpo dei pazienti: facendo inspirare a questi ultimi dell’elio, è poi possibile osservare dove si spinge il respiro all’interno del polmone.<br />Questo tracciamento del flusso di aria permette di trattare enfisemi e fibrosi cistiche, nonché di monitorare il decorso post-operatorio di trapianti polmonari. I pazienti inalano elio al posto dell’ossigeno; le molecole di gas normalmente ruotano in modo casuale, ma un laser puntato tra di loro origina un campo magnetico che orienta le molecole e la fa ruotare tutte nella stessa direzione, generando un segnale di risonanza magnetica (RM) migliaia di volte più intenso di quello normale. La RM dell’elio immesso nei polmoni mostra un’immagine chiara del tessuto; se invece c’è un’ostruzione che impedisce all’elio di fluire e quindi al polmone di lavorare bene, l’immagine generata è scura.<br />Questa tecnologia non è applicabile solo ai polmoni: è in fase di analisi l’uso per altri organi più difficili da vedere con tecniche convenzionali. I ricercatori sono pronti a testarla per il cancro al colon, oppure per le tube di Falloppio o per il cervello.<br />La ragione per cui la nostra voce cambia suono quando si inala elio è che questo gas è meno denso dell’aria: le nostre corde vocali risuonano a frequenze più alte in un ambiente diverso dal normale, e tutti i toni risultano più alti.<br /><br /><h1>Scienze della Terra</h1>Sulla Terra è presente una piccolissima quantità di elio; la grande quantità di gas prodotta durante la formazione della Terra si è spostata nello spazio a causa della ridotta massa del nostro pianeta, insufficiente a trattenerla. L’elio attualmente presente è il risultato del decadimento radioattivo dell’uranio e del torio in certi minerali, tra cui cleveite, pechblenda e berillo. Ne è presente una piccola quantità anche nelle sorgenti di acqua minerale, nei gas vulcanici e nei minerali di ferro.<br />La maggior parte dell’elio comunemente utilizzato è prodotto da pozzi di gas naturale in Texas, Oklahoma e Kansas.<br /><br /><h1>Astronomia</h1>L’elio è concentrato soprattutto nelle stelle, dove viene prodotto dalla reazione di fusione nucleare dell’idrogeno. Secondo il modello del rapido sviluppo dell’Universo, la maggior parte dell’elio si è formata nei primi tre minuti successivi al Big Bang.<br />I ricercatori stanno studiando la possibilità di usare l’isotopo <sup>3</sup>He (due protoni e un neutrone) come carburante; è infatti molto potente e non inquinante. In realtà è molto difficile ottenerlo sulla Terra, anche se ce n’è una grande quantità sulla Luna. Quando il vento solare (una rapida corrente di particelle cariche emesse dal Sole) batte sulla Luna, <sup>3</sup>He viene depositato sul polveroso suolo lunare; questo fenomeno si ripete da migliaia e migliaia di anni. Poi bombardamenti meteoritici diffondono le particelle anche a centinaia di metri dalla superficie lunare. Gli scienziati stimano che sulla Luna ci siano circa un milione di tonnellate di <sup>3</sup>He, sufficienti per produrre energia sulla Terra per centinaia di anni. Ma è molto costoso andare a prendere l’elio fin sulla Luna.<br />La fusione nucleare di <sup>3</sup>He e deuterio (isotopo dell’idrogeno che contiene un protone e un neutrone) produce una gran quantità di energia, tanta da poter essere anche usata in un reattore.<br /><br /><h1>Storia</h1>L’elio è stato scoperto nel 1868 nell’atmosfera che circonda il Sole dall’astronomo francese Janssen, che individuò un’intensa riga gialla, associata inizialmente al sodio, nello spettro di emissione luminosa del Sole durante un’eclisse. Nello stesso anno, l’astronomo inglese Lockyer osservò che la riga gialla dello spettro del Sole non corrispondeva alle già note righe d<sup>1</sup> e d<sup>2</sup> del sodio; la indicò quindi con d<sup>3</sup> e associò questa linea a un elemento del Sole non presente sulla Terra. Lockyer e il chimico Frankland derivarono perciò il nome del nuovo elemento dal nome greco del Sole, «helios».<br />Il chimico britannico Ramsay scoprì l’esistenza dell’elio sulla Terra nel 1895, grazie a un campione di cleveite, un minerale contenente uranio: Ramsay evidenziò nel suo spettro la presenza dell’inconfondibile riga gialla intensa d<sup>3</sup>, osservata precedentemente nello spettro del Sole. Successivamente, Ramsay e Soddy determinarono che l’elio veniva prodotto dal decadimento radioattivo di alcune sostanze instabili, come l’uranio.<br /><br /><h1>Utilizzo</h1>Grazie alla sua scarsa reattività chimica l’elio è stato usato come gas inerte durante la saldatura di alcuni metalli, come l’alluminio.<br />È usato nei propulsori dei razzi per pressurizzare le taniche di benzina, soprattutto quelle a idrogeno liquido: infatti l’elio è ancora allo stato gassoso alla temperatura di liquefazione dell’idrogeno.<br />L’elio è usato come gas per gonfiare i palloncini, essendo un gas più leggero dell’aria.<br />Viene utilizzato come liquido refrigerante perché, compresso e portato allo stato liquido, può raggiungere temperature così basse da avvicinarsi allo zero assoluto.<br />L’elio viene miscelato con l’ossigeno nelle bombole da sub grazie alla sua bassa solubilità nel sangue umano, che riduce al minimo il rischio di emboli.<br />","atomic_mass":4,"oxidation_numbers":"/","melting_temperature":1,"boiling_temperature":4,"electronic_configuration":"1s<sup>2</sup>","standard_physical_state":"Gas","atomic_radius":"/","first_ionisation_energy":2372,"electronegativity":"/","electronic_affinity":"/","density":"0,18 g/L","discovery_year":1868},{"name":"Litio","number":3,"color":"0xca6b18","group":"metal","symbol":"Li","image_url":"litio.jpg","image_description":"Il litio è il principale componente delle batterie dei telefoni cellulari.","more_text":"<h1>Biologia</h1>L’interesse per l’impiego del litio in campo medico risale alla metà dell’Ottocento, quando ne venne ipotizzata l’utilità nel trattamento della gotta. Negli anni successivi le descrizioni delle potenzialità terapeutiche del litio si moltiplicarono, stimolando addirittura la produzione di acque minerali e birre contenenti litio, che portarono in alcuni casi però a vere e proprie intossicazioni.<br />Era il 1949 quando Cade, presupponendo che alcune malattie mentali fossero dovute alla presenza di sostanze fisiologicamente presenti nell’organismo, descrisse i risultati di uno storico studio su pazienti con gravi turbe maniacali.<br />Successivamente, intorno agli anni Sessanta, altri scienziati confermarono l’ipotesi di Cade: condussero un’ulteriore serie di studi e mostrarono gli effetti del litio su ricadute di depressione e sindromi maniacali e ipomaniacali, segnando una vera e propria svolta nella cura della malattia maniaco-depressiva.<br />Solo negli anni Settanta la terapia al litio è stata ufficialmente riconosciuta, dopo una difficile battaglia volta a far conoscere e riconoscere il ruolo primario del litio nella cura degli episodi maniacali.<br /><br /><h1>Scienze della Terra</h1>Il litio è largamente disponibile, ma non si trova in natura allo stato metallico in quanto altamente reattivo all’aria. Si trova in minima parte in quasi tutte le rocce ignee e in molte saline naturali. Il metallo viene isolato, separandolo dagli altri elementi, dalle rocce ignee, ma è anche estratto da alcune sorgenti di acqua minerale. I principali minerali che contengono questo metallo sono spodumene (il minerale più comune, che contiene LiAlSi<sub>2</sub>O<sub>6</sub>), lepidolite e petalite.<br />Quasi il 50% delle riserve disponibili e commercialmente sfruttabili si trova in Bolivia, nei laghi salati prosciugati delle Ande.<br />Il metallo presenta un aspetto argenteo, come il sodio.<br /><br /><h1>Storia</h1>Il litio venne scoperto nel 1817 da Arfwedsen nel minerale petalite, LiAl(Si<sub>4</sub>O<sub>6</sub>), che lo scienziato stava analizzando sull’isola di Utö, in Svezia.<br />Studi successivi dimostrarono che durante la combustione i sali di litio emettono una fiamma rosso brillante. L’elemento fu isolato anni dopo facendo elettrolisi sull’ossido di litio.<br />Sembra che il nome «litio» (dal greco «lithos», pietra) sia stato scelto perché fu scoperto all’interno di un minerale, mentre gli altri metalli alcalini vennero rintracciati nei tessuti vegetali.<br /><br /><h1>Utilizzo</h1>Il litio trova largo impiego nella farmacologia, sotto forma di carbonato (Li<sub>2</sub>CO<sub>3</sub>), nella cura delle malattie maniaco-depressive.<br />Il litio viene usato anche nella produzione di batterie. La prima batteria al litio fu fabbricata nel 1912, ma l’uso più massiccio risale ai primi anni Novanta, con le batterie ricaricabili. Il litio infatti ha un alto potenziale elettrochimico, e quindi diventa materiale anodico nelle pile, nelle quali si trova sotto forma di sale carbonato (Li<sub>2</sub>CO<sub>3</sub>) o perclorato (LiClO<sub>4</sub>).<br />A causa del suo calore specifico elevato è utilissimo in applicazioni che sfruttano il trasferimento di calore.<br />","atomic_mass":6,"oxidation_numbers":"+1","melting_temperature":454,"boiling_temperature":1615,"electronic_configuration":"[He]2s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":152,"first_ionisation_energy":513,"electronegativity":0,"electronic_affinity":0,"density":"0,53 g/mL","discovery_year":1817},{"name":"Berillio","number":4,"color":"0xffedbc","group":"metalc","symbol":"Be","image_url":"berillio.jpg","image_description":"Lo smeraldo, considerato tra le pietre più preziose al mondo, è un minerale che contiene berillio.","more_text":"<h1>Biologia</h1>Il berillio è altamente tossico, sia in forma metallica che nei suoi composti. Se inalato può provocare una malattia nota come berilliosi. Ci sono due forme di questa patologia: una molto grave, che colpisce la pelle e i polmoni dei minatori che estraggono il metallo; la seconda è una lenta e cronica evoluzione che colpisce chi si espone ai fumi e alla polvere del berillio (cioè soprattutto lavoratori scientifici e industriali).<br />La malattia acuta, che colpisce polmoni e pelle, causa una bruciante eruzione cutanea, irritazione agli occhi e perdite nasali, tosse e oppressione al petto. Il contatto diretto con i sali di berillio causa la reazione della pelle, mentre l’inalazione quella ai polmoni. Molti degli effetti dovuti alla berilliosi si recuperano in alcuni mesi; la malattia cronica sopraggiunge dopo molti anni dall’esposizione, si mostra più mite, genera respiro corto (soprattutto dopo l’esercizio fisico), tosse secca ed esaurimento fisico. La berilliosi causa una permanente ma moderata disabilità.<br /><br /><h1>Scienze della Terra</h1>L’isotopo radioattivo del berillio, <sup>1</sup><sup>0</sup>Be, è stato usato per misurare la variazione dell’attività magnetica del Sole.<br />Il <sup>1</sup><sup>0</sup>Be è raro sulla Terra: si forma infatti nella stratosfera terrestre (la porzione dell’atmosfera fra i 12 e i 50 km), prodotto dai raggi cosmici. Quando l’attività magnetica del Sole aumenta, la produzione di <sup>1</sup><sup>0</sup>Be precipita. A causa del suo lungo tempo di dimezzamento (1,5 milioni di anni), e quindi della sua stabilità, viene considerato un affidabile strumento di misura.<br />Tenendo in considerazione anche il campo magnetico terrestre, che variando influisce sulla produzione di <sup>1</sup><sup>0</sup>Be, gli scienziati hanno concluso che il ciclo dell’attività magnetica del Sole ha un periodo di 100 000 anni, che approssimativamente corrisponde a cambiamenti climatici del passato della Terra. Questo ha portato alcuni scienziati a pensare che l’attività magnetica del Sole abbia un impatto sui cambiamenti climatici della Terra maggiore di quanto precedentemente ipotizzato.<br /><br /><h1>Astronomia</h1>Il berillio è un elemento che può essere usato per stabilire l’età delle galassie. È noto agli astronomi che la Via Lattea è una delle galassie più vecchie: recentemente la sua età è stata stimata nuovamente e stabilita a 13,6 miliardi di anni, con un’incertezza di 800 milioni di anni. La datazione delle stelle è generalmente basata sulla conoscenza del fatto che le stelle più antiche fossero formate interamente di idrogeno. Le vecchie stelle che hanno vissuto una vita breve sono esplose violentemente, espellendo nell’Universo nuovi e più pesanti elementi (generati dalla fusione successiva dell’idrogeno). L’età della Galassia è stata stimata misurando la quantità di berillio di due stelle contenute in un gruppo globulare chiamato NGC 6397. Questa quantità di berillio che aumenta nel tempo genera una sorta di «orologio cosmico».<br />In astronomia il berillio è importante anche perché viene utilizzato nella costruzione degli specchi dei telescopi. Nella costruzione del James Webb Space Telescope è stato fatto un grande passo in avanti quando si è potuto utilizzare uno specchio al berillio di 6,5 m, diviso in 18 sezioni, che vengono riposizionate in orbita con l’ausilio di micromotori. Questo potentissimo specchio è 2,5 volte più grande, e pesa solo un terzo, di quello dello Hubble Space Telescope.<br /><br /><h1>Storia</h1>Il berillo, il minerale da cui prende il nome il berillio, è conosciuto da centinaia di anni; alcune sue varietà sono gli smeraldi e le acquemarine. Nel 1798 Vauquelin affermò che c’era un elemento in comune tra lo smeraldo e il berillo, cioè l’elemento berillio. L’idea che due materiali diversi, l’uno considerato una gemma preziosa e l’altro un banale sasso, contenessero lo stesso elemento era a quei tempi oltraggiosa. Inizialmente il nuovo elemento fu chiamato «glucina» a causa del suo sapore dolce. Solo nel 1828 il metallo elementare fu isolato a partire dal suo cloruro (BeCl<sub>2</sub>).<br /><br /><h1>Utilizzo</h1>Il berillio metallico è grigiastro, e le sue proprietà chimiche sono simili a quelle dell’alluminio. È leggero, flessibile e ha un alto punto di fusione. Nel 1942 Fermi usò il berillio come sorgente di neutroni nella sua reazione a catena controllata.<br />Il berillio è usato come agente modificante di metalli malleabili.<br />Molti dei componenti usati nei reattori nucleari sono ricoperti o completamente costituiti di ossido di berillio (BeO).<br />Giroscopi, parti di computer, veicoli spaziali e altri strumenti in cui sono necessarie forza e leggerezza sono fatti di composti di berillio; comunque queste componenti sono molto costose, quindi non è il caso di costruirci attrezzi per il garage!<br />","atomic_mass":9,"oxidation_numbers":"+2","melting_temperature":1560,"boiling_temperature":2744,"electronic_configuration":"[He]2s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":111,"first_ionisation_energy":899,"electronegativity":1,"electronic_affinity":"/","density":"1,85 g/mL","discovery_year":1828},{"name":"Boro","number":5,"color":"0x90aa24","group":"semimetal","symbol":"B","image_url":"boro.jpg","image_description":"Uno degli eccipienti dei colliri è l’acido borico, acido debole ad azione disinfettante.","more_text":"<h1>Biologia</h1>I composti del boro sono attualmente in fase di studio in campo medico; possono essere utilizzati come sensori di riconoscimento per carboidrati, per la costruzione di membrane permeabili che permettono il flusso di zuccheri.<br />Alcuni composti del boro sono inclusi in farmaci per lo studio dell’artrite, mentre ricerche più specialistiche includono la terapia per la cattura neutronica del boro e il rilascio di farmaci.<br />I composti di boro e idrogeno sono velenosi, anche in piccole concentrazioni, in quanto colpendo i centri nervosi provocano la morte. L’acido borico e i suoi derivati, anche se apparentemente più innocui, sono molto più pericolosi per il loro largo impiego.<br />L’acido borico, in forma diluita, ha capacità antisettiche.<br /><br /><h1>Scienze della Terra</h1>Il boro è un elemento poco abbondante ma abbastanza diffuso. I minerali più comuni sono Na<sub>2</sub>B<sub>4</sub>O<sub>7</sub> ·10H<sub>2</sub>O, chiamato borace, e Na<sub>2</sub>B<sub>4</sub>O<sub>7</sub> ·4H<sub>2</sub>O, chiamato kernite.<br />Gli Stati Uniti e la Turchia sono i più grandi produttori di boro. Questo elemento non è presente in natura nella sua forma elementare, ma si trova combinato nel borace, nella sassolite, nella colemanite, nella kernite e nei borati. L’acido borico si può trovare nelle sorgenti d’acqua vulcaniche. Alcuni minerali di boro possiedono per natura le proprietà delle fibre ottiche, cioè permettono la diffusione della luce.<br />I soffioni boraciferi, presenti per esempio in Toscana nella località di Larderello, sono strutture vulcaniche secondarie che permettono ai gas che si sprigionano nel magma (tra cui vapore acqueo, acido borico e ammoniaca) di salire in superficie. Questi gas possono raggiungere una temperatura di 230 °C e una pressione di 20 atmosfere. Di conseguenza questi gas sono stati sfruttati, a Larderello per la prima volta nel mondo, per la trasformazione di energia geotermica (prodotta dalla Terra) in energia elettrica. Attualmente infatti le centrali prelevano il vapore che fuoriesce dal suolo e lo convogliano in turbine e alternatori. L’acido borico viene estratto dai fanghi dei cosiddetti lagoni; il primo industriale che nel 1827 perfezionò questa procedura di estrazione fu il francese Larderel, da cui prende nome la località.<br /><br /><h1>Storia</h1>Il boro prende nome dall’arabo «buraq» e dal persiano «burah» (cioè «borace»), ed è conosciuto da migliaia di anni; nell’antico Egitto, il processo di mummificazione dipendeva da un materiale conosciuto come «natron», che conteneva borati e altri sali comuni. Glasse di borace erano usate in Cina dal 300 d.C., e composti di boro erano usati per la fabbricazione del vetro nell’antica Roma.<br />L’elemento venne isolato nel 1808 da Davy, Gay-Lussac e Thénard, che però non furono in grado di riconoscerlo; solo nel 1824 Berzelius identificò il boro come elemento. Il boro fu ottenuto puro solo nel 1909, non essendo di facile preparazione; i primi metodi impiegati utilizzavano la riduzione dell’ossido di boro con metalli quali il magnesio o l’alluminio. Comunque il prodotto era quasi sempre contaminato. L’elemento puro può essere preparato riducendo alogenati di boro volatili con l’idrogeno ad alte temperature.<br /><br /><h1>Utilizzo</h1>Il borace (Na<sub>2</sub>B<sub>4</sub>O<sub>7</sub> ·10H<sub>2</sub>O) è usato nella produzione di isolanti e candeggianti.<br />Il borazone (BN), che è elettronicamente simile al carbonio, può essere utilizzato per la costruzione di materiali duri e resistenti, con struttura simile al diamante, o lubrificanti, simili alla grafite.<br />A causa del colore verde della fiamma, il boro allo stato amorfo è usato per i fuochi d’artificio.<br />In ambito spaziale il boro è utilizzato sotto forma di idruro come carburante per razzi, mentre in ambito nucleare l’isotopo <sup>1</sup><sup>0</sup>B è usato per gli schermi contro le radiazioni e per la radioterapia a cattura neutronica.<br />Sono infine da citare i boruri metallici, ottenibili in genere per combinazione diretta del boro con un altro elemento chimico ad alte temperature. Si tratta di sostanze altamente refrattarie, con elevato punto di fusione (> 2000 °C), e per questa ragione trovano impiego nella costruzione di crogioli, camicie di camere di costruzione, parti di turbine sottoposte a sollecitazioni termiche continue e strumenti da taglio ad alte velocità.<br />Nell’industria nucleare l’acido borico è molto usato come veleno neutronico per la regolazione di potenza dei reattori nucleari a fissione; questo è dovuto alla sua grande sezione d’urto per la cattura dei neutroni.<br />","atomic_mass":10,"oxidation_numbers":"+3","melting_temperature":2350,"boiling_temperature":4275,"electronic_configuration":"[He]2s<sup>2</sup>2p<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":80,"first_ionisation_energy":801,"electronegativity":2,"electronic_affinity":0,"density":"2,47 g/mL","discovery_year":1808},{"name":"Carbonio","number":6,"color":"0xadb293","group":"nonmetal","symbol":"C","image_url":"carbonio.jpg","image_description":"Il diamante è carbonio organizzato in una perfetta struttura cristallina.","more_text":"<h1>Biologia</h1>Il carbonio è l’elemento più abbondante dopo l’idrogeno nei composti organici, che per definizione hanno sempre uno «scheletro» di atomi di carbonio che si combina con altri elementi. I composti più piccoli, chiamati unità monomeriche, sono zuccheri, aminoacidi, nucleotidi e acidi grassi. Ognuna di queste unità si lega con altre uguali per formare strutture più grandi: per esempio gli atomi di carbonio degli zuccheri si legano per formare polisaccaridi, come l’amido. Oppure un atomo di carbonio di un aminoacido si lega con un atomo di azoto di un altro per dar vita alle proteine; o ancora il carbonio di un nucleotide si può legare ad altri per formare il DNA (acido deossiribonucleico) o l’RNA (acido ribonucleico) dei cromosomi; infine, il carbonio degli acidi grassi si lega per formare i fosfolipidi delle membrane cellulari, necessari per mantenere la struttura e l’attività delle cellule.<br />Quindi il nostro corpo ma anche quello delle piante e degli animali, è formato essenzialmente da molecole che contengono carbonio.<br />In più anche quando respiriamo, durante l’espirazione, il nostro fiato contiene una grande quantità di anidride carbonica.<br /><br /><h1>Scienze della Terra</h1>Il carbonio è un solido allotropico, cioè può presentarsi sotto varie forme cristalline. Le più comuni sono la grafite, il diamante e il carbone. Ognuna di queste forme ha una struttura differente.<br />Lo stato cristallino della grafite ha una forma esagonale planare, in cui gli atomi sono disposti in piani paralleli e leggermente sfalsati. La forza che tiene insieme i piani è molto debole, perciò la grafite risulta un solido leggero,viscido e scalfibile.<br />La stato cristallino del diamante è una struttura tridimensionale molto stabile, in cui un atomo di carbonio è circondato da altri quattro disposti ai vertici di un tetraedro (quattro facce triangolari). I legami tra gli atomi sono molto forti, quindi il diamante risulta una struttura molto dura e difficile da scalfire.<br />Il carbonio allo stato di polvere, cioè il carbone, ha una struttura simile alla grafite.<br />Nelle ultime decine di anni si è fatta forte la preoccupazione per il riscaldamento globale della Terra, causato tra le altre cose dalla presenza eccessiva di anidride carbonica nell’atmosfera. Questo composto, che contiene carbonio e ossigeno, viene in piccola quantità prodotto dal nostro respiro, ma la quantità eccessiva deriva dalla combustione della benzina e del carbon fossile, nonché dalla distruzione dei legni delle foreste.<br />Connessa con il riscaldamento globale è anche la distruzione dello strato di ozono dell’atmosfera, che protegge il nostro corpo dalle radiazioni ultraviolette del Sole, che possono causare il cancro alla pelle.<br /><br /><h1>Astronomia</h1>Il carbonio esiste nello spazio, ma non in grandi quantità. Quando le stelle invecchiano e raggiungono lo stadio di giganti rosse, le reazioni nucleari nel nucleo della stella producono carbonio, che viene espulso come gas e polvere. Gli scienziati credono che altre forme di vita nell’Universo potrebbero anch’esse essere costituite essenzialmente da carbonio. I tipi di molecole che potrebbero favorire lo sviluppo di nuovi esseri viventi sono facilmente rintracciabili, e il carbonio è l’unico elemento che conosciamo che può generare queste molecole. Quando gli scienziati cercano di capire se su un pianeta può esserci vita o no, la prima cosa che guardano è la quantità di carbonio sul pianeta.<br /><br /><h1>Storia</h1>Il carbonio allo stato elementare è conosciuto fin dalla preistoria sotto forma di grafite e carbone. Le popolazioni antiche lo producevano bruciando materiale organico con poco ossigeno. I diamanti sono considerati da sempre rari e stupendi. L’ultimo allotropo del carbonio, il fullerene, è stato scoperto come sottoprodotto di esperimenti con i raggi molecolari negli anni Ottanta.<br /><br /><h1>Utilizzo</h1>Siccome il carbonio si trova in varie forme, è naturale che abbia anche vari utilizzi.<br />La grafite, che è la struttura più comune del carbonio, viene utilizzata come mina per i lapis. Ultimamente le fibre di grafite sono usate anche come materiale primario o come fibra di rinforzo nella produzione di mazze da hockey e nei rivestimenti, interni o esterni, delle auto sportive o di quelle da corsa, sia per la sua resistenza che per la sua leggerezza.<br />Il diamante, oltre che come gemma ornamentale per gioielli, viene utilizzato come punta dura, per esempio per incisioni o per tagliare il vetro.<br />Il carbone sotto forma di polvere è stato usato come colore nero su alcuni quadri. Il carbon fossile ha come uso principale la produzione di calore da reazioni di combustione e viene aggiunto in piccole quantità nella produzione dell’acciaio e della ghisa, modificando le proprietà strutturali della lega.<br />L’isotopo radioattivo <sup>1</sup><sup>4</sup>C viene invece usato nella datazione dei reperti archeologici: esso si trasforma in <sup>1</sup><sup>4</sup>N mediante un processo di decadimento, quindi nel corpo andrebbe a scomparire se non venisse reintegrato. Questo isotopo è presente legato all’ossigeno in quantità costante sotto forma di anidridvide carbonica e quindi viene assorbito continuamente durante la respirazione; di conseguenza finché un individuo è vivo la sua concentrazione di <sup>1</sup><sup>4</sup>C rimane costante. Quando l’individuo muore, e quindi non respira più, la concentrazione di <sup>1</sup><sup>4</sup>C diminuisce a un ritmo costante, che dipende dal tempo di dimezzamento dell’isotopo (5730 anni). Conoscendo la concentrazione di <sup>1</sup><sup>4</sup>C in un dato reperto è perciò possibile risalire alla sua età.<br />","atomic_mass":12,"oxidation_numbers":"+2 ±4","melting_temperature":3800,"boiling_temperature":3800,"electronic_configuration":"[He]2s<sup>2</sup>2p<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":77,"first_ionisation_energy":1086,"electronegativity":2,"electronic_affinity":1,"density":"2,26 g/mL","discovery_year":"Noto fin dall’antichità"},{"name":"Azoto","number":7,"color":"0xadb293","group":"nonmetal","symbol":"N","image_url":"azoto.jpg","image_description":"L’azoto è il principale componente di concimi e fertilizzanti chimici impiegati in agricoltura.","more_text":"<h1>Biologia</h1>L’azoto è fondamentale per la vita sulla Terra. È conservato e usato non come azoto elementare, ma come molecole diatomiche. I sistemi biologici, come le piante e i funghi, utilizzano il processo di fissazione dell’azoto, in cui l’azoto elementare viene trasformato in composti contenenti azoto. Le piante usano questi composti e successivamente li depositano nel terreno. Escrementi e decomposizione di animali e piante morte riportano altro azoto nel terreno, rendendolo ricco e quindi migliore per la vita delle piante.<br />L’azoto presente nell’aria e che viene respirato si dissolve lentamente nel sangue e nei liquidi del corpo di tutti i mammiferi. Ma se la pressione esterna aumenta, aumenta anche il quantitativo di azoto disciolto. Se invece la pressione viene rapidamente ridotta, come quando si torna bruscamente in superficie dopo un’immersione, possono generarsi malattie da decompressione note come «male del palombaro». Bolle di azoto escono dalla soluzione del flusso di sangue e fluiscono nei tessuti, causando paralisi, spasmi, intorpidimento, nausea e difficoltà nella parola. Se le bolle di azoto si fermano nelle articolazioni si genera un dolore molto forte.<br /><br /><h1>Composti</h1>L’idrogeno reagisce con l’azoto per dare un composto noto con il nome di ammoniaca. Questa è costituita da molecole di struttura tetragonale con angolo di 107,8°, minore di 109° a causa della presenza di una coppia di non legame. È solubile in acqua in quanto forma legami ponte idrogeno, e genera una base nota col nome di idrossido di ammonio.<br />L’acido nitrico (HNO<sub>3</sub>) è un liquido incolore caratterizzato da legami ponte idrogeno. Ha un carattere molto acido ed è un forte ossidante.<br /><br /><h1>Scienze della Terra</h1>L’azoto rappresenta il 78% del gas presente sulla Terra. Solo il 20% di ciò che si respira è ossigeno: il resto è soprattutto azoto, che viene semplicemente espirato. L’azoto può essere trovato nei gas dei vulcani e in alcune acque minerali.<br />Mentre nella crosta terrestre sono presenti solo alcuni sali di azoto, altri, come il nitrato di sodio (NaNO<sub>3</sub>) e il nitrato di potassio (KNO<sub>3</sub>), sono aggiunti dall’uomo come fertilizzante.<br /><br /><h1>Astronomia</h1>Come anche l’ossigeno elementare, alcuni composti contenenti azoto formano eccellenti combustibili per razzi, che hanno permesso di esplorare lo spazio. In più l’azoto libero si può trovare in molte meteoriti.<br /><br /><h1>Storia</h1>Rutherford, all’epoca uno studente di medicina di Edimburgo, viene considerato lo scopritore dell’azoto. Nel 1772 Rutherford mostrò che eliminando O<sub>2</sub> e CO<sub>2</sub> dall’aria rimaneva un terzo gas. Successivamente dimostrò che questo nuovo elemento non è necessario per la vita e non può essere bruciato. L’azoto elementare viene preparato industrialmente separandolo dai componenti dell’atmosfera mediante liquidazione e distillazione frazionata dell’aria.<br /><br /><h1>Utilizzo</h1>L’azoto elementare (in forma liquida) è usato negli strumenti criogenici per alimenti congelati, ed è il refrigerante usato quando vengono trasportati materiali termodegradabili. Attraverso il processo Haber-Bosch, grandi quantità di azoto gassoso vengono mescolate con idrogeno per produrre ammoniaca (NH<sub>3</sub>), un gas incolore con un forte odore. L’ossido di azoto, generalmente conosciuto come gas esilarante, è spesso usato come anestetico.<br />","atomic_mass":14,"oxidation_numbers":"+2 ±3 +4 +5","melting_temperature":63,"boiling_temperature":77,"electronic_configuration":"[He]2s<sup>2</sup>2p<sup>3</sup>","standard_physical_state":"Gas","atomic_radius":74,"first_ionisation_energy":1402,"electronegativity":3,"electronic_affinity":"/","density":"1,25 g/L","discovery_year":1772},{"name":"Ossigeno","number":8,"color":"0xadb293","group":"nonmetal","symbol":"O","image_url":"ossigeno.jpg","image_description":"L\'ossigeno è prodotto dalle piante durante la fotosintesi clorofilliana, come si può vedere dalle bollicine di gas sulla foglia nella foto.","more_text":"<h1>Biologia</h1>Gli animali respirano ossigeno ed espellono nell’aria anidride carbonica, che a sua volta viene catturata e utilizzata da alghe e piante verdi. Mediante la fotosintesi clorofilliana questi convertono CO<sub>2</sub> in carboidrati e ossigeno. Noi esseri umani necessitiamo di ossigeno affinché le nostre cellule trasformino il cibo in energia per le nostre attività quotidiane.<br /><br /><h1>Composti</h1>Gli ossidi sono composti binari di ossigeno con metalli. Quelli del I, II e parte del III gruppo sono ossidi ionici contenenti lo ione O<sup>2</sup>¯. Hanno comportamento basico, o al limite anfotero, in acqua.<br />Le anidridi sono composti binari di ossigeno con non metalli. Sono tutte molecole con legami covalenti, e la maggior parte si trova allo stato gassoso. Hanno un comportamento acido in acqua.<br />L’acqua è il composto più importante dell’ossigeno. Le caratteristiche e le proprietà fisiche dell’acqua dipendono fondamentalmente dalla maggiore elettronegatività dell’ossigeno rispetto all’idrogeno; questo fa sì che l’ossigeno abbia una carica debolmente negativa, e che perciò possa formare legami ponte idrogeno con altre molecole. Nella fase liquida ogni molecola interagisce in media con altre due o tre, in funzione della temperatura; allo stato solido invece ciascuna molecola è legata ad altre quattro ai vertici di un tetraedro, generando una struttura meno densa (per questo il ghiaccio galleggia sull’acqua liquida).<br /><br /><h1>Scienze della Terra</h1>L’ossigeno si trova in natura allo stato gassoso; comunque quando viene raffreddato a -218,79 °C l’ossigeno forma un reticolo cristallino cubico. In realtà esistono due forme allotropiche, la diatomica (O<sub>2</sub>) e la triatomica (O<sub>3</sub>, l’ozono).<br />L’ossigeno è l’elemento più abbondante della crosta terrestre: costituisce infatti circa la metà della massa della Terra. Generalmente si trova negli ossidi metallici, come l’ossido di ferro (III) Fe<sub>2</sub>O<sub>3</sub>, conosciuto come ruggine, e l’ossido di titanio (IV) TiO<sub>2</sub>, che è usato come pigmento bianco in molti prodotti, a partire dalla vernice fino al dentifricio.<br />L’ozono è un composto che contiene tre atomi di ossigeno: è presente nella stratosfera terrestre, dove assorbe le radiazioni solari ultraviolette.<br />La recente riduzione dello strato di ozono ha creato molti problemi atmosferici, come l’aumento delle radiazioni ultraviolette, che causano gravi scottature e possono provocare il cancro della pelle.<br /><br /><h1>Astronomia</h1>L’ossigeno è secondo solo all’azoto come presenza nell’atmosfera terrestre, ed è il terzo elemento più abbondante nell’universo. L’ossigeno può essere trovato in tutti i pianeti sotto forma di ossido metallico; per esempio la crosta di Marte è fondamentalmente formata da ossido di ferro (III). Una miscela di ossigeno e idrogeno liquidi è usata come carburante per razzi: infatti richiede soltanto una scintilla come innesco, ed è perciò una fonte di calore efficiente e pulita, che genera come unico prodotto l’acqua.<br /><br /><h1>Storia</h1>L’ossigeno è stato identificato come elemento nel 1774 dal chimico svedese Scheele e dall’inglese Priestley, indipendentemente l’uno dall’altro. Scheele e Priestley isolarono l’ossigeno riscaldando alcuni ossidi: per esempio la reazione dell’ossido di mercurio è<br />2HgO → O<sub>2</sub> + 2Hg<br />Successivamente Lavoisier dimostrò che questo gas era contenuto nell’aria, e lo chiamò «ossigeno», che significa «generatore di acido», perché credeva che questa sostanza generasse tutti gli acidi.<br /><br /><h1>Utilizzo</h1>L’ossigeno elementare è fondamentale nella vita della maggior parte degli esseri viventi, compreso l’uomo; infatti le cellule hanno bisogno di ossigeno per generare energia e vivere in salute, tanto che senza di esso muoiono nel giro di pochi minuti.<br />Anche l’industria utilizza l’ossigeno, per esempio nel processo di formazione dell’acciaio.<br />Questo gas è usato anche in bombole per usi sottomarini o ospedalieri.<br />","atomic_mass":16,"oxidation_numbers":"-2","melting_temperature":54,"boiling_temperature":90,"electronic_configuration":"[He]2s<sup>2</sup>2p<sup>4</sup>","standard_physical_state":"Gas","atomic_radius":74,"first_ionisation_energy":1314,"electronegativity":3,"electronic_affinity":1,"density":"1,43 g/L","discovery_year":1774},{"name":"Fluoro","number":9,"color":"0xbcb891","group":"alogeni","symbol":"F","image_url":"fluoro.jpg","image_description":"Il fluoro è uno dei componenti più importanti dei dentifrici, grazie alla sua capacità di fissarsi allo smalto dei denti rinforzandolo.","more_text":"<h1>Biologia</h1>La maggior parte della gente associa il fluoro all’odontoiatria, tuttavia può avere molti altri utilizzi. Il gas in sé e per sé è tossico, ma i suoi composti sono molto versatili. Il fluoruro di sodio è molto utilizzato nell’ambito dell’odontoiatria, e soprattutto in molti dentifrici anticarie. Inoltre viene aggiunto all’acqua potabile per migliorare l’igiene orale. Questo composto infatti genera un sottoprodotto chiamato fluorapatite che contribuisce a mantenere i denti sani.<br />Il fluoro è usato in nuovi medicinali antidepressivi, in quanto riesce a mantenere nei giusti livelli la serotonina.<br />Il fluorodeossiglucosio, analogo del glucosio, è usato nell’imaging biomedico, come radiotracciante in una tecnica moderna chiamata tomografia a emissione di positroni (PET). Questa molecola contiene l’isotopo <sup>1</sup><sup>8</sup>F che, essendo radioattivo, emette positroni; essendo omologa del glucosio si introduce con facilità in organi come il rene, il cervello o il cuore, oppure nelle masse tumorali. Permette così un’analisi senza controindicazioni, in quanto il glucosio viene metabolizzato senza radioattività.<br /><br /><h1>Scienze della Terra</h1>Il fluoro, a causa della sua elevata reattività, non si trova libero in natura, tranne che in piccole tracce nei materiali radioattivi; si trova invece combinato con altri elementi, e in tutto costituisce circa lo 0,065% della crosta terrestre. In natura il fluoro si trova comunemente come ione fluoruro (F¯), in particolare nella fluorite e nella fluorapatite. Rappresenta il tredicesimo elemento più abbondante nella crosta terrestre, in cui 950 p.p.m. sono di fluoro.<br />I fluoruri di idrogeno possono essere rilasciati attraverso processi di combustione industriale. I fluoruri che si trovano nell’aria scendono nel terreno o nell’acqua quando sono legati a cationi piuttosto grandi, altrimenti rimangono sospesi anche per lunghi periodi.<br /><br /><h1>Storia</h1>Il fluoro prende il suo nome dal latino «fluere», che significa «fluire»; in forma di fluorite venne descritto nel 1529 da Agricola per il suo uso come sostanza che favorisce la fusione di metalli o minerali.<br />Nel 1670 Schwandhard scoprì che il vetro veniva inciso se esposto alla fluorite trattata con acido; alcuni degli esperimenti condotti successivamente con l’acido fluoridrico finirono in tragedia.<br />Il fluoro non fu isolato fino a molti anni più tardi, perché quando viene separato da un composto attacca immediatamente i materiali delle apparecchiature con cui viene realizzata la sintesi.<br />Nel 1886 lo scienziato francese Moissan isolò per la prima volta il fluoro elementare applicando un metodo originariamente proposto senza successo da Davy e Ampère. Moissan realizzò l’elettrolisi di acido fluoridrico anidro, contenente tracce di fluoruro di potassio, in una cella di platino con elettrodi di platino-iridio.<br /><br /><h1>Utilizzo</h1>In chimica organica il legame C-F è uno dei legami più forti; questo fatto contribuisce in modo significativo all’elevata inerzia chimica tipica di queste molecole.<br />I composti del fluoro trovano uso in liquidi refrigeranti, come il freon: infatti gli idrofluoroclorocarburi sono stati usati massicciamente negli impianti di aria condizionata e nella refrigerazione, ma oggi questi composti sono vietati perché sospettati di contribuire alla formazione del buco nell’ozono.<br />Si usano anche nei medicinali, in cui moltiplicano l’efficacia terapeutica e contemporaneamente ritardano la metabolizzazione del principio attivo: si stima che circa il 20% dei prodotti farmaceutici attualmente in commercio contenga uno o più atomi di fluoro.<br />Il fluoro è anche alla base del funzionamento del gas nervino, che costituì il primo impiego di composti chimici fluorurati per scopi militari. Era in grado di rilasciare nell’organismo considerevoli quantità di fluoruro, che portano a un effetto bloccante sull’attività enzimatica e sul sistema nervoso centrale.<br />I composti del fluoro possono inoltre incidere il vetro delle lampadine o di altri prodotti, per produrre vetro smerigliato.<br />Il fluoro è anche alla base della produzione di esafluoruro di uranio (UF<sub>6</sub>), che viene centrifugato allo stato gassoso e fatto passare attraverso pareti semipermeabili, arricchendo in tal modo l’uranio naturale in <sup>2</sup><sup>3</sup><sup>5</sup>U. Questo processo tecnologico genera un rifiuto «speciale», il fluoro radioattivo, che è impossibile smaltire o trattare.<br />Il fluoro si usa anche come insetticida e a volte, in varie combinazioni, come anticarie nei dentifrici e nei colluttori.<br />","atomic_mass":19,"oxidation_numbers":"-1","melting_temperature":54,"boiling_temperature":85,"electronic_configuration":"[He]2s<sup>2</sup>2p<sup>5</sup>","standard_physical_state":"Gas","atomic_radius":71,"first_ionisation_energy":1681,"electronegativity":3,"electronic_affinity":3,"density":"1,70 g/L","discovery_year":1886},{"name":"Neon","number":10,"color":"0xadccdc","group":"gas","symbol":"Ne","image_url":"neon.jpg","image_description":"L’impiego più comune del neon è nella produzione di insegne e tubi luminosi.","more_text":"<h1>Biologia</h1>Non sono conosciuti usi biologici del neon, in quanto è molto difficile per qualsiasi organismo usare questo gas. Come l’ossigeno e l’idrogeno può essere incorporato in molecole non gassose per scopi biologici. È possibile che respirare neon causi asfissia e morte.<br /><br /><h1>Scienze della Terra</h1>Incolore, inodore, insapore e più leggero dell’aria, il neon è il quinto elemento più comune nell’atmosfera terrestre. Il gas neon in piccolissime quantità è intrappolato anche nelle rocce della crosta terrestre.<br /><br /><h1>Astronomia</h1>Il neon è il quarto elemento in abbondanza nello spazio: ci sono 8,6 atomi di neon ogni 40 000 atomi di idrogeno.<br />Puntando uno spettrometro nello spazio, i ricercatori hanno notato che parte dello spettro non apparteneva a nessun elemento conosciuto. A causa di ciò, gli scienziati teorizzarono l’esistenza dei gas nobili: elio, neon, argon, kripton, xenon e radon.<br />Il neon può essere osservato nello spazio; ha uno spettro visibile (cioè emette luce visibile se eccitato) che può essere visto con estrema facilità. Tutte le lunghezze d’onda di emissione del neon cadono nella regione del rosso, ed è l’intenso colore rosso che si usa nei puntatori, nelle lampade o nei laser.<br /><br /><h1>Storia</h1>Nel 1898 Ramsay e Travers scoprirono il neon, il cui nome deriva dal greco «neos», che significa «nuovo». Raffreddarono l’aria, miscela omogenea di tanti gas, fino a raggiungere lo stato liquido di alcuni componenti come l’ossigeno e l’azoto, che hanno temperature di condensazione più alte. Rimasero allo stato gassoso idrogeno e neon; successivamente l’idrogeno venne ossidato a contatto con carbone attivo, producendo acqua che venne eliminata per condensazione; perciò solo il neon rimase allo stato gassoso.<br />A causa della sua stabilità e della sua scarsa velocità di reazione, il neon è uno degli elementi chiamati gas nobili. I gas nobili non sono stati identificati se non dopo molti metalli di transizione, sebbene fossero più presenti sulla Terra. La loro scoperta si deve alla messa a punto di nuove tecnologie di raffreddamento.<br /><br /><h1>Utilizzo</h1>Essendo inerte (cioè non potendosi combinare con altri elementi), non ci sono molti usi per il neon. L’area in cui trova più impiego è quello delle luci al neon. Quando una scarica elettrica passa attraverso un tubo di vetro pieno di neon, il gas emette una luce rossa intensa. Questi tubi possono essere costruiti e utilizzati facilmente.<br />Il neon è utilizzato anche come mezzo attivo per alcuni laser.<br />","atomic_mass":20,"oxidation_numbers":"/","melting_temperature":25,"boiling_temperature":27,"electronic_configuration":"[He]2s<sup>2</sup>2p<sup>6</sup>","standard_physical_state":"Gas","atomic_radius":"/","first_ionisation_energy":2081,"electronegativity":"/","electronic_affinity":"/","density":"0,90 g/L","discovery_year":1898},{"name":"Sodio","number":11,"color":"0xca6b18","group":"metal","symbol":"Na","image_url":"sodio.jpg","image_description":"Il sodio in una delle sue applicazioni più comuni: come sale da cucina.","more_text":"<h1>Biologia</h1>Il sodio, insieme ad alcuni altri metalli leggeri, è un elemento indispensabile, seppure in piccole quantità, alla vita degli organismi. Assume un ruolo fondamentale nella regolazione dei processi di trasmissione delle informazioni nelle cellule nervose. Tuttavia, elevate assunzioni di sodio, per esempio sotto forma di sale da cucina, possono causare alterazioni dell\'equilibrio idro-salino con conseguenti ripercussioni sulla pressione sanguigna e sul funzionamento dei reni.<br /><br /><h1>Scienze della Terra</h1>L’ossido di sodio (Na<sub>2</sub>O) è uno dei più comuni composti della crosta terrestre, con un’abbondanza di 4500 ppm.<br />Comunque la maggior parte delle persone associa la parola «sodio» al sale da cucina, che è un suo composto detto cloruro di sodio. È raro nella crosta terrestre, ma si può trovare in grande quantità nell’acqua di mare e dell’oceano. L’acqua di mare è salata proprio perché in essa c’è una gran quantità di cloruro di sodio disciolto. La sua solubilità in acqua è di circa 360 g in un litro.<br /><br /><h1>Astronomia</h1>Il sodio è presente negli oggetti celesti; anche sul nostro satellite, la Luna, sono state riscontrate bassissime concentrazioni di sodio che formano un leggerissimo involucro che ne avvolge la superficie. Pare provenga dalla stessa superficie a seguito dell\'impatto provocato dal vento solare.<br /><br /><h1>Storia</h1>Il sodio è un metallo molto morbido, di colore bianco argenteo, che non esiste allo stato libero in natura. Il sodio elementare reagisce violentemente con l’acqua per generare idrogeno (che può esplodere a causa del calore di reazione) e idrossido di sodio. Si ossida facilmente all\'aria. Generalmente viene mantenuto sotto etere di petrolio per evitare il contatto con l\'umidità dell\'aria.<br />Il sodio elementare fu isolato e identificato nel 1807 da Davy; il nome dell’elemento deriva dal nome di uno dei suoi composti più comuni, la soda (Na<sub>2</sub>CO<sub>3</sub>). Il simbolo dell’elemento (Na) deriva da «natrium», nome medioevale del carbonato di sodio.<br />Il sodio elementare viene prodotto per riduzione elettrochimica di una micela di NaCl e CaCl<sub>2</sub>.<br /><br /><h1>Utilizzo</h1>Il sodio è commercialmente importante come componente del cloruro di sodio, o comune sale da cucina. Il sodio è in più un elemento dell’idrossido di sodio (NaOH), chiamato comunemente soda caustica (da non confondere con la soda, Na<sub>2</sub>CO<sub>3</sub>), che è usato nel lavaggio dei capi, nella fabbricazione dei saponi e nella produzione del cellofan e della carta. Il nitrato di sodio (NaNO<sub>3</sub>) è un componente della dinamite. Il solfato di sodio (Na<sub>2</sub>SO<sub>4</sub>) è usato nella produzione di cartoni, vetri e detergenti. I fotografi usano il tiosolfato di sodio (Na<sub>2</sub>S<sub>2</sub>O<sub>3</sub>) per fissare lo sviluppo di negativi e foto. Il bicarbonato di sodio (NaHCO<sub>3</sub>) è usato nella cottura e negli estintori a secco.<br />","atomic_mass":22,"oxidation_numbers":"+1","melting_temperature":371,"boiling_temperature":1156,"electronic_configuration":"[Ne]3s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":186,"first_ionisation_energy":496,"electronegativity":0,"electronic_affinity":0,"density":"0,97 g/mL","discovery_year":1807},{"name":"Magnesio","number":12,"color":"0xffedbc","group":"metalc","symbol":"Mg","image_url":"magnesio.jpg","image_description":"Per la sua resistenza e leggerezza, il magnesio è utilizzato per la produzione dei «cerchi in lega» per le ruote delle auto.","more_text":"<h1>Biologia</h1>I sali di magnesio sono necessari per la fotosintesi (sono costituenti fondamentali della clorofilla) e per la sintesi di diverse biomolecole, tra cui proteine e acidi nucleici; lo ione magnesio (Mg<sup>2</sup><sup>+</sup>), se sciolto in soluzione può legare cariche negative o molecole elettronegative.<br />Quando Mg<sup>2</sup><sup>+</sup> si lega a una proteina, ne cambia la conformazione rendendola adatta ad una specifica funzione biologica. Quando si separa, la proteina ritorna allo stato originale. Viene pertanto definito un attivatore di proteine.<br />Negli animali, il magnesio è implicato in diversi processi metabolici essenziali, come la formazione dell\'urea e la trasmissione degli impulsi nervosi e muscolari.<br /><br /><h1>Scienze della Terra</h1>Il magnesio è l’ottavo elemento più abbondante e costituisce il 2% della crosta terrestre. È anche il terzo elemento tra quelli disciolti nell’acqua di mare. Ogni chilometro cubo di acqua contiene più di un milione di tonnellate di magnesio in forma di sale. La via più comune per estrarre il magnesio è tramite evaporazione dell’acqua di mare.<br />È presente nella crosta terrestre sotto forma di magnesite, MgCO<sub>3</sub>, e di dolomite, un minerale carbonato misto di Ca e Mg.<br /><br /><h1>Astronomia</h1>Com’è abbondante nella crosta terrestre e nel mare, il magnesio è presente anche nello spazio. La superficie della Luna contiene magnesio, e l’ossido di magnesio è stato trovato in un meteorite proveniente da Marte e ritrovato in Antartide.<br /><br /><h1>Storia</h1>Nel 1618 un contadino di Epsom, in Inghilterra, scoprì che l’acqua di un particolare pozzo aveva un gusto amaro. Quando tagli e graffi venivano lavati con quest’acqua amara, guarivano molto velocemente. Le conoscenze mediche erano molto limitate a quei tempi, così le acque minerali erano ritenute avere un potere curativo di malattie e lesioni. Il minerale disciolto nell’acqua era il solfato di magnesio, che prese perciò il nome di «sale di Epsom». Fu Josef Black, nel 1775 a identificare il magnesio come elemento attraverso esperimenti quantitativi sulla «magnesia alba», una miscela di idrossido e di carbonato di magnesio.<br />Nel 1855, Davy fece passare una corrente elettrica attraverso un miscuglio di ossido di magnesio (MgO, noto come «magnesia» che prende il nome da una regione della Grecia) e ossido di mercurio (HgO). L’elettricità divise la magnesia in ossido e in amalgama, un miscuglio di magnesio e mercurio. Davy distillò successivamente il mercurio dall’amalgama per isolare il magnesio.<br /><br /><h1>Utilizzo</h1>Il magnesio è un metallo bianco argenteo, con un terzo della densità dell’alluminio. Il magnesio viene usato in polvere per flash fotografici. Poiché il magnesio puro è molto morbido, è generalmente mescolato con metalli duri come alluminio e zinco.<br />L’aggiunta di magnesio a queste leghe le rende più facili da lavorare e modellare: le leghe al magnesio sono infatti usate per aerei, navicelle spaziali, automobili e congegni comuni.<br />","atomic_mass":24,"oxidation_numbers":"+2","melting_temperature":923,"boiling_temperature":1363,"electronic_configuration":"[Ne]3s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":160,"first_ionisation_energy":738,"electronegativity":1,"electronic_affinity":0,"density":"1,74 g/mL","discovery_year":1755},{"name":"Alluminio","number":13,"color":"0x7d933a","group":"postmetal","symbol":"Al","image_url":"alluminio.jpg","image_description":"Comuni lattine per bevande, costituite interamente di alluminio.","more_text":"<h1>Biologia</h1>L’alluminio elementare non esiste negli organismi viventi a causa del fatto che contengono un gran quantitativo di acqua. Infatti l’alluminio in acqua genera l’idrossido di alluminio, Al(OH)<sub>3</sub>.<br />Ricerche recenti hanno mostrato che dovrebbe esserci un legame tra l’aumento di alluminio nel cervello e l’aumento delle probabilità della comparsa del morbo di Alzheimer. Anche se questi studi non sono ancora arrivati a uno stadio finale, mostrano comunque che le persone che hanno questa malattia a uno stadio avanzato hanno grandi depositi di Al e Cu nel loro cervello. Chiaramente, devono essere condotti ancora studi sul perché l’alluminio crei questa disfunzione o perché sia collegato a essa.<br />L’alluminio elementare non è tossico per l’uomo: infatti molti recipienti e stoviglie sono fatti di questo materiale.<br /><br /><h1>Scienze della Terra</h1>L’alluminio ha una struttura cubica a facce centrate. L’alluminio è raro allo stato elementare a causa della rapida ossidazione ad Al<sub>2</sub>O<sub>3</sub>.<br />L’alluminio è il terzo elemento più abbondante sulla Terra. L’ossido di alluminio o allumina (Al<sub>2</sub>O<sub>3</sub>) si trova in minerali preziosi come rubino, zaffiro e smeraldo. È usato nella produzione di vetro e di ceramica. Quindi, se la richiesta è grande, l’allumina può essere convertita in alluminio elementare e ossigeno mediante elettrolisi; la quantità di corrente elettrica necessaria per questo processo è comunque ingente. In passato circa il 5% di tutta l’elettricità prodotta dagli Stati Uniti era usata per produrre alluminio; questo grosso consumo influisce negativamente sull’inquinamento, tanto che, quando è possibile, l’alluminio si ricicla. Oggi, in Italia, oltre il 48% dell\'alluminio in circolazione proviene dal riciclo, riducendo così del 95% l\'energia consumata per produrlo dal minerale.<br /><br /><h1>Astronomia</h1>L’unico alluminio nello spazio è quello che viene portato dalle navicelle spaziali e dai satelliti; è possibile infatti trovare l’ossido di alluminio vicino ai reattori, come prodotto della loro combustione. Molti razzi infatti bruciano un misto di perclorato di alluminio e alluminio metallico, legati insieme da un polimero gommoso; la maggior parte dell’ossido di alluminio resta vicino alla rampa di lancio e piove a terra. Comunque in alcuni casi si generano piccoli grani, simili a polvere, carichi elettricamente, essendo bombardati dagli elettroni nell’atmosfera. Queste particelle possono interagire con altri veicoli spaziali presenti nelle stesse orbite, come la Stazione spaziale internazionale, che quindi si caricano elettricamente.<br /><br /><h1>Storia</h1>Dal nome latino «alumen» deriva la parola «allume», che indica un sale doppio di alluminio e potassio usato già dagli antichi Greci e Romani come fissatore per colori nell’industria tessile, per le stampe su pergamena, per la concia delle pelli, per la produzione del vetro e, come emostatico, per curare le ferite. Il metallo fu identificato per la prima volta nell’allume, KAl(SO<sub>4</sub>)<sub>2</sub> ·12H<sub>2</sub>O, da Davy, che però non riuscì a isolarlo; propose però il nome aluminum, poi modificato in aluminium. Il primo scienziato a isolare, in forma impura, il metallo fu Ørsted sfruttando la reazione tra l’amalgama di potassio e AlCl<sub>3</sub>; Wöhler è invece accreditato per aver isolato l’alluminio in forma massiva, nel 1827, migliorando il metodo di Ørsted.<br />Sainte-Claire Deville introdusse il metodo di riduzione diretta del metallo per via elettrolitica a partire da NaAlCl<sub>4</sub> fuso, processo studiato in modo indipendente pure da Bunsen. Nel 1886 fu inventato il processo Hall-Héroult, ovvero elettrolisi di allumina disciolta in criolite (NaAlF<sub>4</sub>), che rese economica l’estrazione dell’alluminio dai minerali, ed è comunemente in uso in tutto il mondo.<br /><br /><h1>Utilizzo</h1>L’alluminio è il metallo più importante dopo il ferro ed è usato in molti prodotti di consumo, come i recipienti e i fogli di alluminio.<br />Anche la vita quotidiana ci dice che questi prodotti sono relativamente leggeri: utensili da cucina, raccordi per le costruzioni e aeroplani spesso sono fatti di alluminio.<br />Proprio come nel caso del ferro, le leghe rendono l’alluminio più resistente all’acqua e all’aria.<br />","atomic_mass":26,"oxidation_numbers":"+3","melting_temperature":933,"boiling_temperature":2792,"electronic_configuration":"[Ne]3s<sup>2</sup>3p<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":143,"first_ionisation_energy":578,"electronegativity":1,"electronic_affinity":0,"density":"2,70 g/mL","discovery_year":1825},{"name":"Silicio","number":14,"color":"0x90aa24","group":"semimetal","symbol":"Si","image_url":"silicio.jpg","image_description":"Il silicio è il costituente fondamentale dei microchip delle SIM card e delle celle dei pannelli fotovoltaici.","more_text":"<h1>Biologia</h1>Certi alimenti, come patate, latte, acqua minerale e birra, possono contenere una grande quantità di ossido di silicio. Piccolissime quantità di silicio sono presenti nei tessuti corporei, ma non esiste nessuna evidenza del fatto che esso giochi un ruolo importante nel buon funzionamento del corpo. I reni espellono i silicati assorbiti senza mostrare alcun livello di avvelenamento. Alcune alghe usano il silicio per costruire le pareti delle loro cellule. Il silicio è pericoloso quando inalato: l\'inalazione continuativa di polveri contenenti biossido di silicio (SiO<sub>2</sub>) provoca la silicosi, una malattia che determina insufficienze polmonari anche gravi.<br /><br /><h1>Scienze della Terra</h1>Ci sono due forme solide di silicio; una amorfa, cioè senza struttura cristallina regolare, l’altra cristallina, con un impacchettamento tetragonale simile al diamante. L’aspetto macroscopico dei cristalli di silicio è ottaedrico.<br />In generale il silicio è un atomo tetra-coordinato, cioè è circondato sempre da altri quattro atomi. Nel silicio cristallino questa struttura tetraedrica si ripete su larga scala a formare un reticolo cristallino ordinato.<br />Nel silicio amorfo questo ordine a lungo raggio non è presente, e gli atomi formano un reticolo disordinato e continuo in cui non tutti gli atomi sono tetra-coordinati: quindi alcuni atomi sono disponibili a formare nuovi legami (passivazione con l’idrogeno).<br />Il silicio è il secondo elemento più abbondante nella crosta terrestre dopo l’ossigeno. Non sorprende perciò che il biossido di silicio (SiO<sub>2</sub>) sia il minerale più abbondante nella crosta terrestre. La pietrificazione del legno avviene per l’introduzione invasiva di minerali all’interno delle cavità e delle cellule del legno stesso; questo avviene soprattutto per azione del biossido di silicio. Le foreste pietrificate dell’ovest degli Stati Uniti sono costituite proprio da legno silicificato, in cui il tessuto del legno è sostituito da una struttura cristallina del quarzo, chiamata calcedonio.<br /><br /><h1>Storia</h1>Il nome «silicio» deriva dal latino «silex», che significa «selce». Nel 1824 Berzelius, un chimico svedese, isolò questo elemento trattando la silice (SiO<sub>2</sub>) con acido fluoridrico (HF) e ottenendo il fluoruro di silicio (SiF<sub>4</sub>), un gas nauseante. Quindi fece passare questo gas su potassio ad alta temperatura ottenendo fluoruro di potassio (KF) e silicio elementare amorfo. Non si fu in grado di preparare il silicio allo stato cristallino prima del 1854.<br /><br /><h1>Utilizzo</h1>Quasi tutti i vetri sono composti da SiO<sub>2</sub> che viene scaldata al suo punto di fusione e poi bruscamente raffreddata in contenitori specifici.<br />Trattando il biossido di silicio con idrossido di sodio ad alta temperatura si ottiene una soluzione di silicato di sodio. Questo composto è usato nel sapone, nel trattamento del legno per prevenire il decadimento, nella conservazione delle uova, nella produzione di cemento e nell’ambito della tintoria. Infine il silicio è sfruttato nella produzione industriale del silicone, un polimero utilizzato come lubrificante, come isolante dall’acqua, negli smalti e nelle vernici.<br />Il silicio, grazie alle sue proprietà di semiconduttore, è il materiale di base nei chip dei computer, nei transistor e in altri tipi di circuiti elettronici e di congegni di comunicazione. Le tecnologie moderne usano il silicio ultrapuro, che può essere ulteriormente arricchito quando «drogato», cioè modificato con l’inserimento di arsenico, fosforo, gallio o boro.<br />","atomic_mass":28,"oxidation_numbers":"+2 ±4","melting_temperature":1687,"boiling_temperature":3538,"electronic_configuration":"[Ne]3s<sup>2</sup>3p<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":118,"first_ionisation_energy":786,"electronegativity":1,"electronic_affinity":1,"density":"2,33 g/mL","discovery_year":1824},{"name":"Fosforo","number":15,"color":"0xadb293","group":"nonmetal","symbol":"P","image_url":"fosforo.jpg","image_description":"La testa dei comuni fiammiferi è costituita da fosforo.","more_text":"<h1>Biologia</h1>Il fosforo è un elemento centrale per la vita: forma infatti lo scheletro del DNA e dell’RNA, connettendo le molecole fondamentali per la genetica in lunghe catene. Il fosforo è fondamentale nel metabolismo energetico di ogni cellula, in quanto alcune molecole organiche contenenti fosforo sono in grado di immagazzinare energia e renderla disponibile nei processi biochimici. Pensiamo per esempio all’ATP, o adenosina trifosfato, che è la molecola «energetica» fondamentale di ogni cellula. Questa molecola è formata da tre gruppi fosfato (PO<sup>3</sup><sup>-</sup>)legati tra loro, uno zucchero, il ribosio, e una base azotata, l’adenina. I legami che si formano sono ricchi di energia: tutte le volte che un legame di un gruppo fosfato si rompe, l’energia sviluppata viene usata per un processo biologico. Quando si cammina, le cellule dei muscoli rompono questi legami e creano l’energia necessaria per muoversi.<br />La maggior parte delle molecole di ATP si formano durante la respirazione cellulare, nella fase del ciclo di Krebs in cui il nostro corpo trasforma parte del cibo assunto in energia.<br />Il fosforo è il principale elemento costitutivo del nucleo e del citoplasma cellulare. L’acido fosforico, tra l’altro, è stato individuato come il maggior responsabile dell’aumento dell’osteoporosi nelle donne giovani. In passato soltanto le donne adulte o anziane presentavano questa malattia, soprattutto quelle che non avevano ossa sufficientemente dense. Il corpo si sforza di mantenere costante il rapporto tra gli ioni fosforo e calcio; quando è presente un eccesso di acido fosforico, come per esempio quando si assumono sostanze acide come le bibite a base di cola, il corpo deve pareggiare il rapporto fosforo-calcio estraendo quest’ultimo dalle ossa e quindi indebolendole notevolmente.<br /><br /><h1>Scienze della Terra</h1>Ci sono dieci forme allotropiche di fosforo conosciute in natura, e tre varietà di forme elementari: quella rossa, quella bianca e quella nera. Il fosforo bianco è il prodotto commerciale più comune e ha due forme allotropiche: l’alfa, che è stabile a temperatura ambiente e ha una struttura cristallina cubica; e la beta, che è stabile a temperature inferiori a -78 °C e ha una struttura cristallina esagonale.<br />La più grande risorsa di fosforo sulla Terra sono i minerali di fosfato. Depositi sono presenti in Nord Africa (Marocco, Algeria e Tunisia), negli Stati Uniti (in grande quantità in Florida) e in Russia. La maggior parte del fosforo delle rocce della terra e dei fondali marini viene rilasciato mediante infiltrazioni, estrazioni e azione degli agenti atmosferici.<br />Questo elemento viene anche aggiunto al terreno per mantenerlo fertile e produttivo; l’aggiunta di troppo fosforo ai terreni può però distruggere l’equilibrio naturale. I fertilizzanti contenenti fosforo vengono scaricati in terreni umidi e trasportati dall’acqua in bacini chiusi: una sovrabbondanza di questi materiali causa, per esempio, la crescita spropositata delle alghe, che bloccano il passaggio dell’ossigeno e dei raggi solari, uccidendo la vita sottostante. Negli ultimi anni si è avuto un miglioramento eliminando il flusso di fosfato nei laghi e negli oceani.<br /><br /><h1>Astronomia</h1>Il fosforo è il quinto elemento in ordine di importanza per la biologia, dopo il carbonio, l’idrogeno, l’ossigeno e l’azoto. Ma dove la vita sulla Terra si sia procurata tutto il fosforo necessario rimane un mistero, essendo questo molto più raro degli altri quattro elementi. Scienziati dell’Università dell’Arizona hanno scoperto che alcuni meteoriti, soprattutto quelli contenenti ferro, sono stati fondamentali per l’evoluzione della vita sulla Terra, perché contenevano una grande quantità di fosforo: sufficiente per la formazione di biomolecole, che poi si sono unite e moltiplicate per generare organismi viventi.<br />I meteoriti possono essere formati da numerosi minerali contenenti fosforo: il più importante è il fosfide di ferro e nichel, noto come schreibersite. Si tratta di un composto metallico molto raro sulla Terra, ma molto presente appunto nei meteoriti ferrosi. Gli scienziati hanno mescolato questo minerale con acqua deionizzata e hanno analizzato il miscuglio ottenuto mediante risonanza magnetica. Lo spettro RMN ha mostrato la presenza di P<sub>2</sub>O<sub>7</sub>, che ha una struttura molto simile all’ATP, l’unità fondamentale dell’energia negli esseri viventi.<br /><br /><h1>Storia</h1>Il fosforo è stato scoperto nel 1669 da Brand, un mercante tedesco con l’hobby dell’alchimia. L’alchimia è una scienza medievale che si proponeva di trasformare sostanze comuni in qualcosa di più prezioso, come per esempio il piombo in oro.<br />Brand ha lasciato che 50 campioni di urina arrivassero a decomposizione e che producessero larve. Successivamente bollì l’urina fino a farla diventare una colla e unì al tutto della sabbia; questo miscuglio produsse fosforo elementare, che osservato al buio produceva una luce molto intensa (questa caratteristica è detta appunto «fosforescenza»). Per questo il nome dell’elemento deriva dal greco «phosphoros», che significa «portatore di luce».<br />Il fosforo presenta una curiosità chimica legata al fatto che trattando le ossa con acido nitrico o solforico si produce acido fosforico, che successivamente trattato con carbone genera fosforo.<br />Un’altra curiosità è legata alla formazione dei fuochi fatui: dalla decomposizione organica di piante ed esseri viventi si generano metano e fosfina (PH<sub>3</sub>), che a contatto con l’aria bruciano e formano fiammelle colorate di blu, che quindi si manifestano nei cimiteri o in stagni e paludi.<br /><br /><h1>Utilizzo</h1>Il principale uso del fosforo è nella produzione di fertilizzanti. Si trova però anche negli esplosivi, nei fiammiferi, nei fuochi d’artificio e in vari oggetti che si illuminano al buio.<br />I fosfati sono usati nella produzione di vetri speciali, per esempio per quelli delle lampade al sodio. Il fosfato di calcio è usato per creare oggetti di porcellana fine e per produrre il monofosfato di calcio, usato nel lievito in polvere.Il fosfato trisodico è importante come componente per il bucato, come addolcitore d’acque, per prevenire le incrostazioni nelle caldaie e la corrosione di condotti e tubi.<br />Il fosfato di sodio serve a prevenire la formazione di calcoli renali, ed è usato in pazienti il cui corpo tende ad assorbire troppo calcio dai cibi.<br />Una grande quantità di fosforo è presente nel concime (escrementi di pipistrello o uccelli).<br />I fosfati sono usati nei detergenti per prevenire la formazione di schiuma.<br />L’acido fosforico, come componente di un gel chiamato Naval Jelly, è usato come anti-ruggine: agisce trasformando l’ossido di ferro in un fosfato di ferro solubile in acqua, e quindi lavabile.<br />L’acido fosforico è usato anche come acidificante in bibite gassate, per esempio quelle a base di cola, ed è inoltre impiegato da dentisti e odontotecnici come soluzione per pulire e rendere meno porosi i denti, soprattutto nelle zone in cui vengono applicate otturazioni o apparecchi dentali.<br />","atomic_mass":30,"oxidation_numbers":"±3 +5","melting_temperature":317,"boiling_temperature":553,"electronic_configuration":"[Ne]3s<sup>2</sup>3p<sup>3</sup>","standard_physical_state":"Solido","atomic_radius":110,"first_ionisation_energy":1012,"electronegativity":2,"electronic_affinity":0,"density":"1,82 g/mL","discovery_year":1669},{"name":"Zolfo","number":16,"color":"0xadb293","group":"nonmetal","symbol":"S","image_url":"zolfo.jpg","image_description":"Il caratteristico odore di uova marce che emana dalle solfatare di Pozzuoli (NA) è dovuto all’elevata concentrazione di zolfo.","more_text":"<h1>Biologia</h1>Lo zolfo elementare non è particolarmente dannoso, ma solo irritante per occhi e naso. I composti che contengono zolfo sono invece essenziali per la vita. Lo zolfo si trova in alcuni aminoacidi (cisteina e metionina): nelle proteine e negli enzimi i ponti disolfuro (cioè tra due atomi di zolfo lontani nella catena proteica) formano l’intelaiatura della struttura spaziale di proteine e vitamine e, nelle piante, sono la chiave per la produzione della clorofilla. Per questo le piante coltivate in ambienti carenti di zolfo sono meno robuste, producono meno semi e le loro foglie ingialliscono molto presto.<br /><br /><h1>Scienze della Terra</h1>Lo zolfo molecolare contiene otto atomi in una struttura simile a una corona. Lo zolfo ha tre forme allotropiche, ma a differenza del carbonio gli allotropi dello zolfo non sono di aspetto molto diverso tra loro.<br />Una forma è ortorombica (generalmente chiamata rombica), stabile a temperatura ambiente, di colore giallo, opaca e fragile. Si può preparare per cristallizzazione da una soluzione di disolfuro di carbonio (CS<sub>2</sub>). È stabile fino a 96 °C.<br />La forma monoclina invece è stabile tra i 96 °C e i 119 °C; in questa forma il modo di impacchettarsi delle molecole cambia, e si generano aghi cerosi e fragili, sempre gialli.<br />Oltre i 119 °C lo zolfo fonde; e se si scalda oltre i 160 °C lo zolfo liquido si ottiene una polimerizzazione, ossia una formazione di lunghe catene di zolfo che per brusco raffreddamento generano lo zolfo amorfo (la terza forma allotropica)Questo appare molto simile alla fase liquida, essendo formato da catene ad anelli chiusi di varia grandezza aggrovigliati fra loro.<br />Lo zolfo si trova in natura allo stato elementare per riduzione anaerobica, intermediata da batteri, di sedimenti di solfati. Oltre che allo stato elementare, lo zolfo si trova nella litosfera come solfuro: PbS (galena), ZnS (blenda), CuFeS<sub>2</sub> (calcopirite), FeS<sub>2</sub> (pirite), BaSO<sub>4</sub> (barina), CaSO<sub>4</sub> (anidrite). Il solfato si trova anche nell’idrosfera, portato in soluzione dalle acque di dilavamento a partire da solfati solubili.<br />Lo zolfo elementare non è molto comune nella crosta terrestre, ma i composti sono discretamente presenti nell’atmosfera, soprattutto l’acido solforoso (H<sub>2</sub>SO<sub>3</sub>). Quando si brucia carbone con l’ossigeno dell’aria (come avviene nella produzione dell’acciaio) si produce anche anidride solforosa (SO<sub>2</sub>), a partire dallo zolfo presente come impurità. Parte dell’SO<sub>2</sub> prodotta si trasforma in anidride solforica (SO<sub>3</sub>) e, combinandosi successivamente con il vapore acqueo dell’atmosfera, genera acido solforico, che successivamente torna sulla Terra sotto forma di pioggia acida. L\'inquinamento da piogge acide ha un impatto significativo sulla vegetazione e sulla qualità delle acque, soprattutto nelle zone altamente industrializzate, in cui questo processo avviene molto di frequente.<br /><br /><h1>Astronomia</h1>Perché altri pianeti possano ospitare forme di vita simili alle nostre, è necessaria la presenza di grandi quantitativi di zolfo e di carbonio. Infatti questi elementi, insieme con idrogeno, ossigeno, azoto e fosforo, sono considerati essenziali per la vita; per questo ci sono relativamente poche probabilità di scoprire una forma di vita extraterrestre, che dovrebbe trovarsi su un pianeta in cui tutti questi elementi siano presenti in abbondanza.<br /><br /><h1>Storia</h1>Lo zolfo elementare è utilizzato fin dall’antichità: le popolazioni preromane usavano lo zolfo come medicinale o in rituali religiosi e come insetticida contro cimici e parassiti vari. Successivamente Greci e Romani scoprirono che lo zolfo poteva essere utilizzato per i fuochi d’artificio. Intorno al XII secolo in Cina fu inventata la polvere da sparo, un miscuglio di nitrato di potassio, carbonio e zolfo.<br /><br /><h1>Utilizzo</h1>Lo zolfo è utilizzato soprattutto nei fertilizzanti. Il secondo largo impiego è come materiale di partenza per la produzione di acido solforico, usato per la produzione industriale, dai medicinali alle fibre sintetiche. È anche un ingrediente usato nella produzione di carta, ferro, acciaio, supporti fotografici, trattamento della pelle e della gomma.<br />L’anidride solforosa (SO<sub>2</sub>) è usata allo stato gassoso come refrigerante e come antisettico e antiossidante in enologia.<br />Uno degli utilizzi dello zolfo elementare che tutti i chimici conoscono è quello di prevenire i danni provocati dal mercurio: infatti se si rompe un termometro o se una reazione contenente mercurio non va a buon fine il mercurio va subito eliminato, essendo molto velenoso. Ma lo zolfo, mescolato al mercurio, impedisce l’evaporazione di quest’ultimo, che può causare gravissimi danni alla salute.<br />","atomic_mass":32,"oxidation_numbers":"-2 +4 +6","melting_temperature":388,"boiling_temperature":718,"electronic_configuration":"[Ne]3s<sup>2</sup>3p<sup>4</sup>","standard_physical_state":"Solido","atomic_radius":103,"first_ionisation_energy":1000,"electronegativity":2,"electronic_affinity":2,"density":"2,09 g/mL","discovery_year":"Noto fin dall’antichità"},{"name":"Cloro","number":17,"color":"0xbcb891","group":"alogeni","symbol":"Cl","image_url":"cloro.jpg","image_description":"Il cloro e i suoi composti vengono utilizzati per la disinfezione dell’acqua delle piscine oltre che per la potabilizzazione delle acque.","more_text":"<h1>Biologia</h1>Al contrario del cloro gassoso, molto velenoso e spesso letale, i composti del cloro sono essenziali per la vita sulla Terra. Il cloruro di sodio o sale da cucina è necessario al corpo umano per la maggior parte delle funzioni vitali. Mentre troppo sale causa seri problemi di salute, troppo poco può causare la morte. Inoltre il nostro stomaco contiene acido cloridrico, un acido abbastanza forte da digerire il nostro cibo.<br />Un altro sale di cloro, il cloruro di potassio, è importante per il buon funzionamento del nostro corpo, per esempio per il trattamento della diarrea. Questi sali, così importanti per le funzioni biologiche, sono chiamati elettroliti.<br /><br /><h1>Scienze della Terra</h1>Nonostante il cloro a temperatura ambiente sia un gas, a bassissime temperature cristallizza in un reticolo cubico.<br />Il cloro costituisce circa lo 0,013% della crosta terrestre. È lo ione negativo più presente nell’acqua degli oceani e dei mari chiusi come il Mar Caspio, il Mar Morto e il Gran Lago Salato. Quando gli scienziati hanno scoperto che i clorofluorocarburi (CFC) contribuiscono all’indebolimento dello strato di ozono, l’uso di questi composti chimici è drasticamente diminuito. Miscugli commerciali chiamati bifenili policlorurati si sono sviluppati come lubrificanti e sono usati nella pittura. Negli anni Settanta però si è scoperto che questi erano mortali per pesci e invertebrati anche in piccole quantità. Nell’uomo creano disfunzioni al fegato, dermatiti e capogiri.<br /><br /><h1>Astronomia</h1>Il perossido di cloro si forma dai clorofluorocarburi, molecole create dagli uomini per l’industria della refrigerazione. Il protocollo di Montréal ha bandito l’uso di queste sostanze, ma quelle precedentemente disperse rimarranno nell’atmosfera ancora per molti decenni. La distruzione dello strato di ozono avviene quando le molecole di perossido di cloro assorbono la luce del Sole e si rompono, originando cloro e ossigeno elementari. Gli atomi di cloro liberi reagiscono nuovamente con le molecole di ozono, rompendo il loro legame e riducendo l’ozono stesso. Durante il processo di rottura dell’ozono il perossido di cloro si forma nuovamente, riavviando il meccanismo di distruzione. A causa dei problemi associati al cloro nella stratosfera e al suo ruolo nella degradazione dello strato di ozono, sono stati lanciati molti satelliti per condurre indagini e misure per determinare la concentrazione sua e dei suoi composti nell’alta atmosfera.<br />Il cloro trovato nei meteoriti provenienti da Marte potrebbe essere tutto ciò che resta di possibili antichi mari marziani.<br /><br /><h1>Storia</h1>Scheele scoprì il cloro nel 1774, aggiungendo biossido di manganese (MnO<sub>2</sub>) ad acido muriatico (una soluzione di acido cloridrico): si sviluppò un gas velenoso, ma Scheele pensò che questo gas fosse un composto e non un elemento. Solo oltre trent’anni più tardi, nel 1810, Davy dimostrò che non era possibile scomporlo in sostanze più semplici, e quindi dedusse che era un nuovo elemento.<br />Il nome «cloro» deriva dal greco «chloros» e significa «verde».<br /><br /><h1>Utilizzo</h1>Il cloro è uno degli elementi più importanti in industria.<br />L’odore che si sente nelle piscine è una soluzione molto diluita di cloro. Il cloro e i suoi composti sono usati come sbiancanti per carta e tessuti, come disinfettanti per le acque municipali e come gas velenosi in guerra. Quando l’acqua di mare viene fatta passare attraverso un conduttore elettrico non metallico, avviene una reazione chimica in cui si producono cloro gassoso (Cl<sub>2</sub>), idrogeno gassoso e idrossido di sodio. Il cloro gassoso prodotto è poi utilizzato nell’industria del cloruro di vinile, come polimero per la produzione di plastica.<br />Un altro composto è l’ipoclorito di sodio, NaClO (la comune candeggina), usato anche questo come sbiancante.<br />Il cloro puro è un gas velenoso. È stato il primo gas usato nella guerra chimica durante la prima guerra mondiale. Il cloro causa compressione del petto, stringimento alla gola, gonfiore ai polmoni e soffocamento.<br />","atomic_mass":35,"oxidation_numbers":"±1 +3 +5 +7","melting_temperature":172,"boiling_temperature":239,"electronic_configuration":"[Ne]3s<sup>2</sup>3p<sup>5</sup>","standard_physical_state":"Gas","atomic_radius":99,"first_ionisation_energy":1251,"electronegativity":3,"electronic_affinity":3,"density":"3,21 g/L","discovery_year":1774},{"name":"Argon","number":18,"color":"0xadccdc","group":"gas","symbol":"Ar","image_url":"argon.jpg","image_description":"Gli amanti delle auto di lusso ricorrono all’argon per gonfiare i pneumatici delle loro costosissime vetture.","more_text":"<h1>Biologia</h1>Siccome l’argon è un gas inerte, gli organismi viventi non lo possono utilizzare. L’esposizione al gas può causare invece respirazione rapida, mal di testa, vertigini, stanchezza e perdita di prontezza e di coordinazione. L’esposizione continua causa nausea, vomito, perdita di conoscenza, coma e morte. Questo avviene perché l’argon, che è più pesante dell’ossigeno, si infiltra nei polmoni, impedendo così a quest\'ultimo di entrare nel flusso sanguigno.<br /><br /><h1>Scienze della Terra</h1>L’argon è solido a temperature molto basse, e cristallizza in un reticolo cubico a facce centrate.<br />Il guscio esterno dell’argon ha otto elettroni, ed è quindi molto stabile; i suoi atomi non si combinano né con se stessi né con altri elementi.<br />L’argon è il terzo elemento per abbondanza nell’atmosfera terrestre, e costituisce lo 0,93% dell’aria a livello del mare.<br />Durante la formazione della Terra è stato prodotto molto argon a partire da minerali che contenevano potassio; poi il gas si è lentamente disperso nell’atmosfera.<br />La produzione di <sup>4</sup><sup>0</sup>Ar da <sup>4</sup><sup>0</sup>K per decadimento radioattivo è utile per misurare l’età degli oggetti antichi con un metodo chiamato «datazione potassio-argon».<br /><br /><h1>Astronomia</h1>Nel 1997 gli scienziati sono stati capaci di rilevare una grande quantità di argon nella cometa Hale-Bopp mandandole vicino un razzo sonda.<br />Le lampade a microonde sono state testate per la crescita delle piante su Marte: queste lampade usano bulbi sferici riempiti di argon eccitato da microonde. Non avendo all’interno un filamento incandescente, i ricercatori hanno ritenuto che queste lampade potessero essere sorgenti perfette di luce.<br /><br /><h1>Storia</h1>L’argon è stato il primo gas nobile isolato. Ramsay eliminò tutte le tracce di ossigeno, azoto, anidride carbonica e vapore acqueo dispersi in un campione d’aria; dopo questa operazione, evidenziò che il campione aveva un volume ridotto all’1,3% di quello di partenza. Ramsay teorizzò che questo gas fosse un nuovo elemento, che a causa della sua scarsissima reattività fu chiamato «argon», dalla parola greca «argos», che significa «pigro».<br /><br /><h1>Utilizzo</h1> L’argon è usato nei luoghi in cui è essenziale lavorare in atmosfera inerte, cioè che non reagisca con i campioni da analizzare. Per esempio, le lampadine contenenti gas ad alta pressione funzionano grazie a metalli incandescenti che potrebbero reagire con l’ossigeno dell’aria, e per questo è necessaria un’atmosfera inerte.<br />I tubi radio e i contatori Geiger sono altre apparecchiature in cui viene usato argon. Anche i processi industriali per la fabbricazione di chip per i computer avvengono in atmosfera inerte.<br />L’argon è anche ampiamente utilizzato come gas di protezione per le scariche elettriche durante la saldatura di metalli come l’alluminio e l’acciaio inossidabile. Questo tipo di saldatura è molto utilizzata in quanto l’argon protegge dalle scariche elettriche così bene da poter essere sfruttato anche in processi automatici; per di più è anche il gas nobile più economico.<br />","atomic_mass":39,"oxidation_numbers":"/","melting_temperature":84,"boiling_temperature":87,"electronic_configuration":"[Ne]3s<sup>2</sup>3p<sup>6</sup>","standard_physical_state":"Gas","atomic_radius":71,"first_ionisation_energy":1521,"electronegativity":"/","electronic_affinity":0,"density":"1,78 g/L","discovery_year":1894},{"name":"Potassio","number":19,"color":"0xca6b18","group":"metal","symbol":"K","image_url":"potassio.jpg","image_description":"Frutta e vegetali freschi sono ricchi di potassio, elemento indispensabile nell’alimentazione quotidiana.","more_text":"<h1>Biologia</h1>Il potassio è importante per mantenere i riflessi dei muscoli e dei nervi, il ritmo cardiaco e in particolare la pressione e il bilanciamento del fluido intracellulare.<br />Il diabete e diarree gravi possono causare rapida perdita di potassio e quindi generare altri problemi di salute.<br />Mentre il sodio è lo ione presente in maggior quantità nei liquidi extracellulari del nostro corpo, il potassio è quello che ha maggior concentrazione dentro le cellule.<br />Sia il sodio che il potassio servono per regolare la pressione osmotica e i potenziali elettrici a livello delle membrane plasmatiche. Entrambi gli ioni si muovono attraverso le membrane plasmatiche mediante proteine specifiche chiamate «canali» o tramite il meccanismo definito «pompa sodio/potassio» che ha la funzione di ripristinare le concentrazioni degli ioni coinvolti.<br />Insufficienti quantità di potassio nel sangue causano vomito, crampi muscolari, sonnolenza e un anormale battito cardiaco; troppo potassio può causare debolezza ai muscoli e un battito cardiaco anormale.<br /><br /><h1>Scienze della Terra</h1>Il potassio metallico ha struttura cubica a corpo centrato.<br />Il potassio è il settimo elemento in ordine di abbondanza nella crosta terrestre: è diffuso all’incirca quanto il sodio, a cui assomiglia molto. Sebbene il sodio si ricavi dall’acqua di mare per evaporazione, la maggior parte del potassio si trova in piccoli accumuli in alcuni minerali, e questa è la causa del suo costo elevato.<br />Recentemente scienziati dell’Università di Berkeley e dell’Università del Minnesota hanno proposto che la maggior parte dell’energia del nucleo della Terra provenga da isotopi radioattivi del potassio. Questi isotopi fanno parte di una lega di ferro e potassio che esiste solo ad altre pressioni e temperature. Gli scienziati hanno calcolato che il potassio radioattivo genera un quinto del calore totale del nucleo. Questa energia influenza anche l’intensità del campo magnetico terrestre.<br />Il potassio si trova in natura come KCl (silvite), in sali misti di magnesio e potassio, e infine in molti silicati.<br /><br /><h1>Astronomia</h1> L’esposizione umana all’assenza di gravità, come per esempio alla Stazione spaziale internazionale, causa alcuni problemi di salute, per esempio la formazione di calcoli renali, durante e dopo il volo. Una terapia a base di citrato di potassio per minimizzare e prevenire la formazione dei calcoli è stata testata durante i voli spaziali per verificare se, adottandola, si riduce lo sviluppo di questi disturbi.<br />Il superossido di potassio (K<sub>2</sub>O) è usato come erogatore di emergenza di ossigeno in veicoli spaziali, miniere ecc.<br /><br /><h1>Storia</h1>Come per diversi altri elementi, fu Davy a isolare per primo il potassio: nel 1807 fuse i composti del sodio per ottenere il sodio metallico, e ritenne possibile anche ripetere l’esperimento con l’idrossido di potassio (KOH).<br />In quel periodo i chimici non conoscevano ancora la differenza tra il carbonato di sodio e quello di potassio; successivamente gli studi cristallografici hanno permesso di stabilire che i due composti contenevano un elemento differente, appunto il potassio.<br />Il potassio prende il suo nome dalla potassa (K<sub>2</sub>CO<sub>3</sub>), ma il simbolo chimico K deriva dal suo nome latino, «kalium».<br /><br /><h1>Utilizzo</h1>Non ci sono usi specifici per il potassio elementare, in quanto reagisce violentemente sia con l’ossigeno che con l’acqua; viene generalmente mantenuto sotto etere di petrolio oppure olio.<br />I cibi che contengono più potassio sono banane, pomodori, arance, carote e fagioli verdi.<br />L’idrossido di potassio (KOH) è usato nella produzione dei saponi, mentre il carbonato di potassio (K<sub>2</sub>CO<sub>3</sub>) è largamente usato nei vetri speciali (come quelli per tubi catodici), nei detergenti liquidi per i piatti, nell’industria degli erbicidi e nei fertilizzanti industriali.<br />Il cloruro di potassio è usato in medicina come ingrediente delle soluzioni intravenose, e come sostituto del cloruro di sodio nella dieta priva di sale da cucina.<br />Probabilmente il più importante composto di questo elemento è il salnitro o nitrato di potassio (KNO<sub>3</sub>), che è usato nei fuochi d’artificio e nei fiammiferi. È inoltre usato per produrre polvere da sparo e fertilizzante.<br />Il potassio elementare si prepara per elettrolisi dal KOH fuso, che ha una temperatura di fusione minore di quella del cloruro; la preparazione più vantaggiosa è però quella che usa il cloruro, da ridurre con sodio metallico a potassio elementare.<br />","atomic_mass":39,"oxidation_numbers":"+1","melting_temperature":337,"boiling_temperature":1032,"electronic_configuration":"[Ar]4s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":227,"first_ionisation_energy":419,"electronegativity":0,"electronic_affinity":0,"density":"0,86 g/mL","discovery_year":1807},{"name":"Calcio","number":20,"color":"0xffedbc","group":"metalc","symbol":"Ca","image_url":"calcio.jpg","image_description":"Le ossa dello scheletro umano sono costituite per oltre il 90% da calcio.","more_text":"<h1>Biologia</h1>Il corpo umano è composto per il 2% di calcio. Il fosfato di calcio, Ca<sub>3</sub>(PO<sub>4</sub>)<sub>2</sub>, è il componente principale delle ossa: è presente in una grande quantità di alimenti, soprattutto nelle verdure fresche.<br />Il calcio è anche indispensabile per il funzionamento del sistema nervoso e muscolare e per la coagulazione del sangue. Alcune proteine del nostro corpo usano il calcio nella stessa maniera in cui usano il magnesio.<br />Il calcio esiste come ione libero (Ca<sup>2</sup><sup>+</sup>), e viene trasportato attraverso la membrana cellulare con un meccanismo simile a quello degli altri metalli alcalini. Il calcio, come anche il sodio, è più abbondante fuori che dentro la cellula, e la sua concentrazione nel sangue è controllata da particolari ormoni.<br />Le fluorapatiti disperse nella cheratina costituiscono la dentina, tessuto di alta resistenza meccanica che ricopre i denti.<br />Le conchiglie sono composte essenzialmente di silicati e carbonati di calcio.<br /><br /><h1>Scienze della Terra</h1>Il calcio è il quinto elemento più abbondante nella crosta terrestre: ne rappresenta il 3,64%, e l’ossido di calcio è il suo composto più abbondante. Nella maggior parte dei casi i depositi di calcio si trovano nelle spiagge o comunque in aree con abbondante vita marina, come nel caso delle scogliere di Dover, in Inghilterra, e di simili depositi in altre parti del mondo.<br />Come molti altri metalli del primo e del secondo gruppo, il calcio reagisce immediatamente con l’acqua e con l’ossigeno: per questo il calcio elementare, che presenta un reticolo cubico a facce centrate, non esiste in natura.<br /><br /><h1>Astronomia</h1>Le ossa mantengono la loro forma e la loro dimensione quando sono soggette all\'azione della forza gravitazionale. Ma quando gli astronauti vanno nello spazio non c’è più pressione sulle loro ossa, a causa dell’assenza di gravità. Questo fa sì che, quando ritornano sulla Terra dopo mesi nello spazio, le loro ossa siano diventate fragili e meno dense, cosa potenzialmente pericolosa per la salute.<br /><br /><h1>Storia</h1>Il calcio elementare non esiste in natura, ma i suoi composti sono piuttosto comuni. Già i Romani usavano l’ossido di calcio (CaO), conosciuto a quei tempi come calce. Scritti anteriori al 1000 a.C. riportano che il solfato di calcio (CaSO<sub>4</sub>), comunemente conosciuto come gesso, veniva già usato per curare le fratture. Un altro composto del calcio usato fin dai tempi antichi è il carbonato di calcio (CaCO<sub>3</sub>) o calcare. Nel 1808 Davy ottenne piccole quantità di calcio elementare dall’elettrolisi dell’ossido di mercurio (HgO) e della calce (CaO).<br />Il nome deriva dal latino «calx», che significa «calce».<br /><br /><h1>Utilizzo</h1>Molti composti del calcio sono frequentemente utilizzati in numerosi processi di sintesi chimica. Il carbonato di calcio (CaCO<sub>3</sub>) è presente nel calcare, nel marmo, nei gusci d’uovo, nelle perle, nei coralli, nelle stalagmiti, nelle stalattiti e nei gusci di molti animali. Anche se il gesso che viene usato dagli insegnanti per scrivere sulla lavagna è composto da molti sali, il carbonato di calcio è il suo maggior componente.<br />L’ossido di calcio o calce (CaO) è un materiale da costruzione utilizzato per stucchi, cementi e fertilizzanti. La luce bianca, usata generalmente come luce teatrale, è una luce leggera e brillante che viene generata dall’ossido di calcio scaldato con una fiamma.<br />Il solfato di calcio (CaSO<sub>4</sub>), conosciuto come pietra da gesso, è il composto che costituisce gesso, cemento e laterizi.<br />","atomic_mass":40,"oxidation_numbers":"+2","melting_temperature":1115,"boiling_temperature":1757,"electronic_configuration":"[Ar]4s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":197,"first_ionisation_energy":590,"electronegativity":1,"electronic_affinity":0,"density":"1,53 g/mL","discovery_year":1808},{"name":"Scandio","number":21,"color":"0xe1cac8","group":"metald","symbol":"Sc","image_url":"scandio.jpg","image_description":"Molte delle moderne attrezzature sportive sono fabbricate in leghe leggere comprendenti lo scandio.","more_text":"","atomic_mass":44,"oxidation_numbers":"+3","melting_temperature":1814,"boiling_temperature":3109,"electronic_configuration":"[Ar]3d<sup>1</sup>4s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":161,"first_ionisation_energy":631,"electronegativity":1,"electronic_affinity":0,"density":"2,99 g/mL","discovery_year":1879},{"name":"Titanio","number":22,"color":"0xe1cac8","group":"metald","symbol":"Ti","image_url":"titanio.jpg","image_description":"Per rendere più leggere le montature degli occhiali si utilizza il titanio.","more_text":"<h1>Biologia</h1>Ben poco si conosce del ruolo naturale del titanio nel corpo. Comunque c’è un grande aumento di interesse nell’utilizzo del titanio per «sostituire» alcune parti del nostro corpo. Infatti se c’è bisogno di una protesi attualmente si tende a farla di titanio elementare, che non provoca reazioni nel corpo, non corrode e non è velenoso.<br /><br /><h1>Scienze della Terra</h1>Il titanio metallico ha struttura esagonale, che si trasforma in cubica a corpo centrato ad alte temperature. Poiché il titanio metallico in un’atmosfera di azoto ad alte temperature può bruciare, e poiché reagisce facilmente con l’ossigeno e il carbonio, è difficile preparare il titanio allo stato elementare. Infatti non si trova libero in natura, eppure è il nono elemento per abbondanza nella crosta terrestre, costituendo lo 0,44% del totale grazie ai suoi composti: uno, l’ossido di titanio, è un pigmento bianco che ha forma esagonale compatta al di sotto degli 800 °C; l’altro, il carburo di titanio, è un solido duro la cui forma cristallina principale, fino a 883 °C, è cubica a corpo centrato.<br />I composti di titanio sono generalmente presenti nelle rocce ignee, nella sabbia e nei depositi di titanio situati in Nord America, in Australia, in Scandinavia e in Malesia. Viene estratto faticosamente ed è importante per l’economia di molte nazioni. Il titanio estratto negli Stati Uniti è generalmente usato in gioielleria, mentre il titanio per le costruzioni o per l’aviazione è generalmente importato dall’Europa o dall’Asia.<br /><br /><h1>Astronomia</h1>Le leghe al titanio sono usate nelle navicelle spaziali, nei satelliti, nei missili e in altri oggetti che possono essere mandati nello spazio, inclusi oggetti che sfidano la forza di gravità e placche lasciate sulla Luna e su Marte. A parte quello contenuto questi oggetti, c’è pochissimo titanio nello spazio.<br /><br /><h1>Storia</h1>Il titanio è stato scoperto da Gregor nel 1791. Gregor osservò la presenza di una sostanza sabbiosa nera nella sponda del fiume Helford. Questo minerale da lui chiamato «menaccanite», dal nome della città di Menaccan in Cornovaglia, vicino alla quale fu trovato per la prima volta, era una sostanza magnetica, da cui si poteva eliminare il ferro per azione dell’acido cloridrico; ma Gregor non capì che il minerale sconosciuto conteneva un nuovo elemento. Fu lo scienziato tedesco Klaproth che arrivò alla conclusione che questo minerale fosse parzialmente costituito da un nuovo elemento, da lui chiamato «titanio» ispirandosi ai Titani della mitologia greca, in considerazione della elevata resistenza meccanica naturale del metallo.<br /><br /><h1>Utilizzo</h1>Il titanio è resistente come l’acciaio ma molto più leggero, e viene perciò mescolato con altri metalli per produrre leghe per le costruzioni: sono note quelle con l’alluminio, il manganese, il ferro e altri metalli. Queste leghe sono usate anche nei missili e nelle capsule spaziali, dove forza e resistenza ad alte temperature sono importanti; nella medicina invece il titanio è usato per protesi, specialmente all’anca; le placche metalliche usate per immobilizzare le parti fratturate vengono bloccate con viti di titanio, proprio per la sua scarsa reattività con i tessuti biologici.<br />Il titanio non è corroso dai sali, perciò è adatto per costruire i propulsori e le altre parti delle navi esposte all’acqua di mare. L’intero scafo dei sottomarini è costituito da leghe al titanio.<br />Il biossido di titanio, infine, è utilizzato come sbiancante per i denti.<br />","atomic_mass":47,"oxidation_numbers":"+2 +3 +4","melting_temperature":1941,"boiling_temperature":3560,"electronic_configuration":"[Ar]3d<sup>2</sup>4s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":145,"first_ionisation_energy":658,"electronegativity":1,"electronic_affinity":0,"density":"4,55 g/mL","discovery_year":1791},{"name":"Vanadio","number":23,"color":"0xe1cac8","group":"metald","symbol":"V","image_url":"vanadio.jpg","image_description":"Gli strumenti chirurgici e odontoiatrici sono fatti di leghe metalliche in cui è presente il vanadio.","more_text":"","atomic_mass":50,"oxidation_numbers":"+2 +3 +4 +5","melting_temperature":2183,"boiling_temperature":3680,"electronic_configuration":"[Ar]3d<sup>3</sup>4s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":131,"first_ionisation_energy":651,"electronegativity":1,"electronic_affinity":0,"density":"6,11 g/mL","discovery_year":1801},{"name":"Cromo","number":24,"color":"0xe1cac8","group":"metald","symbol":"Cr","image_url":"cromo.jpg","image_description":"L’impiego più comune del cromo è il rivestimento delle rubinetterie.","more_text":"<h1>Biologia</h1>È discusso se il cromo trivalente sia un oligonutriente essenziale, necessario per il corretto metabolismo degli zuccheri nel corpo umano; sono stati rivisti i dati relativi al fabbisogno umano di questo elemento, spesso supplementato nella dieta in forma di cromo picolinato, e varie volte accusato di essere solamente dannoso, o al più ininfluente se assunto in piccole dosi. Diversamente da altri oligominerali non è stata trovata traccia di atomi di cromo in alcuna metalloproteina dotata di attività biologica e neppure in altri composti attivi.<br />Il cromo metallico e i composti del cromo trivalente non sono normalmente considerati pericolosi per la salute, ma i composti del cromo esavalente sono molto tossici se ingeriti.<br />La maggior parte di essi sono quindi irritanti per gli occhi, la pelle e le mucose, e una esposizione cronica a queste sostanze può causare danni permanenti alla vista; inoltre, il cromo esavalente è un noto agente cancerogeno. Poiché molti composti di questo metallo sono stati e sono tuttora usati in colori e vernici, nonché nella concia del cuoio, oggi sono abbondanti nel terreno e nelle falde acquifere di molti siti industriali, che ora necessitano di decontaminazione e recupero ambientale.<br />Le persone possono essere esposte al cromo (VI) del bicromato di potassio (K<sub>2</sub>Cr<sub>2</sub>O<sub>7</sub>) attraverso la respirazione, mangiando o bevendo, o per contatto con la pelle. Per la maggior parte delle persone il consumo di alimenti che contengono cromo (III) è la via principale di assunzione di cromo, dal momento che è abbondante in molte verdure, frutta, carni, lieviti e farinacei. È una sostanza nutriente essenziale, e la sua scarsità può causare disturbi al cuore.<br />Il cromo (VI) è un elemento molto pericoloso per la salute umana, principalmente per le persone che lavorano nell’industria tessile e siderurgica; è noto per causare vari problemi di salute se inalato, per esempio reazioni allergiche cutanee, irritazioni e sanguinamento dal naso.<br />Il cromo stimola l’attività degli enzimi responsabili del metabolismo del glucosio; è stato provato che stimola anche l’efficacia dell’insulina, e ha un ruolo nella sintesi di proteine mediante legami con l’RNA.<br /><br /><h1>Scienze della Terra</h1>Il cromo si estrae sotto forma di cromite FeCr<sub>2</sub>O<sub>4</sub>: da questa, riscaldata in presenza di alluminio o silicio, si ottiene il cromo metallico commerciale. Circa metà della cromite estratta nel mondo viene da Sudafrica, Kazakistan, India e Turchia.<br />I depositi di cromo nativo puro sono rari: per esempio una miniera in Russia ne produce piccole quantità, grazie all’ambiente riducente che ne favorisce il deposito.<br />Il dicromato di potassio è un potente agente ossidante, ed è il migliore prodotto disponibile per eliminare i composti organici dai vetri di laboratorio. Il verde cromo è un ossido (Cr<sub>2</sub>O<sub>3</sub>) usato nelle vernici per miniature e pittura su vetro.<br />L’acido cromico (H<sub>2</sub>CrO<sub>4</sub>) e l’acido dicromico (H<sub>2</sub>Cr<sub>2</sub>O<sub>7</sub>) non sono presenti in natura, ma i loro anioni si possono ritrovare in una gran varietà di composti, chiamati cromati e dicromati.<br />Il cromo entra nell’aria, nell’acqua e nel terreno in forma di cromo (III) e cromo (VI): questi si formano attraverso processi naturali e attività umane, come la lavorazione di acciaio, cuoio e tessuti, la lavorazione di sostanze chimiche e l’elettropittura. Queste applicazioni ne aumentano soprattutto la concentrazione in acqua; la maggior parte del cromo in aria si deposita e finisce in acqua o nel terreno, dove aderisce alle particelle del suolo.<br /><br /><h1>Astronomia</h1>Il cromo presenta degli isotopi radioattivi, tra cui il <sup>5</sup><sup>3</sup>Cr che decade in <sup>5</sup><sup>3</sup>Mn; il cromo quindi contiene di solito anche isotopi di manganese, e questo rende il sistema Cr-Mn uno strumento di indagine geologica.<br />I rapporti di questi due elementi confermano le prove fornite dal <sup>2</sup><sup>6</sup>Al e dal <sup>1</sup><sup>0</sup><sup>7</sup>Pd sulla storia degli inizi del sistema solare; le variazioni di questo rapporto riscontrate in molti meteoriti forniscono invece prove ulteriori sui processi nucleosintetici immediatamente successivi alla formazione del sistema solare.<br /><br /><h1>Storia</h1>Nel 1761 Lehmann trovò un minerale color rosso-arancio nei monti Urali, che chiamò «piombo rosso siberiano», considerandolo erroneamente un minerale di piombo, selenio e ferro; in realtà era costituito da un cromato di piombo.<br />Nel 1770 Pallas estrasse un altro minerale di piombo dalla stessa miniera e lo sfruttò come materiale per le vernici, che divennero molto di moda grazie ai loro colori brillanti.<br />Nel 1797 Vauquelin ricevette dei campioni di crocoite, un minerale del cromo, da cui fu capace di ricavare l’ossido di cromo (CrO<sub>3</sub>); un anno più tardi scoprì che poteva ottenere cromo metallico riscaldando l’ossido in un letto di carbone. Rilevò infine tracce di cromo in alcune gemme preziose, come rubini e smeraldi.<br />Durante il XIX secolo il cromo ha trovato impiego nella produzione di vernici e pigmenti vari; a oggi l’uso principale è per leghe metalliche.<br />Il nome «cromo» deriva dalla parola greca «chroma», che vuol dire «colore», a causa della varietà di composti vivacemente colorati.<br /><br /><h1>Utilizzo</h1>Il cromo viene utilizzato in metallurgia soprattutto per la sua capacità di conferire resistenza alla corrosione e un rivestimento lucido. Trova impiego come costituente per leghe resistenti al calore, come nell’acciaio inox o nelle resistenze elettriche Ni-Cr.<br />Il cromo veniva ampiamente usato per fornire all’acciaio un rivestimento argenteo lucidato a specchio; i suoi sali colorano il vetro di verde smeraldo, e sono usati anche per produrre rubini sintetici.<br />Viene usato per cromature, nell’alluminio anodizzato, in smalti e vernici.<br />L’ossido di cromo (III) è un lucidante per metalli conosciuto come «Green Rouge».<br />Il dicromato di potassio è un reagente chimico usato nella pulitura della vetreria di laboratorio, ed è anche un agente titolante.<br />L’ossido di cromo (IV), CrO<sub>2</sub>, una molecola di sintesi non presente in natura, si usa per fabbricare nastri magnetici al cromo, che offrono prestazioni superiori rispetto a quelli al ferro.<br />","atomic_mass":52,"oxidation_numbers":"+2 +3 +6","melting_temperature":2180,"boiling_temperature":2944,"electronic_configuration":"[Ar]3d<sup>5</sup>4s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":125,"first_ionisation_energy":653,"electronegativity":1,"electronic_affinity":0,"density":"7,19 g/mL","discovery_year":1798},{"name":"Manganese","number":25,"color":"0xe1cac8","group":"metald","symbol":"Mn","image_url":"manganese.jpg","image_description":"Le corde delle chitarre sia elettriche che acustiche sono costituite da leghe metalliche in cui è presente il manganese.","more_text":"<h1>Biologia</h1>Siccome molti classi di molecole biologiche, come gli enzimi, contengono uno o più atomi di manganese, questo assume una notevole importanza nel metabolismo. Entra come cofattore in enzimi importantissimi come la superossido dismutasi, l’RNA sintetasi e l’arginasi. Gli alimenti più ricchi di manganese sono il riso, il frumento, la soia, le uova, l’olio d’oliva e i fagioli. È necessario anche per la regolazione dello zucchero nel sangue; risulta quindi importante per il benessere del sistema nervoso e del cervello, per il mantenimento e la produzione degli ormoni sessuali, per il normale sviluppo dello scheletro. È fondamentale per la produzione del latte materno, per la formazione dell’urea e del collagene.<br />Alcuni studi condotti indicano che il manganese può essere utilizzato nel trattamento della sclerosi multipla, dell’osteoartrite e del diabete.<br />La carenza di manganese è abbastanza frequente: i diabetici presentano bassi livelli di manganese, forse come conseguenza delle alterazioni del ricambio glucidico.<br />Il manganese puro è tossico: esposizioni a polveri e/o fumi di manganese non dovrebbero oltrepassare il valore massimo di 5 mg al m<sup>3</sup>, neanche per brevi periodi. L’esposizione prolungata causa allucinazioni, amnesia, danni al sistema nervoso centrale, impotenza e danni al sistema respiratorio.<br />Il morbo di Parkinson è stato correlato a esposizioni a manganese nell’industria metalmeccanica, soprattutto fra i saldatori, che in media si ammalano circa 15 anni prima della media. Il manganese è perciò elencato nella lista delle sostanze pericolose.<br /><br /><h1>Scienze della Terra</h1>Giacimenti di manganese sono frequenti nella crosta terrestre ma distribuiti irregolarmente. L’Ucraina e il Sudafrica insieme possiedono più dell’80% di tutti i giacimenti di manganese sulla Terra; altri produttori di manganese sono la Cina, il Burkina Faso, il Messico e l’Australia.<br />Grandi quantità di manganese sono presenti sul fondale degli oceani, sotto forma di noduli di manganese; negli anni Sessanta e Settanta sono stati studiati alcuni modi per raccogliere il manganese dal fondale oceanico, ma senza successo, e le ricerche in materia sono state abbandonate alla fine degli anni Settanta. Il manganese è uno dei metalli più abbondanti nel terreno, in cui si presenta sotto forma di ossidi e idrossidi, nei vari stadi di ossidazione. Il manganese si presenta principalmente come pirolusite (MnO<sub>2</sub>) e in quantità inferiore come rodocrosite (MnCO<sub>3</sub>). Il manganese è un elemento essenziale per tutte le specie, e alcuni organismi, per esempio diatomee, molluschi e spugne, accumulano manganese. I pesci possono avere fino a 5 ppm e i mammiferi fino a 3 ppm di manganese nei loro tessuti.<br />Sono presenti anche particelle di manganese nell’aria, come polvere che tende a depositarsi dopo alcuni giorni; queste particelle derivano dai processi industriali di combustione del carbon fossile.<br /><br /><h1>Storia</h1>Il manganese è stato usato fin dalla preistoria: pigmenti a base di diossido di manganese sono stati ritrovati in pitture rupestri di 17 000 anni fa. Gli Egizi e i Romani usavano composti di manganese nella fabbricazione del vetro, per renderlo incolore o per colorarlo di viola; il minerale di ferro che usavano gli Spartani per fabbricare le loro armi conteneva una certa quantità di manganese, che si concentrava durante la fusione creando una lega Fe-Mn, conferendo alle armi spartane la loro leggendaria durezza.<br />Nel XVII secolo il chimico tedesco Glauber produsse per primo il permanganato; entro la metà del XVIII secolo il diossido di manganese era già usato per la fabbricazione del cloro. Il chimico svedese Scheele fu il primo a capire che il manganese era un elemento chimico: venne isolato in forma pura da un suo collega, Johan Gottlieb Gahn nel 1774, scaldandolo con carbone e olio. Il manganese puro è stato ottenuto molti anni dopo con un processo di elettrolisi applicato al manganese (II).<br /><br /><h1>Utilizzo</h1>Il manganese è essenziale nella produzione di ferro e acciaio, che ne assorbe attualmente dal 85% al 90% della produzione mondiale; è un componente chiave per l’acciaio inossidabile a basso costo e per alcune leghe di alluminio di largo impiego.<br />Il diossido di manganese è usato come catalizzatore, mentre l’ossido è un pigmento marrone che si usa per le vernici e le per terre rare.<br />Il permanganato di potassio è un reagente chimico di largo impiego sia in chimica che in medicina.<br />Il «sapone del vetraio» è una miscela contenente manganese che viene usata per decolorare il vetro, in quanto elimina la colorazione verde conferitagli dalle impurità di ferro; in alte concentrazioni impartisce una colorazione violetta.<br />","atomic_mass":54,"oxidation_numbers":"+2 +3 +4 +6 +7","melting_temperature":1519,"boiling_temperature":2334,"electronic_configuration":"[Ar]3d<sup>5</sup>4s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":137,"first_ionisation_energy":717,"electronegativity":1,"electronic_affinity":"/","density":"7,43 g/mL","discovery_year":1774},{"name":"Ferro","number":26,"color":"0xe1cac8","group":"metald","symbol":"Fe","image_url":"ferro.jpg","image_description":"Il ferro è uno dei costituenti dei binari ferroviari.","more_text":"<h1>Biologia</h1>Il ferro è fondamentale nella vita di molti organismi, soprattutto degli esseri umani. Circa il 65% del ferro nell’uomo si trova nell’emoglobina, una proteina che trasporta ossigeno dai polmoni lungo tutto il flusso sanguigno, utilizzando una molecola particolare chiamata gruppo eme. Ogni gruppo eme contiene un atomo di ferro con numero di ossidazione +2, al quale può legarsi un atomo di ossigeno. Minore è la quantità di emoglobina presente nel sangue e minore è la quantità di ossigeno che può essere trasportato: questa carenza si chiama anemia.<br />Esiste una disfunzione chiamata anemia falciforme, che produce un particolare tipo di emoglobina che distrugge il globulo rosso dopo aver espulso l’ossigeno, causando gravi malformazioni e danni ai tessuti. Questa malattia, che si trasmette per via genetica, può essere molto pericolosa, causando, se non trattata in tempo, anche la morte del paziente.<br /><br /><h1>Scienze della Terra</h1>Il ferro è allotropico, e i cambiamenti tra le sue tre forme sono in funzione della temperatura. Il ferro nella fase delta ha una struttura cubica a corpo centrato ed è stabile oltre i 1400 °C circa. Al di sotto di questa temperatura abbiamo lo stato gamma, che ha una struttura a facce centrate ed è debolmente magnetico. A circa 900 °C la struttura gamma si trasforma in alfa, che è a corpo centrato ed è l’unica forma realmente magnetica.<br />Il ferro è il quarto elemento per abbondanza nella crosta terrestre, mentre è il primo elemento nella Terra nel suo complesso (ne costituisce circa il 35%). Il colore rosso di certi terreni mostra la presenza di ferro, generalmente sotto forma di ossido: questo composto si forma nelle rocce dopo un lungo periodo di azione degli agenti atmosferici.<br /><br /><h1>Astronomia</h1>Nella maggior parte delle stelle la produzione di energia avviene a seguito della fusione dell\'idrogeno in elio. Quando la quantità di idrogeno comincia a diminuire la fusione nucleare si arresta, e la stella, a causa della forza di attrazione del nucleo, collassa diminuendo il suo volume e la sua temperatura interna.<br />Per evitare il collasso, la produzione di elementi pesanti mediante fusione nucleare deve rilasciare una grande quantità di energia; il problema è che la formazione di elementi pesanti rilascia meno energia maggiore è il peso dell’elemento formato, e in alcuni casi serve addirittura fornire energia per far avvenire la reazione. Questo è il motivo per cui si formano più facilmente elementi metallici leggeri, tra cui il ferro è il più abbondante.<br />Le reazioni di fusione sono:<br />4H → He + Q (calore)<br />Per formare il ferro è necessario usare un metallo più leggero:<br />Mn + H → Fe + Q<br />Per ottenere il cobalto (elemento più pesante del ferro) è necessaria energia:<br />Fe + H + Q → Co<br /><br /><h1>Storia</h1>Come per il carbonio non è possibile stabilire una data esatta di scoperta del ferro: si sa che era già usato fin dal 3000 a.C. e che era utilizzato da popolazioni antiche in Cina e in Egitto.<br /><br /><h1>Utilizzo</h1>Il ferro è usato per produrre armi e altri oggetti resistenti, che devono poter essere utilizzati più e più volte; però il ferro arrugginisce. Per prevenire questo problema si utilizzano delle leghe di vario tipo; per esempio il ferro con il carbonio forma l’acciaio, usato per i coltelli, ma anche per lo scheletro delle costruzioni e per alcune parti delle macchine.<br />Il ferro ha proprietà magnetiche, che vengono usate nelle calamite.<br />","atomic_mass":55,"oxidation_numbers":"+2 +3","melting_temperature":1811,"boiling_temperature":3134,"electronic_configuration":"[Ar]3d<sup>6</sup>4s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":124,"first_ionisation_energy":759,"electronegativity":1,"electronic_affinity":0,"density":"7,86 g/mL","discovery_year":"Noto fin dall’antichità"},{"name":"Cobalto","number":27,"color":"0xe1cac8","group":"metald","symbol":"Co","image_url":"cobalto.jpg","image_description":"La colorazione blu delle porcellane è data dal cobalto.","more_text":"<h1>Biologia</h1>L’isotopo del cobalto 60 (<sup>6</sup><sup>0</sup>Co) è un metallo radioattivo usato in passato nella radioterapia, dato che produce raggi gamma. Il cobalto metallico ha la pessima caratteristica di produrre una finissima polvere, causando problemi di protezione dalle radiazioni. Le sorgenti <sup>6</sup><sup>0</sup>Co sono utili alla medicina per circa 5 anni, poi non emettono più raggi gamma in quantità sufficiente: tuttavia restano molto radioattivi e difficilmente smaltibili. Gli effetti negativi dell’isotopo <sup>6</sup><sup>0</sup>Co, dovuti all’esposizione alla radiazioni, sono sterilità, perdita di capelli, vomito, perdite di sangue, diarrea, coma e perfino morte.<br />Dal momento che il cobalto è ampiamente disperso negli ambienti, gli esseri umani possono essere esposti a esso respirando aria, bevendo acqua e mangiando alimenti che contengono cobalto. Anche i contatti con terreni o acque che contengono cobalto possono aumentare l’esposizione.<br />Eppure il cobalto si trova in molti organismi viventi, esseri umani compresi. Un contenuto di cobalto da 0,13 a 0,30 ppm nel suolo migliora nettamente la salute degli animali da cortile. Il cobalto è un elemento fondamentale nella vitamina B12, che è essenziale per la salute umana perché permette la sintesi della flora intestinale, e pertanto attiva numerosi metaboliti ed enzimi, promuove la formazione dei globuli rossi e interviene nella formazione dell’emoglobina. È un minerale essenziale per l’organismo, ed è necessario per il normale funzionamento e mantenimento dei globuli rossi e delle cellule del corpo. Il cobalto è usato infatti per trattare l’anemia nelle donne incinte, stimolando la produzione di globuli rossi.<br />La vitamina B12 viene immagazzinata nel fegato, nei reni, nel pancreas e nella milza. Interviene nella sintesi degli acidi nucleici, in molti processi enzimatici e nel metabolismo dei lipidi e di altre biomolecole; sembra sia necessaria la presenza di cobalto per la trasformazione della folacina in acido folinico.<br />Tuttavia concentrazioni di cobalto troppo elevate possono danneggiare la salute umana, provocando malattie polmonari come asma e polmonite. La polvere di cobalto può causare una malattia simile all’asma, con sintomi che variano da tosse, respiro corto e dispnea fino alla riduzione delle funzioni polmonari.<br /><br /><h1>Scienze della Terra</h1>Il cobalto presenta diverse forme allotropiche: una, chiamata beta, ha una struttura cubica a facce centrate, che è stabile sopra i 417 °C; a temperature più basse è stabile la forma alfa, esagonale. Il passaggio da una forma all’altra è molto lenta, e la struttura beta può essere stabilizzata con l’aggiunta di un po’ di ferro.<br />Il cobalto non si trova allo stato puro metallico, ma solo come minerale, e non viene estratto direttamente, ma come sottoprodotto dell’estrazione di rame e nichel. I più importanti minerali di cobalto sono la cobaltite, l’eritrite, il glaucodoto, e la skutterudite. I maggiori produttori al mondo sono il Congo, la Cina, lo Zambia, la Russia e l’Australia.<br />La maggior parte del cobalto si trova nel nucleo della Terra; è relativamente poco abbondante nella crosta terrestre e nelle acque naturali, da cui precipita come solfuro altamente insolubile.<br />Ci sono terreni che contengono scarse quantità di cobalto, e altri che ne hanno elevate; nell’ambiente marino il cobalto è necessario per le alghe blu-verdi e per altri organismi.<br />Gli esseri umani immettono piccole quantità di cobalto prodotto dalla combustione e dall’estrazione mineraria del carbone, trattando alcuni minerali che contengono il metallo in tracce. Una volta entrato nell’ambiente, il cobalto può reagire con altre particelle o essere assorbito dal terreno o dai sedimenti di ambiente acquatico.<br />Il cobalto spesso raggiunge un ambiente come polvere trasportata dal vento, e si deposita sul terreno o sulla superficie dell’acqua.<br />I terreni che contengono scarse quantità di cobalto possono far crescere piante cobalto-deficienti; d’altra parte, terreni nei pressi di miniere e impianti possono contenere quantità molto elevate di cobalto, e il suo assorbimento da parte degli animali può avere effetti sulla salute.<br /><br /><h1>Storia</h1>Il cobalto era noto fin dall’antichità per i suoi composti che coloravano il vetro di un blu molto bello. Brandt è considerato lo scopritore di questo elemento: la data della scoperta viene accreditata tra il 1730 e il 1737, quando Brandt fu in grado di dimostrare che il cobalto era la fonte del colore blu nel vetro.<br />L\'origine della parola «cobalto» è attualmente sconosciuta: si ritiene possa derivare dal greco «cobalos» o dal tedesco «Kobold», entrambi utilizzati, fin dall\'antichità, per individuare folletti maligni. Questo nome all\'elemento è stato probabilmente assegnato in passato dai minatori che scambiavano i minerali contenenti cobalto con quelli da cui abitualmente venivano estratti metalli preziosi: una volta fusi, questi minerali non solo non producevano i metalli ricercati, ma potevano sviluppare vapori velenosi a causa dell\'arsenico spesso presente in essi.<br />L’alluminato di cobalto, noto con il nome di «blu cobalto», è un pigmento che venne sintetizzato per la prima volta nel 1802: presentò grandi vantaggi per i pittori dell’epoca, poiché è molto stabile e facilmente asciugabile nella pittura a olio.<br /><br /><h1>Utilizzo</h1>Il cobalto viene utilizzato nelle leghe metalliche, come per esempio quelle usate nelle turbine a motore, o per produrre materiali altamente resistenti alla corrosione e in acciai per utensili ad alta velocità. Questi materiali prendono il nome di superleghe.<br />In lega con il ferro, o in lega con alluminio e nichel, genera magneti e supporti magnetici per registrazioni.<br />Nella chimica dell’arte il cobalto è usato per vernici, lacche e inchiostri, come polvere per rivestimenti di porcellane e smalti, e come pigmento blu.<br />Viene usato per la costruzione dei catodi di particolari valvole termoioniche, destinate a usi hi-fi di altissimo livello; queste particolari valvole hanno la particolarità di emettere una luce verdognola invece del solito arancione da incandescenza tipico degli altri tipi di valvole.<br />Il <sup>6</sup><sup>0</sup>Co, radioattivo, si usa nella radioterapia, per la sterilizzazione dei cibi tramite radiazioni, nella radiografia industriale e per il rilevamento di anomalie strutturali in manufatti metallici.<br />","atomic_mass":58,"oxidation_numbers":"+2 +3","melting_temperature":1768,"boiling_temperature":3200,"electronic_configuration":"[Ar]3d<sup>7</sup>4s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":125,"first_ionisation_energy":758,"electronegativity":1,"electronic_affinity":0,"density":"8,80 g/mL","discovery_year":1735},{"name":"Nichel","number":28,"color":"0xe1cac8","group":"metald","symbol":"Ni","image_url":"nichel.jpg","image_description":"Per la sua elevata resistenza alla corrosione, il nichel rientra nella composizione di leghe metalliche per la fabbricazione delle eliche.","more_text":"<h1>Biologia</h1>Molti enzimi del gruppo delle idrogenasi contengono nichel in aggiunta al centro ferro-zolfo; i siti di nichel in alcune idrogenasi hanno il compito di ossidarsi, e pare che questo metallo cambi il suo numero di ossidazione durante l’azione dell’enzima. Per esempio nel coenzima nichel-tetrapirrolo, presente nei batteri, sono state osservate variazioni nello stato di ossidazione e di coordinazione del nichel nell’enzima.<br />Gli esseri umani possono essere esposti a nichel respirando aria, bevendo acqua, mangiando certi alimenti o fumando sigarette; i fumi sono irritanti per la respirazione e possono causare la polmonite. La tossicità del nichel per esempio aumenta quando si combina con l’ossido di carbonio, creando il nichel carbonile. L’esposizione diretta al metallo invece può provocare una dermatite nota come «prurito del nichel», il cui primo sintomo è il prurito; successivamente si manifestano eruzioni cutanee.<br />Tra i sintomi dell’avvelenamento da nichel ricordiamo emicrania, vertigini, nausea, vomito, problemi respiratori, interferenza nel ciclo di Krebs.<br />La carenza di nichel può essere provocata da cirrosi epatica, può aggravare l’anemia causata da mancanza di ferro e può influenzare anche il metabolismo di zinco e ferro.<br />Certi composti del nichel sono considerati cancerogeni.<br /><br /><h1>Scienze della Terra</h1>La maggior parte del nichel estratto proviene da due tipi di minerali: il primo tipo sono le lateriti, i cui minerali principali sono la limonite nichelifera e la guarnierite. Il secondo tipo invece sono depositi di solfuri di origine magmatica, il cui principale minerale è la pentlandite. Il nichel si trova unito allo zolfo nella millerite, all’arsenico nella niccolite, e ad arsenico e zolfo in altri minerali misti.<br />Il fabbisogno di nichel viene soddisfatto principalmente da giacimenti che si trovano in Canada, nella regione dell’Ontario.<br />La maggior parte del nichel presente sulla Terra è inaccessibile perché è intrappolato nel nucleo fuso Fe-Ni del pianeta che è formato per il 10% da nichel. Il materiale organico ha una notevole capacità di assorbire il metallo; ciò spiega perché il carbone e l’olio ne contengono quantità considerevoli. Il contenuto di nichel va da appena 0,2 ppm fino a 450 ppm in alcune argille e terreni argillosi.<br />Il nichel rilasciato nell’aria dalle centrali elettriche e dagli inceneritori ricadrà sui terreni per azione delle piogge; lo smaltimento del nichel in ambiente aereo richiede molto tempo.<br /><br /><h1>Astronomia</h1>I meteoriti metallici (soprattutto quelli ferrosi) sono ritenuti parti di nuclei di asteroidi, e contengono quantità variabili di nichel: dal 4,5% fino al 30%.<br />Le mesosideriti e le pallasiti sono i due gruppi principali delle meteoriti rocciose-ferrose. Le mesosideriti sono frammenti spigolosi di roccia in cui il nichel e il ferro si sono fusi insieme a causa dell’impatto con un altro corpo. Si ritiene che le pallasiti, tra i metoriti più affascinanti, si siano formati sul confine tra nucleo e mantello degli asteroidi: contengono infatti cristalli di olivina.<br /><br /><h1>Storia</h1>Il nichel si usa almeno dal 3500 a.C.: alcuni bronzi, provenienti da quella che oggi è la Siria, contengono fino al 2% di nichel, ed esistono alcuni manoscritti cinesi che suggeriscono che il «rame bianco» fosse in uso in Oriente già tra il 1400 e il 1700 a.C.<br />Siccome però il nichel poteva essere confuso con l’argento, l’uso consapevole risale solo all’epoca contemporanea.<br />I minerali che contengono nichel (come la niccolite o falso rame) erano apprezzati anticamente per il colore verde che conferivano al vetro; nel 1751 il barone Cronstedt, tentando di ottenere il rame, ottenne invece un metallo bianco che battezzò «nichel», dal tedesco «Kupfernickel» (falso rame), a sua volta da «Nickel» (diavoletto): questo perché i minatori associavano a un genio maligno le colpe del ritrovamento di questo metallo, che allora non aveva alcun valore, al posto del rame, relativamente prezioso.<br /><br /><h1>Utilizzo</h1>L’uso principale è nella preparazione di leghe, duttili e con alta resistenza alla corrosione e al calore.<br />Circa il 65% del nichel viene consumato per la produzione di acciaio inossidabile; un altro 12% viene impiegato per le superleghe. Il restante 23% viene usato per batterie, catalizzatori e altri prodotti chimici, conio, prodotti per fonderia e placcatura.<br />Il nichel negli Stati Uniti e in Canada è usato nelle monete da 5 centesimi; in Italia, ai tempi della Lira, diverse monete erano fatte con leghe di nichel; molti altri Paesi usano o hanno usato nichel per realizzare le loro monete.<br />L’accumulatore nichel-metalloidruro, NiMH, è un tipo di batteria simile a quella contenente cadmio, ma può avere una capacità due o tre volte superiore e un minor effetto memoria. Le applicazioni di queste batterie includono i veicoli ibridi di nuova generazione; in ambito normale queste operano meglio con dispositivi che richiedono corrente, come le fotocamere digitali e altra elettronica di consumo.<br />","atomic_mass":58,"oxidation_numbers":"+2 +3","melting_temperature":1728,"boiling_temperature":3186,"electronic_configuration":"[Ar]3d<sup>8</sup>4s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":125,"first_ionisation_energy":737,"electronegativity":1,"electronic_affinity":1,"density":"8,90 g/mL","discovery_year":1751},{"name":"Rame","number":29,"color":"0xe1cac8","group":"metald","symbol":"Cu","image_url":"rame.jpg","image_description":"I cavi elettrici sono costituiti da fili di rame, ottimi conduttori di elettroni, rivestiti di plastica.","more_text":"<h1>Biologia</h1>Il corpo umano contiene tra 1,4 e 2,1 mg di rame per ogni kilogrammo: questo significa che un uomo di 60 kg contiene circa 1/10 di grammo di rame. Questa piccola quantità è però essenziale per produrre enzimi catalitici, che aiutano numerose funzioni corporee come la riduzione dell’ossigeno con la formazione di acqua. Altri enzimi che contengono rame aiutano a trasformare la melanina, pigmento principale della pelle; altri ancora permettono di formare legami incrociati tra il collagene e l’elastina, proteine che accrescono e riparano il tessuto connettivo nel cuore e nelle arterie.<br />Recenti ricerche suggeriscono che la mancanza di rame è un fattore che aumenta i problemi delle coronarie. Un’altra importante funzione del rame è quella della costruzione della struttura secondaria e terziaria delle proteine (protein folding), che sono necessarie per la produzione e la duplicazione del DNA nelle cellule; chiaramente in queste proteine non è presente rame allo stato elementare, ma al suo stato di ossidazione (I) o (II).<br /><br /><h1>Scienze della Terra</h1>Allo stato elementare il rame presenta una struttura cubica a facce centrate.<br />Sebbene il rame possa essere trovato in grandi accumuli, molto spesso si trova combinato con altri elementi per formare vari minerali misti, che possono essere successivamente trattati per ottenere rame elementare. Esistono nuovi metodi industriali che portano alla formazione di rame metallico, di cui il più usato è quello in cui i solfuri di rame (CuS e Cu<sub>2</sub>S) sono scaldati ad alte temperature. In questo processo un atomo di zolfo viene legato a una molecola di ossigeno per formare SO<sub>2</sub> (anidride solforosa), un gas che viene immesso nell’atmosfera; questo viene convertito successivamente in anidride solforica (SO<sub>3</sub>) e, a causa dell\'umidità, in acido solforico (H<sub>2</sub>SO<sub>4</sub>) causa principale delle piogge acide.<br />Il rame si trova nella calcopirite (CuFeS<sub>2</sub>), nella calcocite (Cu<sub>2</sub>S) e come ossido (Cu<sub>2</sub>O) nella cuprite.<br /><br /><h1>Astronomia</h1>Il funzionamento dei veicoli spaziali dipende dal rame: le camere di combustione dei veicoli sono costruite con leghe di materiali che contengono per il 96% rame, per il 3% argento, e per il restante 1% una lega chiamata NARloy-Z. Il rame permette il trasferimento e l’acquisizione di energia e, allo stesso tempo, ha un’alta resistenza alla corrosione. In precedenza la NASA aveva usato il rame nell’Apollo V, al posto dell’acciaio che non permetteva di sfruttare le alte temperature del motore. Quando Amstrong scese sulla Luna sperimentò l’utilizzo di un cavo coassiale di rame, che è rimasto lì da quel giorno; la loro navicella aveva un sistema di comunicazione lunare basato su questi cavi, in modo che rimanessero sempre in contatto con la Terra.<br />Le tute spaziali e gli indumenti degli astronauti contengono rame, per aiutare chi li indossa a mantenere il calore corporeo e a non soffrire il caldo. Recentemente alcuni studenti inglesi hanno iniziato una ricerca su quanto la gravità possa influenzare lavorazione e purificazione dei metalli: un esperimento di tal genere è stato condotto sulla Stazione spaziale internazionale con una bacchetta di rame di piccole dimensioni. A seconda dei risultati ottenuti, la NASA cambierà le proprie strategie su come riparare circuiti elettrici nello spazio.<br /><br /><h1>Storia</h1>Si ritiene che l’uomo abbia iniziato a utilizzare il rame intorno al 5000 a.C.; nel 3500 a.C. veniva ottenuto in Medio Oriente per riduzione dei suoi minerali col carbone. Dopo il 3000 a.C. si iniziò ad aggiungervi lo stagno per produrre bronzo: giunse così l’età del bronzo, in cui il rame divenne uno dei metalli più importanti per la vita dell’uomo.<br /><br /><h1>Utilizzo</h1>Il rame è stato usato per gioielli, posate e tegami da cucina per centinaia di anni. Le leghe di rame come il bronzo (rame e stagno) e l’ottone (rame e zinco) venivano usate già dai tempi antichi. Comunque è solo dal 1877 che il rame viene usato, in quanto ottimo conduttore, per fabbricare cavi (all’inizio quelli del telegrafo). Chiaramente il suo uso è aumentato con l’avvento del telefono e della corrente elettrica. Tubi e condutture industriali sono fatti di rame per la sua ottima capacità di condurre il calore e per la sua ottima resistenza alla combustione.<br />Diverse monete americane ed europee sono fatte di rame.<br />","atomic_mass":63,"oxidation_numbers":"+1 +2","melting_temperature":1358,"boiling_temperature":2835,"electronic_configuration":"[Ar]3d<sup>1</sup><sup>0</sup>4s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":128,"first_ionisation_energy":745,"electronegativity":1,"electronic_affinity":1,"density":"8,96 g/mL","discovery_year":"Noto fin dall’antichità"},{"name":"Zinco","number":30,"color":"0xe1cac8","group":"metald","symbol":"Zn","image_url":"zinco.jpg","image_description":"Le grondaie e le condutture di scarico delle acque piovane sono realizzate in zinco.","more_text":"<h1>Biologia</h1>Lo zinco è un elemento essenziale per la vita degli esseri umani: una carenza di zinco condiziona pesantemente la crescita corporea e l’aumento di peso. Lo zinco si trova anche nell’insulina, nelle proteine con «dita di zinco» (nelle quali uno ione zinco permette l\'avvolgimento delle catene proteiche) e in alcuni enzimi ad azione antiossidante. Secondo alcune fonti assumere pasticche di zinco può dare una certa immunità da raffreddore e influenza, ma questa pratica è controversa.<br />Lo zinco è inoltre implicato nel funzionamento della vista, dell’olfatto, del tatto e della memoria: è responsabile del loro buon funzionamento, e una carenza di zinco causa loro disfunzioni.<br />I seguenti alimenti sono fonti naturali di zinco: ostriche, carne rossa e bianca, fagioli, arachidi, pane integrale, semi di zucca e semi di girasole.<br />Lo zinco è un elemento importante per la produzione di sperma.<br />L’ossido di zinco è utilizzato in medicina per creme contro gli arrossamenti, per esempio la dermatite da pannolino o le ulcere da decubito. Creme a base di zinco sono utilizzate contro la degenerazione maculare dovuta all\'età. In questi medicinali la concentrazione di ossido di zinco si aggira comunemente intorno al 10%, ma in alcuni casi raggiunge anche il 50%.<br />Un altro utilizzo di quest’ossido, in cui si sfrutta la sua azione antiseborroica, è contro l’acne.<br />Lo zinco è un minerale coinvolto nell’assorbimento delle vitamine del complesso B, come la B6. È uno degli elementi meno tossici per l’organismo umano, ma la dieta non deve mai contenere troppo zinco per un periodo molto lungo, perché può impedire l’assorbimento del ferro e del rame.<br />Una mancanza di zinco può causare stanchezza, predisposizione alle infezioni, riduzione della formazione del collagene (quindi unghie e capelli fragili).<br />La scarsità di zinco in gravidanza può perfino causare difetti congeniti.<br />Anche se gli esseri umani possono sopportare concentrazioni elevate di zinco, troppo zinco può causare gravi problemi di salute come spasmi allo stomaco, irritazioni cutanee, vomito, nausea e anemia. Livelli molto elevati di zinco possono causare danni al pancreas e disturbare il metabolismo delle proteine, e causano arteriosclerosi. Una lunga esposizione a cloruro di zinco può causare disordini respiratori.<br /><br /><h1>Scienze della Terra</h1>Lo zinco è il 23° elemento più abbondante nella crosta terrestre; i giacimenti di zinco più sfruttati contengono di solito il 10% di ferro e il 40-50% di zinco. I minerali da cui si estrae lo zinco sono la blenda (che è quello predominante), la sfalerite, la smithsonite, la calamina e la franklinite.<br />Esistono miniere di zinco in tutto il mondo, ma i maggiori produttori sono l’Australia, il Canada, la Cina, il Perù e gli Stati Uniti.<br />In Europa le due miniere più importanti sono la Vieille Montagne in Belgio e Zinkgruvan in Svezia.<br />Lo zinco si presenta in aria, acqua e suolo, ma le concentrazioni di zinco stanno aumentando in modo innaturale, a causa dell’immissione nell’ambiente di questo metallo connessa all’attività umana.<br />La maggior parte dello zinco entra nell’ambiente durante attività industriali, come estrazione mineraria, combustione di carbone e rifiuti e lavorazione dell’acciaio. L’acqua potabile contiene una certa quantità di zinco, che può essere più elevata quando è immagazzinata in serbatoi metallici.<br />L’acqua può essere inquinata a causa della presenza di grandi quantità di zinco negli scarichi delle industrie non adeguatamente depurati. Una delle conseguenze di questo fatto è che i fiumi depositano fango inquinato di zinco sulle loro rive, aumentando l’acidità dell’acqua.<br />Grandi quantità di questo metallo possono essere trovati nei terreni di fattorie, e gli animali assorbono concentrazioni dannose per la salute.<br />Infine lo zinco può modificare l’attività degli organismi che vivono nel terreno alterando significativamente i processi di degradazione della sostanza organica.<br /><br /><h1>Storia</h1>Le leghe di zinco sono state usate per secoli: l’ottone è senza dubbio la più antica e sono stati ritrovati manufatti di questa lega in Palestina a partire dal 1400 a.C. Oggetti di zinco puro invece sono stati ritrovati nella Transilvania preistorica.<br />La fabbricazione dell’ottone era nota ai Romani, che utilizzavano una tecnica che prevedeva il riscaldamento di rame e calamina in un crogiolo; lo zinco liberato veniva catturato dal rame, formando l’ottone, che veniva poi colato in stampi o forgiato.<br />L’estrazione e l’uso di forme impure era praticata già nel 1000 a.C. in Cina e in India; alla fine del XIV secolo gli indiani erano a conoscenza dell’esistenza dello zinco come metallo a se stante, diverso dai sette metalli noti agli antichi.<br />Lo zinco era già noto quando fu ufficialmente isolato a metà del Settecento dal tedesco A. S. Maargraf e dallo svedese A. von Swab, e infatti era già stato isolato anche due anni prima.<br /><br /><h1>Utilizzo</h1>Lo zinco è il quarto metallo più comune nell’uso tecnologico, dopo ferro, alluminio e rame.<br />Si usa per galvanizzare metalli come l’acciaio, in modo da prevenirne la corrosione: questo processo prende il nome di zincatura.<br />Trova impiego nelle leghe (ottone, alpacca e varie leghe per saldature).<br />L’ossido di zinco si usa come pigmento bianco nei colori e nelle vernici ad acqua e come attivatore nell’industria della gomma; il bianco di Cina è una speciale gradazione del bianco di zinco, utilizzato nei pigmenti della pittura artistica. È caratterizzato da un discreto potere coprente, non molto marcato.<br />L’ossido di zinco e l’acido stearico sono ingredienti importanti nella produzione di oggetti in gomma a scopo commerciale. Una miscela appropriata di queste due sostanze permette una più veloce e controllabile manifattura della gomma.<br />Infine l’ossido di zinco è un semiconduttore, utilizzato nei sensori per le fughe di gas e nei LED.<br />Il solfuro di zinco si usa in pigmenti per rendere luminescenti al buio le lancette dell’orologio e altri oggetti.<br />Lo zinco, come altri metalli, è compreso nella maggior parte degli integratori di vitamine e minerali sul mercato. Alcuni pensano che abbia proprietà antiossidanti che proteggono dall’invecchiamento della pelle e dei muscoli.<br />Durante le due guerre mondiali, a causa della carenza di metalli, usati per scopi bellici, alcuni Paesi coniarono monete di alluminio o zinco anziché di argento o bronzo.<br />","atomic_mass":65,"oxidation_numbers":"+2","melting_temperature":693,"boiling_temperature":1180,"electronic_configuration":"[Ar]3d<sup>1</sup><sup>0</sup>4s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":133,"first_ionisation_energy":906,"electronegativity":1,"electronic_affinity":0,"density":"7,14 g/mL","discovery_year":"Noto fin dall’antichità"},{"name":"Gallio","number":31,"color":"0x7d933a","group":"postmetal","symbol":"Ga","image_url":"gallio.jpg","image_description":"Una delle applicazioni più comuni del gallio è nel raggio laser dei moderni lettori ottici.","more_text":"","atomic_mass":69,"oxidation_numbers":"+3","melting_temperature":303,"boiling_temperature":2477,"electronic_configuration":"[Ar]3d<sup>1</sup><sup>0</sup>4s<sup>2</sup>4p<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":122,"first_ionisation_energy":579,"electronegativity":1,"electronic_affinity":0,"density":"5,91 g/mL","discovery_year":1875},{"name":"Germanio","number":32,"color":"0x90aa24","group":"semimetal","symbol":"Ge","image_url":"germanio.jpg","image_description":"Transistor e circuiti elettronici di televisori e computer sono fatti di germanio.","more_text":"","atomic_mass":72,"oxidation_numbers":"+2 +4","melting_temperature":1211,"boiling_temperature":3106,"electronic_configuration":"[Ar]3d<sup>1</sup><sup>0</sup>4s<sup>2</sup>4p<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":123,"first_ionisation_energy":762,"electronegativity":2,"electronic_affinity":1,"density":"5,32 g/mL","discovery_year":1886},{"name":"Arsenico","number":33,"color":"0x90aa24","group":"semimetal","symbol":"As","image_url":"arsenico.jpg","image_description":"L’arsenico è uno dei veleni più potenti esistenti in natura. Veniva utilizzato in passato per le disinfestazioni.","more_text":"","atomic_mass":74,"oxidation_numbers":"±3 +5","melting_temperature":876,"boiling_temperature":876,"electronic_configuration":"[Ar]3d<sup>1</sup><sup>0</sup>4s<sup>2</sup>4p<sup>3</sup>","standard_physical_state":"Solido","atomic_radius":125,"first_ionisation_energy":947,"electronegativity":2,"electronic_affinity":0,"density":"5,73 g/mL","discovery_year":1250},{"name":"Selenio","number":34,"color":"0xadb293","group":"nonmetal","symbol":"Se","image_url":"selenio.jpg","image_description":"Alcuni produttori coltivano le patate in terreni ricchi di selenio, per conferire ai tuberi le capacità antiossidanti di questo elemento.","more_text":"","atomic_mass":78,"oxidation_numbers":"-2 +4 +6","melting_temperature":494,"boiling_temperature":958,"electronic_configuration":"[Ar]3d<sup>1</sup><sup>0</sup>4s<sup>2</sup>4p<sup>4</sup>","standard_physical_state":"Solido","atomic_radius":116,"first_ionisation_energy":941,"electronegativity":2,"electronic_affinity":2,"density":"4,81 g/mL","discovery_year":1817},{"name":"Bromo","number":35,"color":"0xbcb891","group":"alogeni","symbol":"Br","image_url":"bromo.jpg","image_description":"Le pellicole utilizzate nelle macchine fotografiche automatiche, professionali o manuali sono costituite anche dal bromo.","more_text":"<h1>Biologia</h1>Il bromo puro è fortemente irritante e produce dolorose vesciche sulla pelle nuda, specialmente sulle mucose. Anche piccole quantità di vapori, da 10 ppm in su, possono avere effetti sulla respirazione, e in quantità maggiore possono danneggiare gravemente l’apparato respiratorio. Per questo quando si tratta il bromo occorre indossare indumenti di protezione e assicurare un’adeguata ventilazione all’ambiente.<br />Gli esseri umani possono assorbire bromo organico attraverso la pelle, il cibo e la respirazione. È largamente usato in spray per uccidere insetti e altri parassiti indesiderabili, ma è tossico anche per gli animali più grandi, compresi gli esseri umani. Il bromo organico è spesso usato come agente di disinfezione e protezione, grazie ai suoi effetti negativi sui microrganismi; ma quando viene applicato in serre e su terreno coltivabile può facilmente concentrarsi nelle acque superficiali con effetti molto negativi su crostacei, pesci e alghe.<br />Le principali conseguenze sulla salute degli inquinanti bromo-organici sono il malfunzionamento del sistema nervoso e il danneggiamento del materiale genetico; possono essere danneggiati anche fegato, reni, polmoni, milza e stomaco, procurando vari disturbi gastrointestinali.<br />Il bromo organico è presente anche in natura, ma le attività antropiche ne hanno aumentato le quantità nell\'ambiente.<br /><br /><h1>Scienze della Terra</h1>In natura il bromo è molto diffuso nelle rocce, sotto forma di bromuro. A causa del dilavamento i sali di bromo si sono accumulati nell’acqua marina e possono essere estratti a costi accettabili nelle saline, soprattutto dal Mar Morto. I maggiori produttori di bromo sono gli Stati Uniti e Israele.<br /><br /><h1>Storia</h1>Il nome «bromo» deriva dal greco «bromos», che significa «cattivo odore»; è stato scoperto da A. J. Balard nelle paludi salmastre di Montpellier nel 1826, ma si è riusciti a produrlo puro in grandi quantità solo dal 1860.<br /><br /><h1>Utilizzo</h1>Il bromo si usa per la sintesi di una grande varietà di composti utilizzati nell’industria e nell’agricoltura, ma tradizionalmente è stato utilizzato soprattutto per produrre dibromometano, un composto organometallico adoperato come antidetonante nella benzina super.<br />Trova impiego nella produzione di fumogeni, sostanze ignifughe, coloranti, medicinali e disinfettanti, nonché nella depurazione delle acque.<br />In più può essere usato nella fotografia a pellicola, sotto forma di bromuro d’argento e, in ambito alimentare, come emulsionante per bibite al sapore di limone.<br />","atomic_mass":79,"oxidation_numbers":"±1 +3 +5","melting_temperature":266,"boiling_temperature":332,"electronic_configuration":"[Ar]3d<sup>1</sup><sup>0</sup>4s<sup>2</sup>4p<sup>5</sup>","standard_physical_state":"Liquido","atomic_radius":114,"first_ionisation_energy":1140,"electronegativity":2,"electronic_affinity":3,"density":"3,12 g/mL","discovery_year":1826},{"name":"Cripton","number":36,"color":"0xadccdc","group":"gas","symbol":"Kr","image_url":"cripton.jpg","image_description":"Il cripton è utilizzato come gas di riempimento di particolari lampade a fluorescenza e alcuni flash per macchine fotografiche.","more_text":"","atomic_mass":83,"oxidation_numbers":"/","melting_temperature":116,"boiling_temperature":120,"electronic_configuration":"[Ar]3d<sup>1</sup><sup>0</sup>4s<sup>2</sup>4p<sup>6</sup>","standard_physical_state":"Gas","atomic_radius":88,"first_ionisation_energy":1351,"electronegativity":3,"electronic_affinity":0,"density":"3,75 g/L","discovery_year":1898},{"name":"Rubidio","number":37,"color":"0xca6b18","group":"metal","symbol":"Rb","image_url":"rubidio.jpg","image_description":"Il rubidio è impiegato nella produzione di cellule fotoelettriche e nella colorazione di tazze e altri oggetti di ceramica.","more_text":"","atomic_mass":85,"oxidation_numbers":"+1","melting_temperature":312,"boiling_temperature":961,"electronic_configuration":"[Kr]5s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":248,"first_ionisation_energy":403,"electronegativity":0,"electronic_affinity":0,"density":"1,53 g/mL","discovery_year":1861},{"name":"Stronzio","number":38,"color":"0xffedbc","group":"metalc","symbol":"Sr","image_url":"stronzio.jpg","image_description":"Uno spettacolo di fuochi pirotecnici, per la cui colorazione si utilizza lo stronzio.","more_text":"<h1>Biologia</h1>Lo stronzio è presente nei prodotti caseari (formaggi e altri latticini) e viene fissato dagli animali nelle ossa, in piccolissime quantità, al posto del calcio.<br />In natura si riscontra anche lo stronzio 90, un isotopo radioattivo che, assorbito dalle piante da foraggio per l\'alimentazione dei bovini, può concentrarsi nei latticini e infine fissarsi nel nostro corpo. Nelle aree in cui l’isotopo radioattivo è più frequente, le radiazioni che questo produce danneggiano l\'apparato scheletrico, in particolare il midollo osseo, alterando il processo di formazione di nuove cellule. Alcuni ricercatori ritengono che la maggior incidenza di leucemia e cancro alle ossa, in certe zone del pianeta rispetto ad altre, dipenda dalla maggiore abbondanza in tali zone dello stronzio 90.<br /><br /><h1>Scienze della Terra</h1>Lo stronzio presenta una struttura cristallina cubica a facce centrate. È abbastanza raro trovare un cristallo ben strutturato di stronzio: in natura sono infatti molto più frequenti i microcristalli.<br />Circa lo 0,25% della crosta terrestre è costituita da stronzio e, in particolare, dall’ossido di stronzio (SrO). Sembra poco, ma è una percentuale simile a quelle del carbonio e dello zolfo, entrambi elementi essenziali alla vita.<br /><br /><h1>Astronomia</h1>L’isotopo radioattivo stronzio 90 è uno dei migliori emettitori di particelle beta conosciuti: la radiazione prodotta, ad alta energia, può generare correnti elettriche e potrebbe quindi essere utilizzata per produrre energia in stazioni e navi spaziali.<br /><br /><h1>Storia</h1>Nel 1790 lo scienziato irlandese Crawford trattò un campione di un minerale carbonato con acido cloridrico; i cristalli che ne risultarono avevano un aspetto diverso dal cloruro di bario che normalmente si formava da tale processo. Crawford ipotizzò che ciò fosse dovuto alla presenza di un elemento sconosciuto presente nel minerale. Solo nel 1808, l\'inglese Davy isolò, tramite elettrolisi, tale elemento, che venne chiamato stronzio dal nome della città scozzese di Strontian, da dove veniva il campione di carbonato studiato da Crawford.<br /><br /><h1>Utilizzo</h1>Lo stronzio è usato nei fuochi d’artificio e nei proiettili traccianti, a causa del colore rosso brillante che deriva dalla combustione dei suoi sali.<br />","atomic_mass":87,"oxidation_numbers":"+2","melting_temperature":1050,"boiling_temperature":1655,"electronic_configuration":"[Kr]5s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":215,"first_ionisation_energy":549,"electronegativity":0,"electronic_affinity":0,"density":"2,60 g/mL","discovery_year":1790},{"name":"Ittrio","number":39,"color":"0xe1cac8","group":"metald","symbol":"Y","image_url":"ittrio.jpg","image_description":"Per generare il colore rosso nei tubi catodici dei televisori si sfruttano le proprietà di uno dei composti dell’ittrio.","more_text":"","atomic_mass":88,"oxidation_numbers":"+3","melting_temperature":1799,"boiling_temperature":3618,"electronic_configuration":"[Kr]4d<sup>1</sup>5s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":178,"first_ionisation_energy":616,"electronegativity":1,"electronic_affinity":0,"density":"4,47 g/mL","discovery_year":1794},{"name":"Zirconio","number":40,"color":"0xe1cac8","group":"metald","symbol":"Zr","image_url":"zirconio.jpg","image_description":"Le protesi dentarie sono costituite anche da zirconio; è anche utilizzato per il rivestimento di forni.","more_text":"","atomic_mass":91,"oxidation_numbers":"+4","melting_temperature":2128,"boiling_temperature":4682,"electronic_configuration":"[Kr]4d<sup>2</sup>5s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":159,"first_ionisation_energy":660,"electronegativity":1,"electronic_affinity":0,"density":"6,49 g/mL","discovery_year":1789},{"name":"Niobio","number":41,"color":"0xe1cac8","group":"metald","symbol":"Nb","image_url":"niobio.jpg","image_description":"Viene utilizzato per la produzione di utensili da taglio e supermagneti; per il suo colore bluastro, è spesso impiegato nei piercing.","more_text":"","atomic_mass":92,"oxidation_numbers":"+3 +5","melting_temperature":2750,"boiling_temperature":5017,"electronic_configuration":"[Kr]4d<sup>4</sup>5s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":143,"first_ionisation_energy":664,"electronegativity":1,"electronic_affinity":0,"density":"8,57 g/mL","discovery_year":1801},{"name":"Molibdeno","number":42,"color":"0xe1cac8","group":"metald","symbol":"Mo","image_url":"molibdeno.jpg","image_description":"Il molibdeno è impiegato nella costruzione di elementi di aerei: è utilizzato per la produzione di turbine e fluidi lubrificanti.","more_text":"","atomic_mass":95,"oxidation_numbers":"+1 +2 +3 +4 +5 +6","melting_temperature":2896,"boiling_temperature":4912,"electronic_configuration":"[Kr]4d<sup>5</sup>5s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":136,"first_ionisation_energy":685,"electronegativity":2,"electronic_affinity":0,"density":"10,20 g/mL","discovery_year":1778},{"name":"Tecnezio","number":43,"color":"0xe1cac8","group":"metald","symbol":"Tc","image_url":"tecnezio.jpg","image_description":"Il tecnezio è radioattivo; viene impiegato nei test di radiodiagnostica.","more_text":"","atomic_mass":"[98,91]","oxidation_numbers":"+4 +5 +6 +7","melting_temperature":2430,"boiling_temperature":4538,"electronic_configuration":"[Kr]4d<sup>5</sup>5s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":135,"first_ionisation_energy":702,"electronegativity":1,"electronic_affinity":0,"density":"11,50 g/mL","discovery_year":1937},{"name":"Rutenio","number":44,"color":"0xe1cac8","group":"metald","symbol":"Ru","image_url":"rutenio.jpg","image_description":"Le punte delle penne a sfera sono costituite da leghe metalliche che comprendono anche il rutenio.","more_text":"","atomic_mass":101,"oxidation_numbers":"+2 +3 +4 +5 +6 +7","melting_temperature":2607,"boiling_temperature":4423,"electronic_configuration":"[Kr]4d<sup>7</sup>5s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":133,"first_ionisation_energy":711,"electronegativity":2,"electronic_affinity":1,"density":"12,5 g/mL","discovery_year":1844},{"name":"Rodio","number":45,"color":"0xe1cac8","group":"metald","symbol":"Rh","image_url":"rodio.jpg","image_description":"Le puntine dei giradischi sono in rodio.","more_text":"","atomic_mass":102,"oxidation_numbers":"+3","melting_temperature":2237,"boiling_temperature":3968,"electronic_configuration":"[Kr]4d<sup>8</sup>5s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":135,"first_ionisation_energy":720,"electronegativity":2,"electronic_affinity":1,"density":"12,4 g/mL","discovery_year":1803},{"name":"Palladio","number":46,"color":"0xe1cac8","group":"metald","symbol":"Pd","image_url":"palladio.jpg","image_description":"I meccanismi degli orologi sono fatti di leghe metalliche in cui è presente il palladio.","more_text":"","atomic_mass":106,"oxidation_numbers":"+2 +4","melting_temperature":1828,"boiling_temperature":3236,"electronic_configuration":"[Kr]4d<sup>1</sup><sup>0</sup>","standard_physical_state":"Solido","atomic_radius":138,"first_ionisation_energy":805,"electronegativity":2,"electronic_affinity":0,"density":"12,0 g/mL","discovery_year":1803},{"name":"Argento","number":47,"color":"0xe1cac8","group":"metald","symbol":"Ag","image_url":"argento.jpg","image_description":"Numerosi oggetti ornamentali, dalle posate ai vassoi ai gioielli, sono realizzati in argento.","more_text":"<h1>Biologia</h1>L’argento non ha applicazioni biologiche conosciute; nonostante questo, negli ultimi duemila anni molte civiltà hanno attribuito proprietà curative a questo metallo. Per esempio i Romani usavano il nitrato d’argento per trattare le ulcere della cute o per drenare il pus negli ascessi. Alla fine dell’Ottocento il dottor Halstead, uno dei fondatori della moderna medicina, usava delle lamine d’argento per curare le infezioni. Questa tecnica è stata utilizzata fino alla seconda guerra mondiale, quando è stata sostituita dall’uso di antibiotici.<br />Ancora oggi un farmaco contro le ustioni è a base di un composto dell’argento. Una miscela di argento e rame viene usata per lavare via le alghe dalle piscine.<br /><br /><h1>Scienze della Terra</h1>L’argento presenta una struttura cristallina cubica a facce centrate. È un metallo raro nella crosta terrestre, ma con 0,05 ppm è circa dieci volte più abbondante dell’oro.<br />L\'estrazione dell\'oro e dell\'argento dalle miniere provoca un serio impatto sull\'ambiente: infatti un metodo molto usato per l’estrazione mineraria è quello di spruzzare con acido cianidrico i minerali per ottenere cianuro d’argento (AgCN) e cianuro d’oro (AuCN); il metallo viene poi nuovamente isolato allo stato elementare. Questo processo produce però sali di cianuro, molto velenosi, che possono diffondersi nel terreno e nei corsi d\'acqua e contaminare l\'ambiente.<br /><br /><h1>Astronomia</h1>L’argento è presente nello spazio solo su pianeti e asteroidi. L’analisi degli asteroidi giunti sulla Terra ha dimostrato che la percentuale di argento è in molti casi maggiore su altri pianeti che non nella crosta terrestre.<br /><br /><h1>Storia</h1>Ornamenti e decorazioni in argento sono stati rinvenuti nelle tombe reali del 4000 a.C. È probabile che in India, Mesopotamia ed Egitto sia l’argento sia l’oro fossero usati per coniare monete fin dall’800 a.C.; già a quei tempi all’argento era attribuito un valore minore rispetto all’oro.<br /><br /><h1>Utilizzo</h1>L’argento si usa soprattutto per produrre monete, ornamenti e gioielli. Dagli anni Sessanta è aumentata vertiginosamente la richiesta di argento, a causa dello sviluppo dell’industria fotografica: infatti gli alogenuri d’argento (AgF, AgCl, AgBr, AgI) e anche il nitrato d’argento (AgNO<sub>3</sub>) sono utilizzati nella produzione di pellicole e nel loro sviluppo.<br />L’ossocianuro d’argento (AgCNO) è usato in molti esplosivi.<br />L’argento trova impiego in molti apparecchi elettrici che necessitano di circuiti che non siano soggetti a corrosione.<br />","atomic_mass":107,"oxidation_numbers":"+1","melting_temperature":1235,"boiling_temperature":2435,"electronic_configuration":"[Kr]4d<sup>1</sup><sup>0</sup>5s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":145,"first_ionisation_energy":731,"electronegativity":1,"electronic_affinity":1,"density":"10,5 g/mL","discovery_year":"Noto fin dall’antichità"},{"name":"Cadmio","number":48,"color":"0xe1cac8","group":"metald","symbol":"Cd","image_url":"cadmio.jpg","image_description":"Le comuni pile a basso voltaggio sono realizzate in cadmio.","more_text":"","atomic_mass":112,"oxidation_numbers":"+2","melting_temperature":594,"boiling_temperature":1040,"electronic_configuration":"[Kr]4d<sup>1</sup><sup>0</sup>5s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":149,"first_ionisation_energy":868,"electronegativity":1,"electronic_affinity":0,"density":"8,65 g/mL","discovery_year":1817},{"name":"Indio","number":49,"color":"0x7d933a","group":"postmetal","symbol":"In","image_url":"indio.jpg","image_description":"L’indio viene impiegato nella fabbricazione degli specchi, in cui costituisce un rivestimento di elevata qualità resistente alla corrosione.","more_text":"","atomic_mass":114,"oxidation_numbers":"+3","melting_temperature":430,"boiling_temperature":2345,"electronic_configuration":"[Kr]4d<sup>1</sup><sup>0</sup>5s<sup>2</sup>5p<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":163,"first_ionisation_energy":558,"electronegativity":1,"electronic_affinity":0,"density":"7,31 g/mL","discovery_year":1863},{"name":"Stagno","number":50,"color":"0x7d933a","group":"postmetal","symbol":"Sn","image_url":"stagno.jpg","image_description":"Lo stagno, grazie alla sua malleabilità, è il metallo più utilizzato nella saldatura.","more_text":"<h1>Biologia</h1>Il ruolo assunto dallo stagno nel nostro organismo non è ancora completamente noto; è stato tuttavia dimostrato che nei topi una dieta completamente priva di stagno determina una crescita e uno sviluppo stentati. Il corpo di un uomo adulto contiene circa 352 mg di stagno.<br />Mentre lo stagno metallico e i sali di stagno sono relativamente poco tossici, quando lo stagno si lega a composti organici genera prodotti molto pericolosi, la cui tossicità aumenta con il numero dei sostituenti organici. Sono spesso usati come fungicidi e vengono mescolati con le vernici per le carene delle navi; sono inoltre utilizzati come stabilizzanti nella produzione di plastiche.<br /><br /><h1>Scienze della Terra</h1>Lo stagno è un metallo allotropico. A bassa temperatura (sotto i 13,2 °C per lo stagno puro, ma molto più sotto se ci sono impurità) l’allotropo più stabile è lo stagno grigio o stagno alfa, che ha una struttura simile al diamante e ha l’aspetto di una polvere; l’altra forma, lo stagno bianco o stagno beta, è lo stagno che siamo abituati a osservare, un metallo bianco-argenteo con struttura tetragonale.<br />Se piegato lo stagno bianco produce uno misterioso e strano scricchiolio, dovuto alla geminazione dei cristalli.<br />Solo lo 0,001% delle rocce ignee ha tra i suoi costituenti lo stagno, ma per fortuna questo metallo è concentrato in certe località, rendendone non troppo difficile l’estrazione. Il composto maggiormente presente nella crosta terrestre è l’ossido di stagno (SnO<sub>2</sub>). A differenza di altri metalli pesanti lo stagno elementare si ottiene facilmente, eliminando l’ossigeno tramite arrostimento in aria in presenza di carbone in appositi forni.<br /><br /><h1>Astronomia</h1>Lo stagno si trova nello spazio in piccolissime quantità, ma la sua concentrazione è molto maggiore su pianeti e asteroidi.<br />Un problema dell’uso dello stagno nello spazio è che le superfici rivestite di stagno subiscono una crescita spontanea di strutture filiformi chiamate «whiskers», che rompendosi possono mandare gli impianti elettronici in cortocircuito; l’unico modo sicuro per prevenire questo inconveniente è evitare di usare lo stagno metallico o i suoi composti. Per questo, nonostante tutti i pregi dello stagno, come l’alta resistenza alla corrosione e il basso costo, la NASA ne ha bandito l’uso per le apparecchiature spaziali.<br /><br /><h1>Storia</h1>Lo stagno è stato usato ampiamente dalle civiltà antiche, che lo mescolavano al rame per ottenere il bronzo con cui producevano oggetti e armi. Il peltro, una lega di stagno e piombo, è stato usato circa 1500 anni prima di Cristo dagli antichi Egizi; la civiltà romana ha poi sviluppato il peltro come materiale per vasellame e usi ornamentali. Oggi il peltro è composto dal 91% di stagno, 7,5% di antimonio e 1,5% di rame; il piombo è stato sostituito dall’antimonio quando si è scoperto che era nocivo per la salute.<br />La latta, cioè fogli di ferro rivestiti di un sottile strato di stagno per impedirne l\'ossidazione, è stata una scoperta molto importante. L’uso originale della latta era quello di produrre oggetti di uso comune, come lanterne, piatti o bicchieri. Dal 1812 la latta venne usata per confezionare il cibo in scatola.<br /><br /><h1>Utilizzo</h1>Nonostante non abbia più la stessa importanza degli anni passati, lo stagno è usato ancora oggi soprattutto nella conservazione dei cibi: è infatti resistente alla corrosione e facile da fondere, produrre e riciclare.<br />","atomic_mass":118,"oxidation_numbers":"+2 +4","melting_temperature":505,"boiling_temperature":2875,"electronic_configuration":"[Kr]4d<sup>1</sup><sup>0</sup>5s<sup>2</sup>5p<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":141,"first_ionisation_energy":709,"electronegativity":1,"electronic_affinity":1,"density":"7,29 g/mL","discovery_year":"Noto fin dall’antichità"},{"name":"Antimonio","number":51,"color":"0x90aa24","group":"semimetal","symbol":"Sb","image_url":"antimonio.jpg","image_description":"Vernici e smalti hanno tra i loro ingredienti anche l’antimonio.","more_text":"","atomic_mass":121,"oxidation_numbers":"±3 +5","melting_temperature":904,"boiling_temperature":1860,"electronic_configuration":"[Kr]4d<sup>1</sup><sup>0</sup>5s<sup>2</sup>5p<sup>3</sup>","standard_physical_state":"Solido","atomic_radius":145,"first_ionisation_energy":834,"electronegativity":2,"electronic_affinity":1,"density":"6,68 g/mL","discovery_year":"Noto fin dall\'antichità"},{"name":"Tellurio","number":52,"color":"0x90aa24","group":"semimetal","symbol":"Te","image_url":"tellurio.jpg","image_description":"I pannelli fotovoltaici più moderni, che sfruttano l’energia solare per la produzione di energia pulita, sono costituiti da composti del tellurio.","more_text":"","atomic_mass":127,"oxidation_numbers":"-2 +4 +6","melting_temperature":723,"boiling_temperature":1261,"electronic_configuration":"[Kr]4d<sup>1</sup><sup>0</sup>5s<sup>2</sup>5p<sup>4</sup>","standard_physical_state":"Solido","atomic_radius":143,"first_ionisation_energy":869,"electronegativity":2,"electronic_affinity":1,"density":"6,24 g/mL","discovery_year":1782},{"name":"Iodio","number":53,"color":"0xbcb891","group":"alogeni","symbol":"I","image_url":"iodio.jpg","image_description":"Le acque marine e oceaniche sono ricche di iodio, che viene liberato nell’atmosfera grazie soprattutto al moto ondoso.","more_text":"<h1>Biologia</h1>Il corpo umano necessita di modeste quantità di iodio per assicurare un adeguato controllo dello sviluppo dell\'intero organismo. Lo iodio è il componente fondamentale degli ormoni prodotti dalla tiroide, una ghiandola che controlla appunto lo sviluppo: la carenza di iodio può portare al cosiddetto «gozzo», una disfunzione della ghiandola tiroidea. Nelle aree geografiche dove lo iodio non è sufficientemente presente negli alimenti, lo si integra aggiungendo ioduro di potassio al sale da cucina. Lo iodio può essere assorbito dall\'organismo solo attraverso il canale digerente; pertanto «respirare» lo iodio diffuso nell\'aria in prossimità delle coste marine non ne aumenta la quantità nel nostro corpo.<br /><br /><h1>Scienze della Terra</h1>Lo iodio presenta una struttura cristallina cubica. Non avendo una concentrazione sufficiente da poter formare un minerale a sé stante, lo si ritrova solo in tracce nelle rocce della crosta terrestre. Una risorsa molto importante di iodio sono le alghe marine e i depositi di salnitro in Cile. Lo iodio presente in abbondanza nell’acqua di mare, viene liberato nell\'atmosfera e ricade nei terreni trasportato nelle piogge; può così essere assorbito dalle piante.<br /><br /><h1>Storia</h1>Lo iodio fu scoperto in maniera fortuita nel 1811 dal francese Bernard Courtois, un produttore di salnitro, utilizzato per la polvere da sparo. Stava studiando un processo di estrazione di carbonato di sodio dalle ceneri delle alghe depositate sulle spiagge della Normandia. Durante la lavorazione Courtois, aggiungendo alle ceneri acido solforico, produsse una nuvola di vapori violetti che, a contatto con gli oggetti metallici freddi, depositava cristalli scuri di aspetto metallico. Fu tuttavia Gay-Lussac, nel 1814, ad assegnare a questo elemento il nome «iodio», che deriva dal greco e significa «viola».<br /><br /><h1>Utilizzo</h1>Lo iodio è usato in medicina, nell’industria dei coloranti e nella fotografia. L’elemento, sciolto in soluzione alcolica diluita, è stato usato per molti anni come disinfettante per uso esterno (tintura di iodio).<br />I composti dello iodio, come lo ioduro di potassio (KI), vengono aggiunti al sale da cucina in piccole quantità e barrette di iodio vengono utilizzate per disinfettare le acque. Lo iodio è anche un costituente del Reattivo di Lugol, un colorante utilizzato in laboratorio di Biologia per evidenziare alcune strutture cellulari. È necessario maneggiarlo con molta cura, perché può causare lesioni alla pelle e danneggiare gli occhi e le mucose. Lo iodio puro è molto velenoso; un suo isotopo artificiale, lo iodio 131, prodotto dalla fissione di uranio e plutonio e fortemente radioattivo, viene utilizzato in radioterapia e per test diagnostici come la scintigrafia tiroidea.<br />","atomic_mass":126,"oxidation_numbers":"±1 +5 +7","melting_temperature":387,"boiling_temperature":457,"electronic_configuration":"[Kr]4d<sup>1</sup><sup>0</sup>5s<sup>2</sup>5p<sup>5</sup>","standard_physical_state":"Solido","atomic_radius":133,"first_ionisation_energy":1008,"electronegativity":2,"electronic_affinity":3,"density":"4,93 g/mL","discovery_year":1811},{"name":"Xenon","number":54,"color":"0xadccdc","group":"gas","symbol":"Xe","image_url":"xenon.jpg","image_description":"Le luci stroboscopiche sono utilizzate nelle discoteche per creare l’effetto di movimento, e utilizzano lo xenon per funzionare.","more_text":"","atomic_mass":131,"oxidation_numbers":"/","melting_temperature":161,"boiling_temperature":165,"electronic_configuration":"[Kr]4d<sup>1</sup><sup>0</sup>5s<sup>2</sup>5p<sup>6</sup>","standard_physical_state":"Gas","atomic_radius":108,"first_ionisation_energy":1170,"electronegativity":2,"electronic_affinity":0,"density":"5,90 g/L","discovery_year":1898},{"name":"Cesio","number":55,"color":"0xca6b18","group":"metal","symbol":"Cs","image_url":"cesio.jpg","image_description":"Il primo orologio atomico è stato realizzato nel 1955. Il tempo è determinato in base alla frequenza di risonanza di un atomo di cesio.","more_text":"","atomic_mass":132,"oxidation_numbers":"+1","melting_temperature":302,"boiling_temperature":944,"electronic_configuration":"[Xe]6s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":265,"first_ionisation_energy":376,"electronegativity":0,"electronic_affinity":0,"density":"1,87 g/mL","discovery_year":1860},{"name":"Bario","number":56,"color":"0xffedbc","group":"metalc","symbol":"Ba","image_url":"bario.jpg","image_description":"Il solfato di bario viene somministrato al paziente prima di una radiografia all’apparato digerente.","more_text":"<h1>Biologia</h1>I composti del bario sono molto tossici e possono essere anche letali. L’ingestione di queste sostanze genera problemi al cuore, allo stomaco, al fegato, ai reni e altri organi; il bario è assorbibile dall\'organismo nelle sue diverse forme solubili in acqua, in alcol o in acidi.<br /><br /><h1>Scienze della Terra</h1>Il bario ha reticolo cubico a corpo centrato. È molto comune nella crosta terrestre, dove è il sesto elemento per abbondanza. Essendo fortemente reattivo all\'acqua e all\'ossigeno, non si trova quasi mai puro, ma sempre in sali o ossidi.<br /><br /><h1>Astronomia</h1>«Nuvole» di bario furono utilizzate dalla NASA negli anni Ottanta per studiare gli effetti del vento solare sulla ionosfera terrestre.<br /><br /><h1>Storia</h1>Alcuni composti del bario erano noti già dalla metà del XVI secolo: in particolare la cosiddetta «pietra lucida di Bologna», probabilmente il minerale barite (solfuro di bario, BaSO<sub>4</sub>) che, macinata e arroventata si trasformava nella «pietra fosforica» capace, dopo essere stata esposta alla luce, di emettere luce fosforescente al buio.<br />Tra il 1774 e il 1779, il chimico svedese Scheele, studiando le impurità della pirolusite (un minerale contenente magnesio), isolò alcuni composti del bario, tra cui la barite, che all\'epoca chiamò «terra pesante»; fu tuttavia l\'inglese Humphry Davy ad isolare il bario nel 1808 tramite elettrolisi e utilizzando la pila inventata da Volta.<br /><br /><h1>Utilizzo</h1>Il bario trova molti impieghi, soprattutto sotto forma di solfato: per esempio come pigmento bianco per pitture oppure aggiunto ad alcune gomme e plastiche. Il solfato di bario è molto tossico se ne vengono inalate le polveri, ma può essere ingerito: infatti, essendo insolubile in acqua, viene espulso allo stato solido senza essere stato assorbito. Grazie alla sua capacità di bloccare i raggi X, viene usato nelle analisi mediche come tracciante per le rilevazioni gastrointestinali.<br />Il perossido di bario, BaO<sub>2</sub>, viene a volte ancora usato come candeggiante; il nitrato, Ba(NO<sub>3</sub>)<sub>2</sub>, sprigionando una intensa fiamma verde, viene utilizzato per produrre fuochi di artificio. Essendo molto reattivo, il bario puro viene conservato immerso nel kerosene.<br />","atomic_mass":137,"oxidation_numbers":"+2","melting_temperature":1000,"boiling_temperature":2170,"electronic_configuration":"[Xe]6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":217,"first_ionisation_energy":503,"electronegativity":0,"electronic_affinity":0,"density":"3,59 g/mL","discovery_year":1808},{"name":"Lantanio","number":57,"color":"0xe8b521","group":"lantanidi","symbol":"La","image_url":"lantanio.jpg","image_description":"Le lenti utilizzate dalle apparecchiature fotografiche sono costituite da lantanio.","more_text":"","atomic_mass":138,"oxidation_numbers":"+3","melting_temperature":1193,"boiling_temperature":3727,"electronic_configuration":"[Xe]5d<sup>1</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":187,"first_ionisation_energy":538,"electronegativity":1,"electronic_affinity":48,"density":"6,17 g/mL","discovery_year":1839},{"name":"Cerio","number":58,"color":"0xe8b521","group":"lantanidi","symbol":"Ce","image_url":"cerio.jpg","image_description":"LANTANIDE. È il costituente principale delle leghe con cui sono fatte le «pietrine» degli accendini.","more_text":"","atomic_mass":140,"oxidation_numbers":"+3 +4","melting_temperature":1071,"boiling_temperature":3716,"electronic_configuration":"[Xe]4f<sup>1</sup>5d<sup>1</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":183,"first_ionisation_energy":528,"electronegativity":1,"electronic_affinity":50,"density":"6,77 g/mL","discovery_year":1803},{"name":"Praseodimio","number":59,"color":"0xe8b521","group":"lantanidi","symbol":"Pr","image_url":"praseodimio.jpg","image_description":"LANTANIDE. È utilizzato per la realizzazione delle «lampade ad arco» che producono una luce simile a quella del giorno.","more_text":"","atomic_mass":140,"oxidation_numbers":"+3","melting_temperature":1204,"boiling_temperature":3793,"electronic_configuration":"[Xe]4f<sup>3</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":182,"first_ionisation_energy":523,"electronegativity":1,"electronic_affinity":50,"density":"6,77 g/mL","discovery_year":1885},{"name":"Neodimio","number":60,"color":"0xe8b521","group":"lantanidi","symbol":"Nd","image_url":"neodimio.jpg","image_description":"LANTANIDE. Viene utilizzato per produrre magneti permanenti utilizzati negli auricolari.","more_text":"","atomic_mass":144,"oxidation_numbers":"+3","melting_temperature":1297,"boiling_temperature":3347,"electronic_configuration":"[Xe]4f<sup>4</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":181,"first_ionisation_energy":530,"electronegativity":1,"electronic_affinity":50,"density":"7,00 g/mL","discovery_year":1885},{"name":"Promezio","number":61,"color":"0xe8b521","group":"lantanidi","symbol":"Pm","image_url":"promezio.jpg","image_description":"LANTANIDE RADIOATTIVO. Essendo radioattivo è impiegato come sorgente di radiazioni beta in campo medico e spaziale.","more_text":"","atomic_mass":"[145]","oxidation_numbers":"+3","melting_temperature":1315,"boiling_temperature":3273,"electronic_configuration":"[Xe]4f<sup>5</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":181,"first_ionisation_energy":523,"electronegativity":"/","electronic_affinity":50,"density":"7,22 g/mL","discovery_year":1945},{"name":"Samario","number":62,"color":"0xe8b521","group":"lantanidi","symbol":"Sm","image_url":"samario.jpg","image_description":"LANTANIDE. In grado di assorbire la radiazione infrarossa, è utilizzato per la realizzazione di vetri speciali.","more_text":"","atomic_mass":150,"oxidation_numbers":"+2 +3","melting_temperature":1345,"boiling_temperature":2051,"electronic_configuration":"[Xe]4f<sup>6</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":180,"first_ionisation_energy":543,"electronegativity":1,"electronic_affinity":0,"density":"7,54 g/mL","discovery_year":1879},{"name":"Europio","number":63,"color":"0xe8b521","group":"lantanidi","symbol":"Eu","image_url":"europio.jpg","image_description":"LANTANIDE. Dotato di luminescenza, è impiegato come composto anticontraffazione delle banconote dell\'euro.","more_text":"","atomic_mass":152,"oxidation_numbers":"+2 +3","melting_temperature":1095,"boiling_temperature":1802,"electronic_configuration":"[Xe]4f<sup>7</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":199,"first_ionisation_energy":547,"electronegativity":"/","electronic_affinity":50,"density":"5,24 g/mL","discovery_year":1901},{"name":"Gadolinio","number":64,"color":"0xe8b521","group":"lantanidi","symbol":"Gd","image_url":"gadolinio.jpg","image_description":"LANTANIDE. È impiegato in tecniche di indagine medica come la risonanza magnetica.","more_text":"","atomic_mass":157,"oxidation_numbers":"+3","melting_temperature":1584,"boiling_temperature":3546,"electronic_configuration":"[Xe]4f<sup>7</sup>5d<sup>1</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":179,"first_ionisation_energy":592,"electronegativity":1,"electronic_affinity":50,"density":"7,89 g/mL","discovery_year":1880},{"name":"Terbio","number":65,"color":"0xe8b521","group":"lantanidi","symbol":"Tb","image_url":"terbio.jpg","image_description":"LANTANIDE. Trova impiego nella produzione di elementi per gli schermi di televisioni e computer.","more_text":"","atomic_mass":158,"oxidation_numbers":"+3","melting_temperature":1629,"boiling_temperature":3503,"electronic_configuration":"[Xe]4f<sup>9</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":176,"first_ionisation_energy":564,"electronegativity":1,"electronic_affinity":50,"density":"8,27 g/mL","discovery_year":1843},{"name":"Disprosio","number":66,"color":"0xe8b521","group":"lantanidi","symbol":"Dy","image_url":"disprosio.jpg","image_description":"LANTANIDE. Insieme ad altri elementi è utilizzato nella fabbricazione dei laser.","more_text":"","atomic_mass":162,"oxidation_numbers":"+3","melting_temperature":1682,"boiling_temperature":2840,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>0</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":175,"first_ionisation_energy":572,"electronegativity":1,"electronic_affinity":50,"density":"8,53 g/mL","discovery_year":1886},{"name":"Olmio","number":67,"color":"0xe8b521","group":"lantanidi","symbol":"Ho","image_url":"olmio.jpg","image_description":"LANTANIDE. Per le sue proprietà magnetiche è utilizzato per produrre i più potenti magneti artificiali.","more_text":"","atomic_mass":164,"oxidation_numbers":"+3","melting_temperature":1743,"boiling_temperature":2993,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>1</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":174,"first_ionisation_energy":581,"electronegativity":1,"electronic_affinity":50,"density":"8,80 g/mL","discovery_year":1878},{"name":"Erbio","number":68,"color":"0xe8b521","group":"lantanidi","symbol":"Er","image_url":"erbio.jpg","image_description":"LANTANIDE. Il suo ossido, avendo un\'alta capacità di trattenere specifiche lunghezze d\'onda della luce, viene utilizzato per la produzione di filtri fotografici e lenti per speciali occhiali da sole.","more_text":"","atomic_mass":167,"oxidation_numbers":"+3","melting_temperature":1795,"boiling_temperature":3141,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>2</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":173,"first_ionisation_energy":589,"electronegativity":1,"electronic_affinity":50,"density":"9,05 g/mL","discovery_year":1842},{"name":"Tulio","number":69,"color":"0xe8b521","group":"lantanidi","symbol":"Tm","image_url":"tulio.jpg","image_description":"LANTANIDE. Viene utilizzato per la produzione di laser impiegati in campo medico.","more_text":"","atomic_mass":168,"oxidation_numbers":"+2 +3","melting_temperature":1818,"boiling_temperature":2223,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>3</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":173,"first_ionisation_energy":596,"electronegativity":1,"electronic_affinity":50,"density":"9,33 g/mL","discovery_year":1879},{"name":"Itterbio","number":70,"color":"0xe8b521","group":"lantanidi","symbol":"Yb","image_url":"itterbio.jpg","image_description":"LANTANIDE. Viene usato come additivo per la produzione di acciaio e altre leghe per migliorarne il comportamento meccanico.","more_text":"","atomic_mass":173,"oxidation_numbers":"+2 +3","melting_temperature":1097,"boiling_temperature":1469,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":194,"first_ionisation_energy":603,"electronegativity":1,"electronic_affinity":50,"density":"6,98 g/mL","discovery_year":1907},{"name":"Lutezio","number":71,"color":"0xe8b521","group":"lantanidi","symbol":"Lu","image_url":"lutezio.jpg","image_description":"LANTANIDE. Viene impiegato come catalizzatore di reazioni tra composti organici (alchilazione, idrogenazione, polimerizzazione).","more_text":"","atomic_mass":175,"oxidation_numbers":"+3","melting_temperature":1929,"boiling_temperature":3675,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>1</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":172,"first_ionisation_energy":524,"electronegativity":1,"electronic_affinity":33,"density":"9,84 g/mL","discovery_year":1907},{"name":"Afnio","number":72,"color":"0xe1cac8","group":"metald","symbol":"Hf","image_url":"afnio.jpg","image_description":"Essendo un eccellente assorbitore di neutroni e resistente alla corrosione, l\'afnio è usato nei reattori e nei sottomarini nucleari.","more_text":"","atomic_mass":178,"oxidation_numbers":"+4","melting_temperature":2506,"boiling_temperature":4876,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>2</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":156,"first_ionisation_energy":642,"electronegativity":1,"electronic_affinity":"≈ 0","density":"13,3 g/mL","discovery_year":1923},{"name":"Tantalio","number":73,"color":"0xe1cac8","group":"metald","symbol":"Ta","image_url":"tantalio.jpg","image_description":"Le clip da sutura utilizzate in chirurgia sono in tantalio.","more_text":"","atomic_mass":180,"oxidation_numbers":"+5","melting_temperature":3290,"boiling_temperature":5698,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>3</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":143,"first_ionisation_energy":761,"electronegativity":1,"electronic_affinity":0,"density":"16,7 g/mL","discovery_year":1802},{"name":"Tungsteno","number":74,"color":"0xe1cac8","group":"metald","symbol":"W","image_url":"tungsteno.jpg","image_description":"I bulbi delle vecchie lampadine a incandescenza contenevano una spirale di tungsteno. L\'alto punto di fusione ne fanno un ottimo componente per la costruzione di leghe per utensili che lavorano ad alte temperature.","more_text":"<h1>Biologia</h1>Il tungsteno (chiamato anche Wolframio) compare all\'interno di cofattori di una classe di enzimi che catalizzano reazioni di trasferimento di elettroni da una molecola all\'altra. Alcuni composti gassosi con il tungsteno provocano danni alle mucose e irritazione agli occhi e, in grandi quantità, possono risultare tossici.<br /><br /><h1>Scienze della Terra</h1>Il tungsteno presenta una struttura cristallina cubica a corpo centrato. Si estrae prevalentemente dai minerali Sheelite e Wolframite, ma è poco abbondante nella crosta terrestre. I giacimenti più importanti si trovano in Cina.<br /><br /><h1>Astronomia</h1>Grazie alle sue caratteristiche, il tungsteno trova diverse applicazioni aerospaziali, dalle leghe pesanti per parti di aeromobili che richiedano alte densità, alle penne a sfera per astronauti.<br /><br /><h1>Storia</h1>Nel 1758 il chimico Axel Fredrick Cronstedt scoprì e descrisse un minerale particolarmente pesante (chiamato poi scheelite) che chiamò «tung sten», che in svedese significa «pietra pesante». Un altro chimico svedese, Carl Wilhelem Scheele riuscì a isolare, nel 1871, il minerale in questione. Il tungsteno metallico fu tuttavia ottenuto solo nel 1783 da due chimici spagnoli, i fratelli Juan José e Fausto Elhuyar.<br />Questo elemento è chiamato sia tungsteno che wolframio, anche se l’unico simbolo ufficiale è W; nei paesi anglosassoni si preferisce usare tungsteno, mentre in Germania è più diffuso il nome wolframio.<br /><br /><h1>Utilizzo</h1>Il tungsteno è il metallo con il punto di fusione più alto. Ha anche un’alta conducibilità elettrica e mostra una forte incandescenza se scaldato ad alte temperature, perciò è stato usato come filamento per le lampadine. A temperatura ambiente è fragile, mentre diventa malleabile e duttile ad alte temperature.<br />I carburi di tungsteno (WC e W<sub>2</sub>C) per la loro estrema durezza sono usati per aumentare la resistenza di utensili e parti di macchine operatrici.<br />Recentemente questo metallo ha trovato impiego anche nella costruzione di mazze da golf.<br />","atomic_mass":183,"oxidation_numbers":"+2 +3 +4 +5 +6","melting_temperature":3695,"boiling_temperature":5828,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>4</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":137,"first_ionisation_energy":770,"electronegativity":2,"electronic_affinity":0,"density":"19,3 g/mL","discovery_year":1781},{"name":"Renio","number":75,"color":"0xe1cac8","group":"metald","symbol":"Re","image_url":"renio.jpg","image_description":"Questo elemento trova uso principalmente nella sintesi di catalizzatori per la produzione di benzine.","more_text":"","atomic_mass":186,"oxidation_numbers":"+4 +6 +7","melting_temperature":3459,"boiling_temperature":5869,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>5</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":137,"first_ionisation_energy":760,"electronegativity":1,"electronic_affinity":0,"density":"21,0 g/mL","discovery_year":1925},{"name":"Osmio","number":76,"color":"0xe1cac8","group":"metald","symbol":"Os","image_url":"osmio.jpg","image_description":"Per la rilevazione delle impronte digitali si utilizzano inchiostri particolari a base di osmio.","more_text":"","atomic_mass":190,"oxidation_numbers":"+2 +3 +4 +5 +8","melting_temperature":3306,"boiling_temperature":5285,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>6</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":134,"first_ionisation_energy":839,"electronegativity":2,"electronic_affinity":1,"density":"22,6 g/mL","discovery_year":1803},{"name":"Iridio","number":77,"color":"0xe1cac8","group":"metald","symbol":"Ir","image_url":"iridio.jpg","image_description":"Gli aghi delle bussole sono costituiti da iridio.","more_text":"","atomic_mass":192,"oxidation_numbers":"+3 +4","melting_temperature":2739,"boiling_temperature":4701,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>7</sup>6s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":136,"first_ionisation_energy":878,"electronegativity":2,"electronic_affinity":1,"density":"22,5 g/mL","discovery_year":1803},{"name":"Platino","number":78,"color":"0xe1cac8","group":"metald","symbol":"Pt","image_url":"platino.jpg","image_description":"Il platino è considerato il metallo più prezioso nella produzione di gioielli.","more_text":"<h1>Biologia</h1>Alcuni composti del platino sono utilizzati come farmaci per la cura del cancro: è stata infatti individuata una nuova classe di composti platino-fosfati in grado di interagire e alterare il ciclo di alcune cellule cancerogene.<br />Gli effetti del platino sull\'organismo dipendono dal tipo di composto che forma e dal livello di esposizione; il platino metallico è poco reattivo e quindi non molto pericoloso, mentre i sali di platino sono considerati composti tossici e possono avere effetti pesanti sulla salute. Inoltre il platino può aumentare la tossicità di altre sostanze chimiche come il selenio.<br /><br /><h1>Scienze della Terra</h1>Il platino si trova spesso allo stato nativo, mescolato con altri metalli dello stesso gruppo o combinato con nichel, ferro e rame. I suoi minerali più importanti sono la sperrylite (PtAs<sub>2</sub>) e la cooperite (PtS). Si trova principalmente in depositi alluvionali fluviali in Colombia, Ontario, monti Urali, Sudafrica e certe zone degli Stati Uniti.<br />Industrialmente il platino si ricava dalla lavorazione dei minerali di nichel; benché la concentrazione di platino in tali minerali sia mediamente piuttosto bassa (circa 2 ppm), il suo valore ne rende l’estrazione conveniente.<br />Benché negli ultimi anni si sia riscontrato un aumento di platino nell\'ambiente, dovuto soprattutto all\'utilizzo di marmitte catalitiche che lo contengono, non sono state riscontrate finora significative ripercussioni sulla salute degli ecosistemi.<br /><br /><h1>Storia</h1>Il suo nome deriva dallo spagnolo «platina», derivato della parola «plata», che vuol dire «argento». Gli spagnoli lo chiamarono così quando lo incontrarono per la prima volta in Colombia. Il platino era infatti noto e usato dalle popolazioni precolombiane del Sud America e la prima menzione in documenti europei risale al 1557 ad opera dell’umanista italiano Scaligera, che lo descrive come un misterioso metallo trovato nelle miniere del Darièn (Panama) e del Messico.<br />Il platino allora era considerato un’impurezza indesiderata dell’argento, e spesso veniva gettato via; la sua prima scoperta è attribuita agli spagnoli Antonio de Ulloa e Don Jorge Juany Santacilia durante una spedizione in Perù, tra il 1735 e il 1745.<br />L\'inglese Charles Wood lo isolò nel 1741.<br />Lo standard di riferimento per la misura del metro è stato per lungo tempo la distanza tra due tacche su una barra di platino-iridio; un cilindro della stessa lega è lo standard di riferimento per il kilogrammo.<br />Il platino è usato anche per la definizione dell’elettrodo standard a idrogeno.<br /><br /><h1>Utilizzo</h1>Il platino allo stato elementare e puro ha aspetto simile all’argento, è duttile, malleabile e resistente alla corrosione. Come gli altri metalli della sua famiglia possiede notevoli capacità catalitiche. La sua resistenza alla corrosione e all’ossidazione lo rende adatto alla produzione di gioielleria. Altre caratteristiche sono sfruttate per applicazioni industriali.<br />Il platino non si ossida all’aria nemmeno ad alte temperature, non si scioglie nell’acido cloridrico e nemmeno nell’acido nitrico; per queste caratteristiche peculiari il platino è considerato uno dei migliori conduttori elettrici ed è utilizzato anche nella produzione di connettori per cavi.<br />Il platino e le sue leghe sono usati per costruire attrezzi chirurgici, utensili da laboratorio, cavi elettrici di resistenza e punti di contatto elettrico. È usato nelle marmitte catalitiche (come catalizzatore) e in varie industrie (aeronautica, chimica, elettrica e del vetro). Gli elettrodi di alcuni pace-maker sono costituiti da platino e iridio.<br />","atomic_mass":195,"oxidation_numbers":"+2 +4","melting_temperature":2041,"boiling_temperature":4098,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>9</sup>6s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":139,"first_ionisation_energy":868,"electronegativity":2,"electronic_affinity":2,"density":"21,4 g/mL","discovery_year":1735},{"name":"Oro","number":79,"color":"0xe1cac8","group":"metald","symbol":"Au","image_url":"oro.jpg","image_description":"Le riserve auree di una nazione ne rappresentano la potenza economica e la solvibilità in caso di prestiti internazionali.","more_text":"<h1>Biologia</h1>Nonostante non siano ancora completamente noti i ruoli biologici di questo metallo, sono stati sintetizzati alcuni farmaci che contengono oro (I). Questi medicinali, usati inizialmente per la cura delle artriti, si sono dimostrati efficaci nelle terapie antitumorali.<br />In ortodonzia l’oro è stato sostituito da materiali ceramici solo di recente. Ultimamente sono state sperimentate nanoparticelle d\'oro come marcatori di molecole per seguirne gli spostamenti all\'interno delle cellule.<br /><br /><h1>Scienze della Terra</h1>L’oro presenta una struttura cristallina cubica a facce centrate, in cui ogni atomo d’oro è circondato da altri 12 vicini nel massimo numero di coordinazione.<br />L’oro si trova nelle rocce ignee in quantità modeste; nella crosta terrestre vi sono 0,005 ppm d’oro. Se è presente in una roccia è in piccoli granelli quasi invisibili e i frammenti di grandi dimensioni sono molto rari.<br /><br /><h1>Astronomia</h1>L\'oro è presente su diversi asteroidi del nostro Sistema solare: su Eros (passato recentemente accanto al nostro pianeta), si ipotizza una presenza di grandi quantità di oro, platino e alluminio.<br /><br /><h1>Storia</h1>L’oro è stato usato dall\'uomo per migliaia di anni: i monili più antichi risalgono a 6500 anni fa. Oltre a essere usato come merce di scambio o come moneta, l’oro veniva impiegato per rivestire armi, coppe, gioielli e statue. Fino al 1400 l\'oro europeo proveniva per la maggior parte dalle miniere austriache; con la scoperta dell’America, l\'oro del Nuovo Mondo venne introdotto nell\'economia europea.<br />Nell’Ottocento l’oro fu scoperto prima in California (nel 1848) e poi in Alaska (nel 1890), causando così le rispettive «corse all’oro».<br /><br /><h1>Utilizzo</h1>L’oro viene per la maggior parte utilizzato per la realizzazione di gioielli e monili. A causa della sua scarsa durezza, non viene mai utilizzato puro, ma in lega con altri metalli. Il carato esprime la purezza dell\'oro: l\'oro al 100% di purezza è a 24 carati, quello al 75% di purezza è a 18 carati. Grazie alle sue specifiche proprietà, trova impiego anche nell’industria elettronica (terminali e circuiti stampati). La grande capacità dell’oro di condurre la corrente elettrica e la sua ottima resistenza alla corrosione lo caratterizzano come una delle scelte migliori. Sottili lamine d’oro possono riflettere le radiazioni infrarosse: queste possono essere usate sui satelliti per il controllo della temperatura o come visori di protezione per gli astronauti che viaggiano vicino al Sole.<br />","atomic_mass":197,"oxidation_numbers":"+1 +3","melting_temperature":1337,"boiling_temperature":3081,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>1</sup><sup>0</sup>6s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":144,"first_ionisation_energy":890,"electronegativity":2,"electronic_affinity":2,"density":"19,3 g/mL","discovery_year":"Noto fin dall’antichità"},{"name":"Mercurio","number":80,"color":"0xe1cac8","group":"metald","symbol":"Hg","image_url":"mercurio.jpg","image_description":"Il mercurio è l’unico metallo liquido a temperatura ambiente; per questo veniva usato nei termometri (adesso non più, a casusa della sua tossicità).","more_text":"<h1>Biologia</h1>Il mercurio è fortemente tossico, per ingestione, per inalazione dei vapori oppure anche per semplice contatto; per quanto riguarda il mercurio elementare il rischio maggiore di intossicazione acuta è legato ai vapori, in quanto l’assorbimento cutaneo è trascurabile, così come anche quello intestinale.<br />La sua tossicità è nota fin dall’antichità: i Romani per esempio conoscevano i sintomi neurologici che derivavano dall’esposizione al mercurio e, nel Medioevo, veniva utilizzato per gli avvelenamenti.<br />In età moderna i suoi effetti nocivi sulla salute si fecero palesi: in particolare nell’Inghilterra dell’Ottocento si diffusero disordini mentali tra i produttori di cappelli, che utilizzavano grandi quantità di mercurio per lavorare il feltro.<br />Il mercurio liberato dai processi industriali, se non adeguatemente trattato, può finire nell\'ambiente ed entrare nella catena alimentare, concentrandosi negli organismi animali e portandoli alla morte. Nell\'uomo, oltre alle intossicazioni legate agli ambienti di lavoro, i rischi sono collegati all\'ingestione di alimenti con alti tassi di mercurio al loro interno. In particolare, il mercurio può legarsi a un gruppo metilico originando un catione metilmercurio molto reattivo e immediatamente assorbibile dall\'organismo. I danni più frequenti riguardano il sistema nervoso e quello riproduttivo.<br /><br /><h1>Scienze della Terra</h1>Il mercurio è un elemento raro nella crosta terrestre (0,08 ppm), tuttavia a causa della sua relativa facilità a combinarsi con altri elementi della crosta terrestre i suoi minerali sono particolarmente ricchi. Ciò fa del mercurio uno dei metalli meno onerosi da purificare.<br />Si trova raramente allo stato puro e la forma più frequente è un solfuro, il cinabro; si riscontra poi nella corderite, nella livingstonite e in altri minerali.<br />Le miniere peruviane furono essenziali per la produzione di mercurio nelle colonie spagnole d’America; anche l’Italia, con le miniere del monte Amiata in Toscana, ha sempre avuto un ruolo predominante nella produzione del mercurio.<br />Il mercurio entra nell’ambiente dai minerali, attraverso l’azione degli agenti atmosferici: quindi il rilascio di mercurio da sorgenti naturali è rimasto più o meno lo stesso nel corso degli anni. Tuttavia la concentrazione di mercurio nell’ambiente sta aumentando a causa dall’attività umana: la maggior parte è diffusa nell\'atmosfera attraverso i combustibili fossili, l’estrazione mineraria, la fusione e la combustione dei rifiuti solidi. Alcune attività umane, come l’applicazione dei fertilizzanti agricoli e lo scarico di acque industriali, immettono mercurio direttamente nel terreno e nell’acqua.<br /><br /><h1>Storia</h1>Il mercurio era già noto anticamente in Cina e in India; è stato inoltre rinvenuto in tombe dell’antico Egitto risalenti al 1500 a.C. In Cina, India e Tibet si riteneva che il mercurio prolungasse la vita, curasse le fratture e aiutasse a conservare la buona salute. Si narra che Qin Shi Huang, il primo imperatore della Cina, sia impazzito e poi morto per l’ingestione di pillole di mercurio, che nelle intenzioni dei suoi medici avrebbero dovuto garantirgli la vita eterna. Dagli alchimisti il mercurio era spesso visto come uno degli elementi primordiali che costituiscono la materia; la parola indù per indicare l’alchimia significa letteralmente «la via del mercurio».<br />Il simbolo chimico del mercurio è Hg, e deriva dalla parola «hydrargyrum», che significa «argento d’acqua», a causa del fatto che è liquido e metallico. Successivamente prese il nome del dio romano Mercurio, per le sue caratteristiche di scorrevolezza e lucentezza, veloce, quindi, come il «messaggero degli dei».<br /><br /><h1>Utilizzo</h1>Il mercurio trova impiego nella produzione di composti chimici industriali e nell’elettronica; è l’elemento base di termometri, barometri, sfigmomanometri, coulombometri e pompe a diffusione, grazie alla sua densità e al suo alto tasso di espansione termica in un ampio intervallo di temperature.<br />Tra i suoi impieghi in campo elettrico ed elettronico, permette la realizzazione di interruttori, elettrodi (noto quello a calomelano saturo) e pile.<br />In campo medico invece l’amalgama di mercurio è usato per realizzare le otturazioni dentali; mentre il cloruro mercuroso o calomelano è stato usato come diuretico, disinfettante locale e lassativo. Il cloruro mercurico ha trovato impiego invece nella cura della sifilide, nonostante effetti collaterali. Disinfettanti a base di sali di mercurio, come il mercurocromo, trovano impiego come insetticida o veleno per topi, anche se in alcune nazioni sono stati banditi.<br />Il metallo viene utilizzato nella purificazione dei minerali di oro e argento, attraverso la formazione di amalgama, ma è un processo ampiamente inquinante e nocivo per l’ambiente e i minatori.<br />I vapori di mercurio sono usati in alcuni tipi di lampade a fluorescenza.<br />Tra la seconda metà del XVIII secolo e la prima del XIX la produzione di cappelli di feltro passava attraverso un processo in cui le pelli venivano immerse in un soluzione di nitrato di mercurio, Hg(NO<sub>3</sub>)<sub>2</sub>; la tossicità della soluzione causò moltissimi casi di avvelenamento tra i fabbricanti. Dato che l’avvelenamento da mercurio ha come prima conseguenza disturbi neurologici, in alcuni paesi esiste il modo di dire «matto come un cappellaio»: da questa espressione deriva anche il nome del personaggio di «Alice nel Paese delle Meraviglie», il Cappellaio Matto.<br />","atomic_mass":200,"oxidation_numbers":"+1 +2","melting_temperature":234,"boiling_temperature":630,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>1</sup><sup>0</sup>6s<sup>2</sup>","standard_physical_state":"Liquido","atomic_radius":150,"first_ionisation_energy":1007,"electronegativity":1,"electronic_affinity":"/","density":"13,6 g/mL","discovery_year":"Noto fin dall’antichità"},{"name":"Tallio","number":81,"color":"0x7d933a","group":"postmetal","symbol":"Tl","image_url":"tallio.jpg","image_description":"Uno dei principi attivi di diserbanti, insetticidi e topicidi comunemente utilizzati in agricoltura è il tallio.","more_text":"","atomic_mass":204,"oxidation_numbers":"+1 +3","melting_temperature":577,"boiling_temperature":1746,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>1</sup><sup>0</sup>6s<sup>2</sup>6p<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":170,"first_ionisation_energy":589,"electronegativity":2,"electronic_affinity":0,"density":"11,8 g/mL","discovery_year":1861},{"name":"Piombo","number":82,"color":"0x7d933a","group":"postmetal","symbol":"Pb","image_url":"piombo.jpg","image_description":"Il piombo veniva utilizzato in epoca romana per realizzare le tubature degli acquedotti.","more_text":"<h1>Biologia</h1>Nonostante le emissioni di piombo comportino un rischio per la salute molto alto, questo metallo è stato ampiamente utilizzato e disperso nell’ambiente. L’esposizione ad alte concentrazioni di piombo può danneggiare i globuli rossi, il sistema nervoso, la pelle e l’apparato riproduttivo. Un’esposizione lieve ma continua può invece causare gravi problemi nei bambini, come ritardi mentali e di crescita.<br /><br /><h1>Scienze della Terra</h1>Il piombo presenta una struttura cubica a facce centrate. Talvolta si trova in natura allo stato elementare, ma più spesso si ricava da minerali come la galena, l’anglesite, la cerussite e il minio; rappresenta solo lo 0,0013% della crosta terrestre, ma non viene considerato raro perché si estrae molto facilmente. La maggior parte del piombo si ottiene esponendo la galena ad aria calda, ma negli Stati Uniti quasi un terzo proviene dal riciclaggio di piombo usato.<br /><br /><h1>Astronomia</h1>Il piombo è uno dei prodotti finali del processo di nucleosintesi che si realizza all\'interno dei nuclei delle stelle di grande massa, durante le fasi finali della loro vita. In particolare, la sintesi del piombo si verifica mediante un processo definito «cattura lenta di neutroni».<br />Sul pianeta Venere, caratterizzato da una atmosfera con livelli altissimi di temperatura e pressione, si ipotizza che il piombo si depositi, sotto forma di solfuro di zolfo, come «neve» sulle montagne venusiane.<br /> <br /><h1>Storia</h1>Il piombo ha avuto un ruolo importante nel progresso di molte civiltà; benché non utilizzato per la realizzazione di monili e gioielli a causa della sua opacità e limitata durezza, fu tuttavia impiegato, vista la sua resistenza alla corrosione ed elevata duttilità, per la costruzione di manufatti idraulici, edifici e navi. A causa del suo basso punto di fusione, poteva infatti essere facilmente saldato e impiegato come componente di base in diverse leghe metalliche.<br />Venne impiegato come supporto per la scrittura dai Babilonesi, mentre i Romani lo utilizzavano per realizzare tubature; era frequente l\'uso come copertura dei tetti dei palazzi.<br />Il piombo è stato spesso utilizzato dai popoli antichi anche per la produzione di cosmetici che, viste le caratteristiche tossiche del metallo, risultavano dotati di proprietà antisettiche e disinfettanti, ma comunque dannose per chi ne faceva uso per lunghi periodi.<br /><br /><h1>Utilizzo</h1>Il piombo è molto tenero e duttile, ha una densità piuttosto alta ed è un cattivo conduttore di elettricità. Viene usato in tutti quei casi in cui è necessario un metallo tenero ed economico: quindi in batterie, lapis, pesi, cartucce e alcune produzioni artistiche.<br />I composti del piombo sono usati come additivi nella produzione del vetro, della gomma e dei fuochi di artificio e, fino a poco tempo fa, delle vernici. Significativo fu l\'impiego, fino agli anni Ottanta, del piombo tetraetile come antidetonante nelle benzine, che portò al rilascio di notevoli quantità di questo metallo nell\'atmosfera. Grazie alla sua elevata densità, il piombo è in grado di bloccare i raggi X e viene pertanto impiegato per la costruzione di schermature antiradiazioni.<br />","atomic_mass":207,"oxidation_numbers":"+2 +4","melting_temperature":601,"boiling_temperature":2013,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>1</sup><sup>0</sup>6s<sup>2</sup>6p<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":175,"first_ionisation_energy":716,"electronegativity":2,"electronic_affinity":0,"density":"11,4 g/mL","discovery_year":"Noto fin dall’antichità"},{"name":"Bismuto","number":83,"color":"0x7d933a","group":"postmetal","symbol":"Bi","image_url":"bismuto.jpg","image_description":"L’industria cosmetica fa ampio uso del bismuto come eccipiente nella preparazione di creme e make-up.","more_text":"","atomic_mass":209,"oxidation_numbers":"+3 +5","melting_temperature":545,"boiling_temperature":1833,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>1</sup><sup>0</sup>6s<sup>2</sup>6p<sup>3</sup>","standard_physical_state":"Solido","atomic_radius":155,"first_ionisation_energy":703,"electronegativity":2,"electronic_affinity":0,"density":"9,8 g/mL","discovery_year":1753},{"name":"Polonio","number":84,"color":"0x90aa24","group":"semimetal","symbol":"Po","image_url":"polonio.jpg","image_description":"FORTEMENTE RADIOATTIVO. È impiegato nella preparazione di sorgenti di neutroni in campo bellico e industriale.","more_text":"","atomic_mass":"[209]","oxidation_numbers":"+2 +4 +6","melting_temperature":527,"boiling_temperature":1235,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>1</sup><sup>0</sup>6s<sup>2</sup>6p<sup>4</sup>","standard_physical_state":"Solido","atomic_radius":118,"first_ionisation_energy":812,"electronegativity":2,"electronic_affinity":1,"density":"9,2 g/mL","discovery_year":1898},{"name":"Astato","number":85,"color":"0xbcb891","group":"alogeni","symbol":"At","image_url":"astato.jpg","image_description":"RADIOATTIVO. Prodotto dal decadimento radioattivo di nuclei più pesanti, ha vita brevissima e tale da non consentire alcuna applicazione. È tra gli elementi più rari del pianeta.","more_text":"","atomic_mass":"[210]","oxidation_numbers":"±1 +3 +5 +7","melting_temperature":575,"boiling_temperature":610,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>1</sup><sup>0</sup>6s<sup>2</sup>6p<sup>5</sup>","standard_physical_state":"Solido","atomic_radius":127,"first_ionisation_energy":930,"electronegativity":2,"electronic_affinity":2,"density":6,"discovery_year":1940},{"name":"Radon","number":86,"color":"0xadccdc","group":"gas","symbol":"Rn","image_url":"radon.jpg","image_description":"RADIOATTIVO. Variazioni di concentrazione di questo gas radioattivo nell\'atmosfera sono state riscontrate in occasione di eventi sismici.","more_text":"<h1>Biologia</h1>Il radon è un gas radioattivo che decade emettendo particelle alfa: l\'inalazione di questo gas comporta quindi l\'inserimento nell\'apparato respiratorio di radionuclidi che si depositano nei tessuti continuando ad emettere radiazioni. Gli scienziati ritengono che sia la seconda causa di tumore al polmone dopo il fumo di sigaretta. Il radon viene generato continuamente da alcune rocce della crosta terrestre a seguito del decadimento di radionuclidi più pesanti. Può essere trasportato dalle falde acquifere e giungere, seguendo fessure e infiltrazioni, nei piani interrati delle abitazioni, dove può concentrarsi in quantità pericolose per la salute umana.<br /><br /><h1>Scienze della Terra</h1>Il radon è un prodotto del decadimento alfa di torio-232, uranio-235 e uranio-238, frequentemente contenuti in rocce magmatiche quali il granito e il tufo. Diversi studi compiuti in zone soggette a rischio sismico hanno dimostrato che anomalie nella concentrazione di radon nel sottosuolo o nelle acque sotterranee sono correlate agli eventi sismici. Lo studio delle variazioni delle concentrazioni di radon appare quindi come uno strumento che offre interessanti prospettive per la previsione dei terremoti anche se, attualmente, i modelli a disposizione non appaiono sufficientemente affidabili.<br /><br /><h1>Astronomia</h1>Per verificare l\'eventuale presenza di uranio sulla Luna, alcune missioni spaziali hanno cercato, nella rarefatta atmosfera lunare, il prodotto del suo decadimento, cioè il radon. Il gas è stato effettivamente trovato vicino al cratere Aristarco, considerato uno dei crateri lunari di formazione più recente; la zona circostante include anche una valle vulcanica, che potrebbe avere espulso il radon. Sulla faccia nascosta della Luna, invece, non è stata riscontrata alcuna presenza di radon a causa dell’eccezionale spessore della crosta che ha sempre impedito l’attività vulcanica, perfino nei periodi più violenti della storia geologica della Luna.<br /><br /><h1>Storia</h1>Il radon è stato scoperto per caso nel 1900 dal fisico tedesco F. E. Dorn; analizzando le radiazioni emesse dal radio, che segue l\'elemente di due caselle nella tavola periodica, notò che l’aria intorno a un campione di questo elemento diventava radioattiva. Ne dedusse che dal decadimento dal radio si formava un gas radioattivo che diffondeva nell’aria e ipotizzò che si trattasse di un nuovo elemento.<br />Tuttavia, anche se sconosciuto, il radon provocava tragici effetti sulla salute dei minatori fin dall\'antichità; fin dal sedicesimo secolo, le cronache riportano alti tassi di mortalità nei minatori della Boemia e della Sassonia. Alla fine degli anni Trenta, accurate indagini permisero di riscontrare elevate concentrazioni di radon nell\'aria di tali miniere.<br /><br /><h1>Utilizzo</h1>A parte qualche suo impiego in radioterapia e il possibile futuro utilizzo nella previsione dei sismi, il radon non ha, vista la sua pericolosità, altre applicazioni pratiche.<br />","atomic_mass":"[222]","oxidation_numbers":"/","melting_temperature":202,"boiling_temperature":211,"electronic_configuration":"[Xe]4f<sup>1</sup><sup>4</sup>5d<sup>1</sup><sup>0</sup>6s<sup>2</sup>6p<sup>6</sup>","standard_physical_state":"Gas","atomic_radius":120,"first_ionisation_energy":1037,"electronegativity":"/","electronic_affinity":0,"density":"9,72 g/L","discovery_year":1900},{"name":"Francio","number":87,"color":"0xca6b18","group":"metal","symbol":"Fr","image_url":"francio.jpg","image_description":"RADIOATTIVO. Prodotto dal decadimento radioattivo di nuclei più pesanti, è l\'elemento con vita più breve.","more_text":"","atomic_mass":"[223]","oxidation_numbers":"+1","melting_temperature":300,"boiling_temperature":950,"electronic_configuration":"[Rn]7s<sup>1</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":380,"electronegativity":0,"electronic_affinity":0,"density":"1,00 g/mL","discovery_year":1939},{"name":"Radio","number":88,"color":"0xffedbc","group":"metalc","symbol":"Ra","image_url":"radio.jpg","image_description":"RADIOATTIVO. È utilizzato come fonte di radon, impiegato in campo medico.","more_text":"","atomic_mass":"[226]","oxidation_numbers":"+2","melting_temperature":973,"boiling_temperature":1413,"electronic_configuration":"[Rn]7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":215,"first_ionisation_energy":509,"electronegativity":0,"electronic_affinity":"/","density":"5,00 g/mL","discovery_year":1898},{"name":"Attinio","number":89,"color":"0x8ba2ae","group":"attinidi","symbol":"Ac","image_url":"attinio.jpg","image_description":"RADIOATTIVO. A causa della sua intensa radioattività è utilizzato in campo medico e industriale.","more_text":"","atomic_mass":"[227]","oxidation_numbers":"+3","melting_temperature":1324,"boiling_temperature":3432,"electronic_configuration":"[Rn]6d<sup>1</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":188,"first_ionisation_energy":499,"electronegativity":1,"electronic_affinity":"/","density":"10,10 g/mL","discovery_year":1899},{"name":"Torio","number":90,"color":"0x8ba2ae","group":"attinidi","symbol":"Th","image_url":"torio.jpg","image_description":"RADIOATTIVO. Sono in corso studi sul suo utilizzo come combustibile in centrali nucleari di nuova generazione. La fissione del torio richiederebbe temperature inferiori e produrrebbe scorie con emivita più breve degli attuali combustibili.","more_text":"","atomic_mass":232,"oxidation_numbers":"+4","melting_temperature":2023,"boiling_temperature":5061,"electronic_configuration":"[Rn]6d<sup>2</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":180,"first_ionisation_energy":587,"electronegativity":1,"electronic_affinity":"/","density":"11,7 g/mL","discovery_year":1828},{"name":"Protoattinio","number":91,"color":"0x8ba2ae","group":"attinidi","symbol":"Pa","image_url":"protoattinio.jpg","image_description":"RADIOATTIVO. A causa della sua scarsità e tossicità, questo elemento non ha attualmente applicazioni industriali.","more_text":"","atomic_mass":231,"oxidation_numbers":"+4 +5","melting_temperature":1845,"boiling_temperature":4300,"electronic_configuration":"[Rn]5f<sup>2</sup>6d<sup>1</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":161,"first_ionisation_energy":568,"electronegativity":1,"electronic_affinity":"/","density":"15,4 g/mL","discovery_year":1913},{"name":"Uranio","number":92,"color":"0x8ba2ae","group":"attinidi","symbol":"U","image_url":"uranio.jpg","image_description":"RADIOATTIVO. Il suo isotopo 235 è il combustibile nucleare maggiormente utilizzato nelle centrali.","more_text":"<h1>Biologia</h1>L\'uranio e i suoi composti sono cancerogeni e altamente tossici. È un elemento radioattivo che, decadendo, si trasforma in altri isotopi radioattivi. L\'uranio può penetrare in un organismo attraverso inalazione del suo ossido, diffondendo nei liquidi delle mucose del sistema respiratorio ed entrando nel sangue; viene espulso con le urine, ma la parte non eliminata si fissa nelle ossa e si concentra nei reni.<br />Fissato all\'interno dell\'organismo, l\'uranio continua ad irraggiare i tessuti con effetti particolarmente pesanti sul midollo osseo.<br /><br /><h1>Scienze della Terra</h1>Nei suoi minerali lo si ritrova essenzialmente come U-238, anche se raro (3 ppm nella crosta terrestre) risulta ben distribuito in numerose rocce magmatiche, formando diversi tipi di minerali, tra cui il più conosciuto e il più sfruttato è la pechblenda.<br />I principali giacimenti si trovano negli Stati Uniti e in Australia.<br /><br /><h1>Storia</h1>L’uranio è stato scoperto nel 1789 dal chimico tedesco Klaproth studiando il minerale pechblenda, che era ritenuta una miscela di zinco e ferro. Klaproth vi scoprì la presenza anche di un altro elemento, che chiamò «uranio» in onore del pianeta Urano, scoperto solo otto anni prima.<br />Circa cinquant’anni più tardi, nel 1841, Péligot riuscì a isolare l’uranio elementare, che apparve come un metallo scuro, scaldando la pechblenda in presenza di potassio e platino. Nessuno dei due scienziati sospettava la radioattività di questo elemento, che fu determinata solo a fine Ottocento da Becquerel.<br /><br /><h1>Utilizzo</h1>L\'uranio, insieme al plutonio, è l\'elemento maggiormente utilizzato nelle reazioni di fissione nucleare. In tali reazioni, che ricavano energia dalla rottura di un isotopo fissile in due isotopi più leggeri, viene impiegato uranio 235 che è però solo lo 0,7% dell\'uranio ricavabile dall\'estrazione mineraria. Per disporre di grandi quantità di U-235 si procede, pertanto, al cosiddetto «arricchimento» dell\'uranio, che aumenta la percentuale di U-235 fino al 20%. I residui di questo processo costituiscono l\'uranio impoverito, materiale comunque radioattivo, impiegato, in considerazione della sua elevata densità, nella costruzione di proiettili ad alto grado di penetrazione. L\'uranio 235 è stato anche utilizzato come materiale fissile nella bomba atomica sganciata dagli Stati Uniti su Hiroshima il 6 agosto 1945, che causò la morte istantanea di oltre 100 000 civili.<br />","atomic_mass":238,"oxidation_numbers":"+3 +4 +5 +6","melting_temperature":1408,"boiling_temperature":4404,"electronic_configuration":"[Rn]5f<sup>3</sup>6d<sup>1</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":139,"first_ionisation_energy":584,"electronegativity":1,"electronic_affinity":"/","density":"19,0 g/mL","discovery_year":1789},{"name":"Nettunio","number":93,"color":"0x8ba2ae","group":"attinidi","symbol":"Np","image_url":"nettunio.jpg","image_description":"RADIOATTIVO. È un sottoprodotto delle reazioni nucleari di fissione.","more_text":"","atomic_mass":"[237]","oxidation_numbers":"+3 +4 +5 +6","melting_temperature":913,"boiling_temperature":4175,"electronic_configuration":"[Rn]5f<sup>4</sup>6d<sup>1</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":175,"first_ionisation_energy":597,"electronegativity":1,"electronic_affinity":"/","density":"20,4 g/mL","discovery_year":1940},{"name":"Plutonio","number":94,"color":"0x8ba2ae","group":"attinidi","symbol":"Pu","image_url":"plutonio.jpg","image_description":"RADIOATTIVO. È l\'elemento oggi maggiormente utilizzato per la produzione di armi nucleari.","more_text":"","atomic_mass":"[244]","oxidation_numbers":"+3 +4 +5 +6","melting_temperature":914,"boiling_temperature":3501,"electronic_configuration":"[Rn]5f<sup>6</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":151,"first_ionisation_energy":585,"electronegativity":1,"electronic_affinity":"/","density":"19,7 g/mL","discovery_year":1940},{"name":"Americio","number":95,"color":"0x8ba2ae","group":"attinidi","symbol":"Am","image_url":"americio.jpg","image_description":"RADIOATTIVO. Il suo isotopo 241 è impiegato come sorgente di radiazioni ionizzanti e di neutroni.","more_text":"","atomic_mass":"[243]","oxidation_numbers":"+3 +4 +5 +6","melting_temperature":1449,"boiling_temperature":2284,"electronic_configuration":"[Rn]5f<sup>7</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":131,"first_ionisation_energy":579,"electronegativity":1,"electronic_affinity":"/","density":"13,7 g/mL","discovery_year":1944},{"name":"Curio","number":96,"color":"0x8ba2ae","group":"attinidi","symbol":"Cm","image_url":"curio.jpg","image_description":"RADIOATTIVO. Alcuni isotopi sono utilizzati in campo spaziale come generatori di energia.","more_text":"","atomic_mass":"[247]","oxidation_numbers":"+3","melting_temperature":1618,"boiling_temperature":3383,"electronic_configuration":"[Rn]5f<sup>7</sup>6d<sup>1</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":581,"electronegativity":1,"electronic_affinity":"/","density":"13,5 g/mL","discovery_year":1944},{"name":"Berkelio","number":97,"color":"0x8ba2ae","group":"attinidi","symbol":"Bk","image_url":"berkelio.jpg","image_description":"RADIOATTIVO. L\'elemento non si trova nella crosta terrestre e viene ottenuto bombardando l\'americio con particelle alfa.","more_text":"","atomic_mass":"[247]","oxidation_numbers":"+3 +4","melting_temperature":1259,"boiling_temperature":2900,"electronic_configuration":"[Rn]5f<sup>9</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":601,"electronegativity":1,"electronic_affinity":"/","density":"14,8 g/mL","discovery_year":1949},{"name":"Californio","number":98,"color":"0x8ba2ae","group":"attinidi","symbol":"Cf","image_url":"californio.jpg","image_description":"RADIOATTIVO. È uno dei pochi elementi transuranici che ha trovato applicazioni in campo medico e come fonte di neutroni nelle centrali nucleari.","more_text":"","atomic_mass":"[251]","oxidation_numbers":"+3","melting_temperature":1175,"boiling_temperature":1743,"electronic_configuration":"[Rn]5f<sup>1</sup><sup>0</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":608,"electronegativity":1,"electronic_affinity":"/","density":"15,1 g/mL","discovery_year":1950},{"name":"Einsteinio","number":99,"color":"0x8ba2ae","group":"attinidi","symbol":"Es","image_url":"einsteinio.jpg","image_description":"RADIOATTIVO. Fu identificato nelle scorie dell\'esplosione della prima bomba a fusione termonucleare.","more_text":"","atomic_mass":"[252]","oxidation_numbers":"+3","melting_temperature":1133,"boiling_temperature":1269,"electronic_configuration":"[Rn]5f<sup>1</sup><sup>1</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":619,"electronegativity":1,"electronic_affinity":"/","density":"13,5 g/mL","discovery_year":1952},{"name":"Fermio","number":100,"color":"0x8ba2ae","group":"attinidi","symbol":"Fm","image_url":"fermio.jpg","image_description":"RADIOATTIVO. È l\'unico elemento della tavola periodica dedicato a un italiano, il fisico Enrico Fermi (1901-1954).","more_text":"","atomic_mass":"[257]","oxidation_numbers":"+3","melting_temperature":1800,"boiling_temperature":"/","electronic_configuration":"[Rn]5f<sup>1</sup><sup>2</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":627,"electronegativity":1,"electronic_affinity":"/","density":"/","discovery_year":1952},{"name":"Mendelevio","number":101,"color":"0x8ba2ae","group":"attinidi","symbol":"Md","image_url":"mendelevio.jpg","image_description":"RADIOATTIVO. È ottenuto tramite bombardamento dell\'einstenio con particelle alfa.","more_text":"","atomic_mass":"[258]","oxidation_numbers":"+2 +3","melting_temperature":1100,"boiling_temperature":"/","electronic_configuration":"[Rn]5f<sup>1</sup><sup>3</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":637,"electronegativity":1,"electronic_affinity":"/","density":"/","discovery_year":1955},{"name":"Nobelio","number":102,"color":"0x8ba2ae","group":"attinidi","symbol":"No","image_url":"nobelio.jpg","image_description":"RADIOATTIVO. Gli elementi transfermici, come il nobelio, non esistono in natura e hanno un nucleo molto instabile, quindi sono molto difficili da sintetizzare.","more_text":"","atomic_mass":"[259]","oxidation_numbers":"+2 +3","melting_temperature":1100,"boiling_temperature":"/","electronic_configuration":"[Rn]5f<sup>1</sup><sup>4</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":642,"electronegativity":1,"electronic_affinity":"/","density":"/","discovery_year":1958},{"name":"Laurenzio","number":103,"color":"0x8ba2ae","group":"attinidi","symbol":"Lr","image_url":"laurenzio.jpg","image_description":"RADIOATTIVO. Il laurenzio viene sintetizzato a partire dal californio e non ha applicazioni pratiche.","more_text":"","atomic_mass":"[262]","oxidation_numbers":"+3","melting_temperature":1900,"boiling_temperature":"/","electronic_configuration":"[Rn]5f<sup>1</sup><sup>4</sup>6d<sup>1</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":"/","electronegativity":1,"electronic_affinity":"/","density":"/","discovery_year":1961},{"name":"Rutherfordio","number":104,"color":"0xe1cac8","group":"metald","symbol":"Rf","image_url":"rutherfordio.jpg","image_description":"RADIOATTIVO. Il suo isotopo più stabile ha una emivita di soli 70 secondi; poco si conosce quindi delle caratteristiche di questo elemento.","more_text":"","atomic_mass":"[261]","oxidation_numbers":"+4","melting_temperature":2400,"boiling_temperature":"/","electronic_configuration":"[Rn]5f<sup>1</sup><sup>4</sup>6d<sup>2</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":409,"electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":1974},{"name":"Dubnio","number":105,"color":"0xe1cac8","group":"metald","symbol":"Db","image_url":"dubnio.jpg","image_description":"RADIOATTIVO. Il suo isotopo più stabile ha una emivita di soli 40 secondi; poco si conosce quindi delle caratterstiche di questo elemento.","more_text":"","atomic_mass":"[262]","oxidation_numbers":"sconosciuti","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"[Rn]5f<sup>1</sup><sup>4</sup>6d<sup>3</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":640,"electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":1964},{"name":"Seaborgio","number":106,"color":"0xe1cac8","group":"metald","symbol":"Sg","image_url":"seaborgio.jpg","image_description":"RADIOATTIVO. Come altri elementi sintetici di questo periodo, che decadono in tempi molto brevi, anche del seaborgio si hanno scarse conoscenze.","more_text":"","atomic_mass":"[266]","oxidation_numbers":"/","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"[Rn]5f<sup>1</sup><sup>4</sup>6d<sup>4</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":730,"electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":1974},{"name":"Bohrio","number":107,"color":"0xe1cac8","group":"metald","symbol":"Bh","image_url":"bohrio.jpg","image_description":"RADIOATTIVO. L\'isotopo più stabile di questo elemento sintetico decade in un solo minuto.","more_text":"","atomic_mass":"[264]","oxidation_numbers":"/","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"[Rn]5f<sup>1</sup><sup>4</sup>6d<sup>5</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":660,"electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":1976},{"name":"Assio","number":108,"color":"0xe1cac8","group":"metald","symbol":"Hs","image_url":"assio.jpg","image_description":"RADIOATTIVO. Il nome di questo elemento è stato assegnato nel 1997.","more_text":"","atomic_mass":"[265]","oxidation_numbers":"/","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"[Rn]5f<sup>1</sup><sup>4</sup>6d<sup>6</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":840,"electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":1984},{"name":"Meitnerio","number":109,"color":"0xe1cac8","group":"metald","symbol":"Mt","image_url":"meitnerio.jpg","image_description":"RADIOATTIVO. L\'isotopo più stabile di questo elemento ha una emivita di 3,4 millisecondi.","more_text":"","atomic_mass":"[268]","oxidation_numbers":"/","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"[Rn]5f<sup>1</sup><sup>4</sup>6d<sup>7</sup>7s<sup>2</sup>","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":840,"electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":1982},{"name":"Darmstadtio","number":110,"color":"0xe1cac8","group":"metald","symbol":"Ds","image_url":"darmstadtio.jpg","image_description":"RADIOATTIVO. Benché decada in pochi millisecondi è da considerarsi uno degli elementi più pesanti.","more_text":"","atomic_mass":"[271]","oxidation_numbers":"/","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"/","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":"/","electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":1994},{"name":"Roentgenio","number":111,"color":"0xe1cac8","group":"metald","symbol":"Rg","image_url":"roentgenio.jpg","image_description":"RADIOATTIVO. È da considerarsi uno degli atomi più pesanti. Il suo nome è stato assegnato nel 2004.","more_text":"","atomic_mass":"[272]","oxidation_numbers":"/","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"/","standard_physical_state":"Solido","atomic_radius":"/","first_ionisation_energy":"/","electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":1994},{"name":"Copernicio","number":112,"color":"0xe1cac8","group":"metald","symbol":"Cn","image_url":"copernicio.jpg","image_description":"RADIOATTIVO. Scoperto nel 1996, il nome copernicio è stato assegnato a questo elemento nel 2010.","more_text":"","atomic_mass":"[277]","oxidation_numbers":"/","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"/","standard_physical_state":"Liquido","atomic_radius":"/","first_ionisation_energy":"/","electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":1996},{"name":"Nihonio","number":113,"color":"0xe5e5e5","group":"unkown","symbol":"Nh","image_url":"ununtrio.jpg","image_description":"","more_text":"","atomic_mass":"/","oxidation_numbers":"/","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"/","standard_physical_state":"/","atomic_radius":"/","first_ionisation_energy":"/","electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":"/"},{"name":"Flerovio","number":114,"color":"0xe5e5e5","group":"unkown","symbol":"Fl","image_url":"flerovio.jpg","image_description":"","more_text":"","atomic_mass":"/","oxidation_numbers":"/","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"/","standard_physical_state":"/","atomic_radius":"/","first_ionisation_energy":"/","electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":"/"},{"name":"Moscovio","number":115,"color":"0xe5e5e5","group":"unkown","symbol":"Mc","image_url":"ununpentio.jpg","image_description":"","more_text":"","atomic_mass":"/","oxidation_numbers":"/","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"/","standard_physical_state":"/","atomic_radius":"/","first_ionisation_energy":"/","electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":"/"},{"name":"Livermorio","number":116,"color":"0xe5e5e5","group":"unkown","symbol":"Lv","image_url":"livermorio.jpg","image_description":"","more_text":"","atomic_mass":"/","oxidation_numbers":"/","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"/","standard_physical_state":"/","atomic_radius":"/","first_ionisation_energy":"/","electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":"/"},{"name":"Tennessinio","number":117,"color":"0xe5e5e5","group":"unkown","symbol":"Ts","image_url":"ununseptio.jpg","image_description":"","more_text":"","atomic_mass":"/","oxidation_numbers":"/","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"/","standard_physical_state":"/","atomic_radius":"/","first_ionisation_energy":"/","electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":"/"},{"name":"Oganessio","number":118,"color":"0xe5e5e5","group":"unkown","symbol":"Og","image_url":"ununoctio.jpg","image_description":"","more_text":"","atomic_mass":"/","oxidation_numbers":"/","melting_temperature":"/","boiling_temperature":"/","electronic_configuration":"/","standard_physical_state":"/","atomic_radius":"/","first_ionisation_energy":"/","electronegativity":"/","electronic_affinity":"/","density":"/","discovery_year":"/"}]');